#!/bin/csh -f
# Script to run the program unres (serial version).
#
if ($#argv<2) then
  echo "USAGE: unres_clust.csh INPUT INTIN [OUTPUT]"
  exit (1)
endif

set BIN = /people2/adam/PROTARCH/CLUSTER/bin
setenv INPUT $1
setenv INTIN $2
if ($#argv<3) then
  setenv OUTPUT $2
else
  setenv OUTPUT $3
endif

# Check for the existence of the input file

if (!(-e $1.inp)) then
  echo "Error: The input file $1.inp does not exist."
  exit(1)
endif

if (!(-e $2.int)) then
  echo "Error: The input internal coordinate file $2.int does not exist."
  exit(1)
endif

#gdb -d /people2/adam/PROTARCH/CLUSTER/src ${BIN}/unres_clust
time ${BIN}/unres_clust

# Clear empty files
find . -size 0 -exec rm {} \;
