      subroutine initialize
C 
C Define constants and zero out tables.
C
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.TORSION'
      include 'COMMON.FFIELD'
      include 'COMMON.SBRIDGE'
      include 'COMMON.MCM'
      include 'COMMON.MINIM' 
      include 'COMMON.DERIV'
C
C The following is just to define auxiliary variables used in angle conversion
C
      pi=4.0D0*datan(1.0D0)
      dwapi=2.0D0*pi
      dwapi3=pi/3.0D0
      pipol=0.5D0*pi
      deg2rad=pi/180.0D0
      rad2deg=1.0D0/deg2rad
      angmin=10.0D0*deg2rad
C Assign virtual-bond length
      vbl=3.8D0
      vblinv=1.0D0/vbl
      vblinv2=vblinv*vblinv
C
C Define I/O units.
C
      inp=    1
      iout=   2
      ipdbin= 3
      ipdb=   7
      igeom=  8
      intin=  9
      istat= 17
      imol2= 18
      jplot= 19
C
C Zero out tables.
C
      do i=1,maxres2
	do j=1,3
	  c(j,i)=0.0D0
	  dc(j,i)=0.0D0
        enddo
      enddo
      do i=1,maxres
	do j=1,3
	  xloc(j,i)=0.0D0
        enddo
      enddo
C Initialize the bridge arrays
      ns=0
      nss=0 
      nhpb=0
      do i=1,maxss
	iss(i)=0
      enddo
      do i=1,maxdim
	dhpb(i)=0.0D0
      enddo
      do i=1,maxres
	ihpb(i)=0
	jhpb(i)=0
      enddo
C
C Initialize timing.
C
      call set_timers
      return
      end
c-------------------------------------------------------------------------
      block data 
      include 'DIMENSIONS'
      include 'COMMON.NAMES'
      include 'COMMON.FFIELD'
      data restyp /
     &'CYS','MET','PHE','ILE','LEU','VAL','TRP','TYR','ALA','GLY','THR',
     &'SER','GLN','ASN','GLU','ASP','HIS','ARG','LYS','PRO','D'/
      data onelet /
     &'C','M','F','I','L','V','W','Y','A','G','T',
     &'S','Q','N','E','D','H','R','K','P','X'/
      data potname /'LJ','LJK','BP','GB','GBV'/
      end 
