C
C Program to cluster united-residue MCM results.
C
      include 'DIMENSIONS'
      include 'sizesclu.dat'
      include 'COMMON.TIME1'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.HEADER'
      include 'COMMON.CONTROL'
      include 'COMMON.CONTACTS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.CLUSTER'
      include 'COMMON.IOUNITS'
      logical printang(max_cut)
      integer printpdb(max_cut)
      integer printmol2(max_cut)
      
      double precision varia(maxvar)
      double precision hrtime,mintime,sectime
      logical eof
c      ICANT(I,J)=((NCON+NCON-J)*(J-1))/2+I-J

      call initialize
      call openunits
      call read_control
      call molread
      do i=1,nres
        phi(i)=0.0D0
        theta(i)=0.0D0
        alph(i)=0.0D0
        omeg(i)=0.0D0
      enddo

      print *,'MAIN: nnt=',nnt,' nct=',nct

      DO I=1,NCUT
        PRINTANG(I)=.FALSE.
        PRINTPDB(I)=0
        printmol2(i)=0
        IF (RCUTOFF(I).LT.0.0) THEN
          RCUTOFF(I)=ABS(RCUTOFF(I))
          PRINTANG(I)=.TRUE.
          PRINTPDB(I)=outpdb
          printmol2(i)=outmol2
        ENDIF
      ENDDO
      PRINT *,'Number of cutoffs:',NCUT
      PRINT *,'Cutoff values:'
      DO ICUT=1,NCUT
        PRINT '(8HRCUTOFF(,I2,2H)=,F8.1,2i2)',ICUT,RCUTOFF(ICUT),
     &    printpdb(i),printmol2(i)
      ENDDO
      DO I=1,NRES-3  
        MULT(I)=1
      ENDDO
      ICON=1
  123 READ (intin,'(I5,F10.5,I2)',END=13,ERR=13) IC,ENERGY(ICON),NSS
      IF (NSS.GT.9) READ (intin,'(3X,11(1X,2I3))',END=13,ERR=13) 
     1                                     (II,JJ,I=10,NSS)
      PRINT *,'IC:',IC,' ENERGY:',ENERGY(ICON)
      call read_angles(intin,*13)
      do i=1,nres
        phiall(i,icon)=phi(i)
        thetall(i,icon)=theta(i)
        alphall(i,icon)=alph(i)
        omall(i,icon)=omeg(i)
      enddo
      ICON=ICON+1
      GOTO 123
C      
C CALCULATE DISTANCES
C
   13 NCON=ICON-1
      DO I=1,NCON
        ICC(I)=I
      ENDDO
      WRITE (iout,'(A80)') TITEL
      t1=tcpu()
      DO I=1,NCON
        print *,'Calculating RMS i=',i
        do ii=1,nres
          phi(ii)=phiall(ii,i)
          theta(ii)=thetall(ii,i)
          alph(ii)=alphall(ii,i)
          omeg(ii)=omall(ii,i)
        enddo
        call chainbuild
        do ii=1,nres
          do jj=1,3
            cref(jj,ii)=c(jj,ii)
          enddo
        enddo
        DO J=I+1,NCON
          ATTALUMS(ICANT(J,I))=DIFCONF(I,J)
cd        write (iout,'(2i4,f10.5)') i,j,ATTALUMS(ICANT(J,I))
        ENDDO
      ENDDO
      t2=tcpu()
      WRITE (iout,'(/a,1pe14.5,a/)') 
     & 'Time for distance calculation:',T2-T1,' sec.'
      t1=tcpu()
      PRINT '(a)','End of distance computation'

      if (punch_dist) then
        do i=1,ncon
          do j=i+1,ncon
            write (jrms,'(2i5,2f10.5)') i,j,attalums(icant(i,j)),
     &        energy(j)-energy(i)
          enddo
        enddo
      endif
C
C Print out the RMS deviation matrix.
C
      CALL DISTOUT(NCON)

      IF (MIN_VAR) THEN
C
C Minimum-variance clustering.
C
        CALL MINVAR(NCON,PRINTANG,PRINTPDB,PRINTMOL2)
C
      ELSE IF (TREE) THEN
C
C Minimal-spanning tree clustering with sorting the distance matrix.
C
        CALL CLUSTMAZ(NCON,PRINTANG,PRINTPDB,printmol2)
C
      ELSE
C
C Minimal-spanning tree clustering without sorting the distance matrix.
C
        CALL CLUSTER(NCON,PRINTANG,PRINTPDB,PRINTMOL2)
C
      ENDIF
      t2=tcpu()
      WRITE (iout,'(/a,1pe14.5,a/)') 
     & 'Total time for clustering:',T2-T1,' sec.'
C
      stop '********** Program terminated normally.'
      end
c---------------------------------------------------------------------------
      double precision function difconf(icon,jcon)
      include 'DIMENSIONS'
      include 'sizesclu.dat'
      include 'COMMON.CLUSTER'
      include 'COMMON.CHAIN' 
      include 'COMMON.INTERACT'
      include 'COMMON.VAR'
      double precision przes(3),obrot(3,3)
      do i=1,nres
        phi(i)=phiall(i,jcon)
        theta(i)=thetall(i,jcon)
        alph(i)=alphall(i,jcon)
        omeg(i)=omall(i,jcon)
      enddo
      call chainbuild
c     do i=1,nres
c       print '(i4,2(3f10.5,5x))',i,(cref(j,i),j=1,3),(c(j,i),j=1,3)
c     enddo
      call fitsq(rms,c(1,nnt),cref(1,nnt),nct-nnt+1,przes,obrot) 
      difconf=dsqrt(rms)
      RETURN
      END
C------------------------------------------------------------------------------
      subroutine distout(ncon)
      include 'DIMENSIONS'
      include 'sizesclu.dat'
      parameter (ncol=10)
      include 'COMMON.IOUNITS'
      include 'COMMON.CLUSTER'
      dimension b(ncol)
c      icant(i,j)=((ncon+ncon-j)*(j-1))/2+i-j
      write (iout,'(a)') 'The distance matrix'
      do 1 i=1,ncon,ncol
      nlim=min0(i+ncol-1,ncon)
      write (iout,1000) (k,k=i,nlim)
      write (iout,'(8h--------,10a)') ('-------',k=i,nlim)
 1000 format (/8x,10(i4,3x))
 1020 format (/1x,80(1h-)/)
      do 2 j=i,ncon
      jlim=min0(j,nlim)
      if (jlim.eq.j) then
        b(jlim-i+1)=0.0d0
        jlim1=jlim-1
      else
        jlim1=jlim
      endif
      do 3 k=i,jlim1
    3 b(k-i+1)=attalums(icant(k,j))
      write (iout,1010) j,(b(k),k=1,jlim-i+1)
    2 continue
    1 continue
 1010 format (i5,3x,10(f6.2,1x))
      return
      end
c------------------------------------------------------------------------
      block data ca_sc_bonds
      include 'DIMENSIONS'
      include 'COMMON.LOCAL'
      data dsc /  1.237,  ! CYS (type  1)
     &            2.142,  ! MET (type  2)
     &            2.299,  ! PHE (type  3)
     &            1.776,  ! ILE (type  4)
     &            1.939,  ! LEU (type  5)
     &            1.410,  ! VAL (type  6)
     &            2.605,  ! TRP (type  7)
     &            2.484,  ! TYR (type  8)
     &            0.743,  ! ALA (type  9)
     &            0.000,  ! GLY (type 10)
     &            1.393,  ! THR (type 11)
     &            1.150,  ! SER (type 12)
     &            2.240,  ! GLN (type 13)
     &            1.684,  ! ASN (type 14)
     &            2.254,  ! GLU (type 15)
     &            1.709,  ! ASP (type 16)
     &            2.113,  ! HIS (type 17)
     &            3.020,  ! ARG (type 18)
     &            2.541,  ! LYS (type 19)
     &            1.345,  ! PRO (type 20)
     &            0.000  /! D   (type 21)
      end
