Input for the new version of PHOENIX2:

1. Title (20A4)
2. NRES, IPRINT, IWEI, IEL12 (free format)

NRES - the number of _inner_ alpha-carbons in the chain (not including)
       the terminal alpha-carbons). The total number of alpha-carbons
       including blocking groups is NRES+2 and the total number of
       peptide groups is NRES+1

IPRINT - printing switch (recommended 0)

IWEI - For IWEI=0 the unweighed sum of squares of the differences between
       alpha-carbon distances of the input and actual virtual-chain is
       minimized. For IWEI=1 each difference is weighed by the inverse of
       the difference of the initial chain (recommended 0).

IEL12 - for IEL12=1 the electrostatic interactions between dipoles
       neighboring in the chain will be included and for IEL12=0 discarded
       in the calculation of the electrostatic field acting on free dipoles
       (i.e. the dipoles not involved in a dipole-path network) (recommended
       1). 

3. INAMP(I),I=1,NRES2 (20A4) - the three-letter codes of the residues 
       comprising the chain (including blocking groups). Use capital
       letter only, except for D-proline which should be coded as 'pro '.
       Use 'TER ' for dummy blocking groups.

4. FORM (A8) - the specification of the format for virtual-chain input:
       MOPAC - MOPAC format (as written by mopzip to .mop files);
       ZIP   - the format of spidola3 .zip files;
       PDB   - PDB format (as written by mopzip to .pdb files).

5. Virtual-chain geometry:

       for FORM=MOPAC: 
       D(I,1),THETA(I),GAMA(I) NRES2 times (3X,F15.2,3X,F12.5,3X,F12.5)
       (the virtual-bond lengts  virtual-bond angles, and virtual-torsional 
       angles). Note that  
       D(1,1),THETA(1),THETA(2),GAMA(1),GAMA(2),GAMA(3) are zero.
       The most easy way to generate such input is to run mopzip on
       a .zip file from spidola3, write a selected conformation to 
       a .mop file and then insert the .mop file except the three title
       lines.

       for FORM=ZIP:
       GAMA(I) from 4 to NRES2 (8F10.5). This part of input can be
       created by taking the gamma angles of a chosen united-residue
       conformation from the spidola3 .zip file and inserting them into
       the phoenix2 input file.

       for FORM=PDB:
       X(I,1),X(I,2),X(I,3) NRES2 times (30X,3F8.3). The Cartesian coordinates 
       of the alpha-carbons including the blocking groups in PDB format.
       This option is not recommended for the present applications; it is
       designed for inputting the alpha-carbon geometry from Brookhaven
       crystal-structure files.

6. MAXSTEP, MAXIT, TOL, STABFAC, MAXMAR (free format). If a '0' is input
       for any of these parameters a default value given in parentheses
       in the description below is assigned. The defaults are also the
       recommended values of these parameters:

       MAXSTEP (20) - maximum number of steps in passing from 'linear' to
                      'real' peptide groups;

       MAXIT   (20) - maximum number of iterations in each steps (i.e. 
                      max. number of iterations permitted to reach self-
                      consistence between the angles theta from two
                      successive iterations;

       TOL    (0.5) - max. allowed difference between the angles theta from
                      two successive iterations;

       STABFAC (1.0) - the theta angles in p-th iterations are calculated
                      from the formula:
                      theta(p)=STABFAC*theta(p-1)+(1-STABFAC)*theta~(p);
                      where theta~(p) is the value resulting from the 
                      dipole-alignment procedure.

       MAXMAR  (10) - maximum number of Marquardt iterations in distance-
                      fitting procedure.

7. NPAIR - the number of alpha-carbon  distances which will be assigned 
        special weights (free format);
        
        For NPAIR>0 IPAIR(I,1),IPAIR(I,2),WPAIR(I),NPAIR times (free format)
        - the numbers of alpha-carbons comprising pairs of specially weighed
        distances, the weights of these distances. 

8. NPATH - the number of dipole paths (free format);
        for each path: NMEM(I), (IPATH(I,J),J=1,NMEM(I)) (free format) - the 
        number of peptide groups involved in path I and the numbers of these
        peptide groups in the chain. Important! Peptide group of number I
        is counted from Calpha(I) to Calpha(I+1).


