      subroutine elecont(iout)
      include 'parcom.dat'
      dimension app(2,2),bpp(2,2),ael6(2,2),ael3(2,2),itel(maxat)
      logical dumy
      character*4 inamp
      common /atoms/ natoms,x(maxat,3),itype(maxat)
      common /contact/ ncont(maxres),icont(maxres,20),econt(maxres,20)
      common /pept/ nres,nres1,nres2,inamp(maxres)
*
* Load the constants of peptide bond - peptide bond interactions.
* Type 1 - ordinary peptide bond, type 2 - alkylated peptide bond (e.g.
* proline) - determined by averaging ECEPP energy.      
*
* as of 7/06/91.
*
      real epp  (2,2) / 0.3045, 0.3649, 0.3649, 0.5743/,
     1     rpp  (2,2) / 4.5088, 4.5395, 4.5395, 4.4846/,
     2     elpp6(2,2) /-0.2379,-0.2056,-0.2056,-0.0610/,
     3     elpp3(2,2) / 0.0503, 0.0000, 0.0000, 0.0692/
      data elcutoff /-0.3/
      do i=1,2
        do j=1,2
        rri=rpp(i,j)**6
        app (i,j)=epp(i,j)*rri*rri 
        bpp (i,j)=-2.0*epp(i,j)*rri
        ael6(i,j)=elpp6(i,j)*4.2**6
        ael3(i,j)=elpp3(i,j)*4.2**3
        write (iout,'(2i2,4e15.4)') i,j,app(i,j),bpp(i,j),ael6(i,j),
     1                               ael3(i,j)
        enddo
      enddo
      nnt=1
      if (inamp(1).eq.'TER') nnt=2
      nct=nres2
      if (inamp(nres2).eq.'TER') nct=nres1
      do i=nnt,nct-1
        if (inamp(i+1).eq.'PRO') then
          itel(i)=2
        else
          itel(i)=1
        endif
      enddo
      do i=1,nres1
        ncont(i)=0
      enddo	    
      do 1 i=nnt,nct-2
        if (dumy(i)) goto 1
        xi=x(i,1)
        yi=x(i,2)
        zi=x(i,3)
        dxi=x(i+1,1)-x(i,1)
        dyi=x(i+1,2)-x(i,2)
        dzi=x(i+1,3)-x(i,3)
        xmedi=xi+0.5*dxi
        ymedi=yi+0.5*dyi
        zmedi=zi+0.5*dzi
        do 4 j=i+2,nct-1
	  if (dumy(j)) goto 4
          ind=ind+1
          iteli=itel(i)
          itelj=itel(j)
          if (j.eq.i+2 .and. itelj.eq.2) iteli=2
          if (iteli.eq.2 .and. itelj.eq.2) goto 4
          aaa=app(iteli,itelj)
          bbb=bpp(iteli,itelj)
          ael6i=ael6(iteli,itelj)
          ael3i=ael3(iteli,itelj) 
          dxj=x(j+1,1)-x(j,1)
          dyj=x(j+1,2)-x(j,2)
          dzj=x(j+1,3)-x(j,3)
          xj=x(j,1)+0.5*dxj-xmedi
          yj=x(j,2)+0.5*dyj-ymedi
          zj=x(j,3)+0.5*dzj-zmedi
          rrmij=1.0/(xj*xj+yj*yj+zj*zj)
          rmij=sqrt(rrmij)
          r3ij=rrmij*rmij
          r6ij=r3ij*r3ij  
          vrmij=vblinv*rmij
          cosa=(dxi*dxj+dyi*dyj+dzi*dzj)*vblinv2      
          cosb=(xj*dxi+yj*dyi+zj*dzi)*vrmij
          cosg=(xj*dxj+yj*dyj+zj*dzj)*vrmij
          fac=cosa-3.0*cosb*cosg
          ev1=aaa*r6ij*r6ij
          ev2=bbb*r6ij
          fac3=ael6i*r6ij
          fac4=ael3i*r3ij
          evdwij=ev1+ev2
          el1=fac3*(4.0+fac*fac-3.0*(cosb*cosb+cosg*cosg))
          el2=fac4*fac       
          eesij=el1+el2
          if (eesij.le.elcutoff) then
            if (itelj.ne.2) then
               ncj=ncont(j)+1
               icont(j,ncj)=i
               ncont(j)=ncj
	       econt(j,ncj)=eesij
            endif
            if (j.ne.i+2 .and. iteli.ne.2) then
               nci=ncont(i)+1
               icont(i,nci)=j
               ncont(i)=nci
	       econt(i,nci)=eesij
            endif
          endif
          ees=ees+eesij
          evdw=evdw+evdwij
    4   continue
    1 continue
      write (iout,*) 'Total average electrostatic energy: ',ees
      write (iout,*) 'VDW energy between peptide-group centers: ',evdw
      write (iout,*)
      write (iout,*) 'Electrostatic contacts: '
      do i=nnt,nct-1
        nci=ncont(i)
        if (nci.gt.0) write (iout,100) inamp(i),i,(inamp(icont(i,j)),
     &  icont(i,j),econt(i,j),j=1,nci)	
      enddo          
      return
  100 format(a3,1h(,i3,1h),2x,6(a3,1h(,i3,1h),f5.2,2x),
     &          20(/10x,6(a3,1h(,i3,1h),f5.2,2x)))
      end
