      subroutine genpath(inp,iout,rdpath,printmap,nocalc,contacts_only)
*
* This subroutine constructs the dipole-path network.
* As of 17/1/93.
*
      include 'parcom.dat'
*     integer*2 ipath,nleft,ileft
      character*4 inamp
      character*80 title
      logical whichend,found,inpath,inhel,inh2,inh3,dumy,overlap
      logical rdpath,printmap,nocalc,contacts_only
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      common /pept/ nres,nres1,nres2,inamp(maxres),gama(maxres),
     1 theta(maxres),alph(maxres),rrl(maxres)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
      common /atoms/ natoms,x(maxat,3),itype(maxat)
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      common /sheets/ nstrand,nstres(maxres,5)
      common /sheet1/ i,k,ii,ib,iib,iidir,iiidir,iiid,iiiid,ic
      common /geo/ pi,dwapi,conv,rad2deg
      dimension ncont1(maxres),icont1(maxres,max_cont)
      common /mapa/ pref
      common /header/ title
      character*16 pref,cfname
      character*16 exten(5) /'.grd','.ele','.el1','.pro','.pr1'/
      integer ilen
      external ilen

cd    print *,'GENPATH: rdpath=',rdpath
      if (rdpath) then

cd    print *,'reading paths'
      read(inp,*) npath
      write (iout,10) npath
      read(inp,*) (nmem(i),(ipath(i,j),j=1,nmem(i)),i=1,npath)
      do i=1, npath 
        write (iout,20) nmem(i),(inamp(ipath(i,j)),ipath(i,j),
     &                  j=1,nmem(i))
cd      print *,'path',i,' read nmem=',nmem(i)
      enddo

      endif
*
* Construct the electrostatic-contact array.
*
      if (.not.rdpath .or. printmap) call elecont(iout)
      do i=1,nres1
        ncont1(i)=ncont(i)
        do j=1,ncont(i)
          icont1(i,j)=icont(i,j)
        enddo
      enddo
* 
* Just punch out the contact map, if requested
*
      if (contacts_only) goto 130
*
* Skip path construction, if the dipole-path network has been read in.
*
      if (rdpath) goto 120

      npath=0
      do i=1,maxpath
        nmem(i)=0
      enddo
*
* Find alpha-helices.
*
      do 11 i=nres1,6,-1
cd	do l=1,nres1
cd	  write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd      enddo	 
        call helcont(i,ih1)
        call helcont(i-1,ih2)
        call helcont(i-2,ih3)
	inh2=inhel(i-1)
	inh3=inhel(i-2)
        if (ih1*ih2*ih3 .eq.0 .and. (ih1.eq.0 .or. .not.inh2 .and. 
     &                             .not.inh3) ) goto 11
	ipath(npath+1,1)=i
	ipath(npath+1,2)=i-3
	nmem(npath+1)=2
	call delcont(i,ih1)
        if (.not.inh2) then	
          ipath(npath+2,1)=i-1
          ipath(npath+2,2)=i-4
          call delcont(i-1,ih2)
          nmem(npath+2)=2
        endif	  
	if (.not.inh3) then
          ipath(npath+3,1)=i-2
          ipath(npath+3,2)=i-5
          call delcont(i-2,ih3)
          nmem(npath+3)=2
        endif	  
        call prophelf(npath+1,i-3)
cd	do l=1,nres1
cd	  write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd      enddo
	if (.not.inh2) call prophelf(npath+2,i-4)
cd	do l=1,nres1
cd	  write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd      enddo
	if (.not.inh3) call prophelf(npath+3,i-5)
cd	do l=1,nres1
cd	  write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd      enddo
	call prophelb(npath+1,i+3)
	if (.not.inh2) call prophelb(npath+2,i+4)
	if (.not.inh3) call prophelb(npath+3,i+5)
	npath=npath+1
        if (.not.inh2) npath=npath+1
	if (.not.inh3) npath=npath+1
cd        write (iout,*) 'helix: npath=',npath
cd	write (iout,'(16i5)') nmem(npath-2),
cd     &        (ipath(npath-2,ii),ii=1,nmem(npath-2))
cd	write (iout,'(16i5)') nmem(npath-1),
cd     &        (ipath(npath-1,ii),ii=1,nmem(npath-1))
cd	write (iout,'(16i5)') nmem(npath),
cd     &        (ipath(npath,ii),ii=1,nmem(npath))
   11 continue        
      write (2,*) 'npath=',npath
      print *,'exit helical path construction'
cd      do l=1,nres1
cd        write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd        write (*,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd      enddo
*
* Find pairs of strands involved in beta-sheets.
*
      nstrand=0
      do i=1,50
        do j=1,5
          nstres(i,j)=0
        enddo
      enddo
      print *,'entering sheet construction'
      do 8 i=1,nres1
        nci=ncont(i)
        if (nci.eq.0) goto 8
        do 9 j=1,nci
          icj=icont(i,j)
          if (icj.le.i) goto 9
*
* Determine whether a contact originates a two-strand fragment of a beta-sheet.
*
cd          write (2,*) 'calling propsheet, i=',i,' icj=',icj
          call propsheet(i,icj,ie,je,-1,iidir)
          isi=-1
cd	  write (2,*) 'i=',i,' icj=',icj,' ie=',ie,' je=',je
	  if (ie.eq.i) then
            call propsheet(i,icj,ie,je,1,iidir)
            isi=1
cd	  write (2,*) 'i=',i,' icj=',icj,' ie=',ie,' je=',je
          endif	    
*
* Add a new pair of strands to the array of interacting strands.
*
          if (ie.ne.i) then
            nstrand=nstrand+1
            nstres(nstrand,1)=i
            nstres(nstrand,2)=icj
            nstres(nstrand,3)=ie
            nstres(nstrand,4)=iidir
            nstres(nstrand,5)=isi
*
* Invert sign of strand contact in the contact array to prevent from
* repetition.
*
            ick=icj
            icont(i,j)=-icj
            do k=i+1,ie
              ick=ick+isi
              nck=ncont(k)
              do l=1,nck
                if (icont(k,l).eq.ick) icont(k,l)=-ick
              enddo
            enddo 
          endif
    9   continue
    8 continue
      write (iout,*) 'nstrand=',nstrand
      do i=1,nstrand
        write (iout,*) 
        write (iout,*) i,(nstres(i,j),j=1,5)
      enddo     
      if (nstrand.eq.0) goto 110
*
* Restore the signs of contact array.
*
      do i=1,nres-1
        nci=ncont(i)
        do j=1,nci
          icont(i,j)=iabs(icont(i,j))
        enddo
      enddo
*
* Construct sheet paths.
*
      do while (nstrand.gt.0)
*
* Find the longest two-strand sheet that has been found in the preceding stage.
*
        maxlen=nstres(i,3)-nstres(i,1)
        imax=1
        do i=1,nstrand
          len=nstres(i,3)-nstres(i,1)
          if (len.gt.maxlen) then
	    maxlen=len
	    imax=i
          endif
        enddo
	ib=nstres(imax,1)
	jb=nstres(imax,2)
	ie=nstres(imax,3)
	iidir=nstres(imax,4)
	isi=nstres(imax,5)
	je=jb+len*isi
	do i=1,5
	  nstres(imax,i)=nstres(nstrand,i)
	enddo
	nstrand=nstrand-1
cd	write (2,*) 'imax=',imax,' len=',len,' ib=',ib,' ie=',ie,
cd     & ' je=',je,' iidir=',iidir,' isi=',isi	
*	
* Attatch neighboring strands and construct sheet paths. Loop along the longest
* strand.
*
        do i=ib,ie
*
* Initiate the path that will start at position i of the longest two-strand
* sheet.
*	
	  npath=npath+1
	  nmem(npath)=2
cd	  write (2,*) 'Contacts before starting a new sheet path'
cd          do l=1,nres1
cd            write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd          enddo	 
          ipath(npath,1)=i
	  ipath(npath,2)=jb+(i-ib)*isi
cd	  write (2,*) 'i=',i,'ipath1=',ipath(npath,1),' ipath2=',
cd     &                ipath(npath,2)
	  call contpos(ipath(npath,2),ipath(npath,1),ic)
cd	  write (2,*) 'ic=',ic,' calling delcont'
	  call delcont(ipath(npath,1),ic)
cd	  write (2,*) 'Contacts after starting a new sheet path'
cd          do l=1,nres1
cd            write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd          enddo	 
*
* Determine the direction of the path.
*	  
          iiid=2
	  if (iidir.ne.2) iiid=iidir*(-1)**(i-ib)
	  if (iiid.eq.-1) then
cd	    write (2,*) 'Inverting the new sheet path'
*	    call exch(ipath(npath,1),ipath(npath,2))
            call invpath(npath)
	    iiid=1
cd            do l=1,nres1
cd              write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd            enddo	 
          endif 
cd	  write (2,*) 'ic=',ic
*	  
* Check whether any of the other two-strand sheets overlap with the fragmet
* i of the last (i.e. the longest) sheet.	  
*
          do k=1,nstrand
            overlap=.false.	  
	    nmemp=nmem(npath)
	    iib=nstres(k,1)
	    iie=nstres(k,3)
	    jjb=nstres(k,2)
	    iiidir=nstres(k,4)
	    iisi=nstres(k,5)
	    jje=nstres(k,2)+(iie-iib)*iisi
	    ip=ipath(npath,1)
	    jp=ipath(npath,2)
	    kp=ipath(npath,nmemp-1)
	    lp=ipath(npath,nmemp)
cd	    write (2,*) 'k=',k,' iib=',iib,' iie=',iie,' jjb=',jjb
cd         write (2,*) 'jje=',jje,' ip=',ip,' jp=',jp,' kp=',kp,' lp=',lp	    
*	    
* Case 1: a part of the two-strand sheet of number k overlaps with the
* first strand of the longest sheet.
*
	    if (ip.ge.iib .and. ip.le.iie) then
	      ii=ip
              jj=jjb+iisi*(ii-iib)
cd              write (2,*) 'Case 1: ii=',ii,' jj=',jj
cd	      write (2,*) 'curvature: ',jj,ip,jp,curvat(jj,ip,jp)
cd	      write (*,*) 'curvature: ',jj,ip,jp,curvat(jj,ip,jp)
              if (curvat(jj,ip,jp).gt.90.0) then
	        iiiid=2
                if (iiidir.ne.2) iiiid=iiidir*(-1)**(ii-iib)
                call contpos(ip,jj,ic)
cd		write (2,*) 'ic=',ic
                call buildsheet(jj,-1,.false.,found)
              endif	
	      overlap=.true.	
* 
* Case 2: a part of the second half of sheet k overlaps with the first strand
* of the longest sheet.
*
	    elseif ( (iisi.gt.0 .and. ip.ge.jjb .and. ip.le.jje) .or.
     &               (iisi.lt.0 .and. ip.le.jje .and. jp.ge.jjb) ) then
              jj=ip
              if (iisi.eq.1) then
                ii=iib+jj-jjb
              else
                ii=iie-(jj-jjb)
              endif
cd              write (2,*) 'Case 2: ii=',ii,' jj=',jj
cd	      write (2,*) 'curvature: ',ii,ip,jp,curvat(ii,ip,jp)
              if (curvat(ii,ip,jp).gt.90.0) then
	        iiiid=2
	        if (iiidir.ne.2) iiiid=iiidir*(-1)**(ii-iib)
                call contpos(ii,ip,ic)
cd		write (2,*) 'ic=',ic
                call buildsheet(ii,1,.false.,found)
              endif
	      overlap=.true.
* 
* Case 3: a part of the second strand of sheet k overlaps with the first strand
* of the longest sheet.
*
	    elseif (lp.ge.iib .and. lp.le.iie) then
              ii=lp
              jj=jjb+iisi*(ii-iib)
cd              write (2,*) 'Case 3: ii=',ii,' jj=',jj
cd	      write (2,*) 'curvature: ',kp,lp,jj,curvat(kp,lp,jj)
	      if (curvat(kp,lp,jj).gt.90.0) then
	        iiiid=2
	        if (iiidir.ne.2) iiiid=iiidir*(-1)**(ii-iib)
cd		write (2,*) (icont(lp,l),l=1,ncont(lp))
                call contpos(jj,lp,ic)
cd		write (2,*) 'ic=',ic
                call buildsheet(jj,1,.true.,found)
              endif	
	      overlap=.true.	
*
* Case 4: a part of the second strand of sheet k overlaps with the second strand
* of the longest sheet.
*	      
	    elseif ( iisi.gt.0 .and. lp.ge.jjb .and. lp.le.jje .or.
     &               iisi.lt.0 .and. lp.le.jjb .and. lp.ge.jje ) then
              jj=lp
              if (iisi.eq.1) then
                ii=iib+jj-jjb
              else
                ii=iie-(jj-jjb)
              endif
cd              write (2,*) 'Case 4: ii=',ii,' jj=',jj
cd	      write (2,*) 'curvature: ',kp,lp,ii,curvat(kp,lp,ii)
              if (curvat(kp,lp,ii).gt.90.0) then
	        iiiid=2
                if (iiidir.ne.2) iiiid=iiidir*(-1)**(ii-iib)
                call contpos(ii,lp,ic)
cd		write (2,*) 'ic=',ic
                call buildsheet(ii,-1,.true.,found)
              endif
	      overlap=.true.
            endif
cd	    write (2,*) 'found=',found,' overlap=',overlap
            if (overlap) call delete(k,ii)
cd            write (iout,*) 'nstrand=',nstrand
cd            do l=1,nstrand
cd              write (iout,*) 
cd              write (iout,*) l,(nstres(l,m),m=1,5)
cd            enddo     
          enddo	
        enddo
cd	stop
      enddo
      print *,'exit sheet path construction'
      write (2,*) 'Helix and sheet path network:'
      do l=1,npath
        write (2,'(16i5)') (ipath(l,m),m=1,nmem(l))
      enddo
      write (2,*) 'Contacts left:'	
      do l=1,nres1
        write (iout,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
        write (*,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
      enddo
cd      stop
*
* Attatch the dipoles that are in electrostatic contact with already existing
* paths to the appropriate paths and concatenate those paths whose ends are in
* electrostatic contact.
*      
cd      write (2,*) 'npath=',npath
 110  do i=1,npath
cd        write (2,*) 'i=',i
        found=.true.
        do while (found)
          found=.false.
          nmemp=nmem(i)      
          ip=ipath(i,1)
          jp=ipath(i,2)
          kp=ipath(i,nmemp-1)
          lp=ipath(i,nmemp)
cd	  write (2,*) 'ip=',ip,' jp=',jp,' kp=',kp,' lp=',lp
          do j=1,nres1
            ncj=ncont(j)
            if (ncj.gt.0) then
	      call contpos(ip,j,ic)
	      if (ic.gt.0) then
                call contdir(j,ip,idir)
cd                write (2,*) 'ic=',ic,' j=',j,' idir=',idir
                if (idir.gt.0 .and. curvat(j,ip,jp).gt.90.0) then
*
* Does the peptide group j already belong to any dipole path?
*
                  l=1
                  do while (l.le.npath .and. .not. found)
                    nmeml=nmem(l)
                    ipm1=ipath(l,nmeml-1)
                    ipm2=ipath(l,nmeml)
                    if (j.eq.ipm2 .and. 
     &                  curvat(ipm1,ipm2,j).gt.90.0) then
*
* The peptide group j was found to link paths l and i. Path i is 
* therefore concatenated with path l.
*
                      call catpath(l,i)
                      found=.true.
                    elseif (.not.inpath(j,l,1,nmeml-1)) then
                      call add2path(i,j,ic,.false.)
                      found=.true.
                    endif
                    l=l+1
                  enddo
                else
                  ncont(j)=ncont(j)-1
		  do ll=ic,ncont(j)
		    icont(j,ll)=icont(j,ll+1)
                  enddo		    
                endif
              endif		
              if (.not.found .and. j.eq.lp) then
	        k=1
                do while (k.le.ncj .and. .not.found)
                  icjk=icont(j,k)
                  call contdir(lp,icjk,idir)
cd          write (2,*) 'k=',k,' icjk=',icjk,' lp=',lp,' idir=',idir
                  if (idir.gt.0 .and. curvat(kp,lp,icjk).gt.90.0) then
*
* Does the peptide group icjk already belong to any dipole path?
*
                    l=1
                    do while (l.le.npath .and. .not.found)
                      nmeml=nmem(l)
                      ipm1=ipath(l,1)
                      ipm2=ipath(l,2)
                      if (icjk.eq.ipath(l,1) .and. 
     &                    curvat(icjk,ipm1,ipm2).gt.90.0) then
                        call catpath(i,l)
                        found=.true.
                      elseif (.not.inpath(icjk,l,2,nmeml)) then
                        call add2path(i,icjk,k,.true.)
                        found=.true.
                      endif
                      l=l+1
                    enddo
                  else
                    ncont(j)=ncont(j)-1
		    ncj=ncont(j)
		    do ll=k,ncj
		      icont(j,ll)=icont(j,ll+1)
                    enddo		      
                  endif
                  k=k+1
                enddo
              endif		
            endif
          enddo
        enddo
      enddo
cd      do l=1,nres1
cd         write (2,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd      enddo	 
* 
* Construct paths from the remaining contacts.
*
      do i=1,nres1
        nci=ncont(i)
	j=1
	do while (nci.gt.0)
	  icj=icont(i,j)
	  call contdir(i,icj,idir)
cd	  write (2,*) 'i=',i,' icj=',icj,' idir=',idir
	  if (idir.eq.1) then
            npath=npath+1
	    ipath(npath,1)=i
	    ipath(npath,2)=icj
	    nmem(npath)=2
cd	    write (2,*) 'npath=',npath,ipath(npath,1),ipath(npath,2) 
	    call delcont(i,j)
	    call propathf(npath)
	    call propathb(npath)
	    nci=ncont(i)
cd            do l=1,nres1
cd              write (2,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd            enddo	 
          else
	    nci=nci-1
	    ncont(i)=nci
	    do k=j,nci
	      icont(i,k)=icont(i+1,k)
            enddo
cd            do l=1,nres1
cd              write (2,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd            enddo	 
	  endif
	enddo
      enddo	
  120 write (iout,10) npath
      do  i=1,npath 
cd      print *,'i=',i,' nmem=',nmem(i)
        write (iout,20) nmem(i),(inamp(ipath(i,j)),ipath(i,j),
     &                  j=1,nmem(i))
      enddo     
*
* Find the proline residues involved in path formation
* (Changes made on 8/1/91).
*
      nfixed=0
      do i=1,npath
        nn=nmem(i)
        ifin=ipath(i,nn)
        do j=1,nn
          ires=ipath(i,j)
          if (j.lt.nn .and. ipro(ires).ne.0) then
            write (iout,*) 'Error - the proline residue must not ',
     1         'originate or be inside a path'
            stop
          endif
          if (ipro(ires).ne.0) then
            nfixed=nfixed+1
            ifix(nfixed)=ires-1
          endif
        enddo
        if (ipro(ifin+1).ne.0) then
          nfixed=nfixed+1
          ifix(nfixed)=ifin+1
        endif
      enddo
      do i=1,npath
        nn=nmem(i)
        if (nmem(i).gt.2) then
        write (2,*) 'Curvatures of path',i
        do j=1,nmem(i)-2
          ii=ipath(i,j)
          jj=ipath(i,j+1)
          kk=ipath(i,j+2)
          write (2,'(3i5,5x,f6.1)') ii,jj,kk,curvat(ii,jj,kk)
        enddo
        endif
      enddo
      write (iout,*) 
*
* Look for "lone" peptide bonds
* Find the remaining proline residues, not involved in path formation.
* Their lambda1 and lambda2 angles are interdependent, so as the angle
* phi be +-75 deg, depending on proline residue chirality.
* (Changes made on 8/1/91)
*
      ndep=0
      nleft=0
      do 2 i=1,nres1
        do 3 j=1, npath
	  do 4 k=1,nmem(j)
	    if (ipath(j,k).eq.i) goto 2
    4     continue
    3   continue
        if (dumy(i)) goto 2
        do j=1,nfixed
          if (ifix(j).eq.i) goto 2
        enddo
        if (ipro(i+1).ne.0) goto 2
        do j=1,ndep
          if (i.eq.idep(j-1) .or. i.eq.idep(j)) goto 2
        enddo
        nleft=nleft+1
	ileft(nleft)=i
        do j=i,2,-1
          if (ipro(j).eq.0) goto 2
          nfixed=nfixed+1
          ifix(nfixed)=j-1
        enddo
    2 continue
      if (nleft.gt.0) write (iout,30) nleft,(inamp(ileft(j)),ileft(j),
     1                                j=1,nleft)
      if (nfixed.gt.0)
     &  write (iout,40) nfixed,(inamp(ifix(i)),ifix(i),i=1,nfixed)
      if (ndep.gt.0)
     &  write (iout,50) ndep,(inamp(idep(i)),idep(i),i=1,ndep)      
      write (iout,'(//)') 
* Print the electrostatic-contact map, if requested.
  130 if (printmap) then
        istart=1
        if (inamp(1).eq.'D') istart=2
        iend=nres2
        if (inamp(nres2).eq.'D') iend=nres2-1
C Create script for GnuPlot
        call concat(pref,'.gnu',cfname)
        open (10,file=cfname,status='unknown')
        write (10,'(2a)') 
     & '# This is the script to display the electrostatic-contact ',
     & 'map using GnuPlot.'
        write (10,'(3a)') 'set title "',title(:ilen(title)),'"'
        write (10,'(a)') 'set size 0.895,1'
        write (10,'(a)') 'set nokey'
        write (10,'(a,i3)') 'set xtics 0,5,',nres2
        write (10,'(a,i3)') 'set ytics 0,5,',nres2
        write (10,'(a)') 'set xlabel "Residue number"'
        write (10,'(a)') 'set ylabel "Residue number"'
        write (10,'(a,i3,a,i3,4a)') 'plot [1:',nres2,'] [1:',nres2,
     &  '] "',pref(:ilen(pref)),'.grd','" w l, \\' 
        write (10,'(4a)') '"',pref(:ilen(pref)),'.ele','" w p 11, \\' 
        write (10,'(4a)') '"',pref(:ilen(pref)),'.el1','" w p 12, \\' 
        write (10,'(4a)') '"',pref(:ilen(pref)),'.pro','" w p 4, \\' 
        write (10,'(4a)') '"',pref(:ilen(pref)),'.pr1','" w p 1 ' 
        call concat(pref,exten(1),cfname)
        open(10,file=cfname,status='unknown')
        write (10,'(a)') '#Grid'         
C Now for GnuPlot:
c       do i=1,nres1 
c         do j=1,i-2
c           write (10,'(2i5)') i,j
c         enddo
c         do j=i+2,nres1
c           write (10,'(2i5)') i,j
c         enddo
c       enddo
        do i=1,nres1,2
          write (10,'(2i5)') 1,i
          write (10,'(2i5)') nres2,i
          write (10,'(2i5)') nres2,i+1
          write (10,'(2i5)') 1,i+1
          if (i.lt.nres2-1) write (10,'(2i5)') 1,i+2
        enddo
        do i=1,nres1,2
          write (10,'(2i5)') i,1
          write (10,'(2i5)') i,nres2
          write (10,'(2i5)') i+1,nres2
          write (10,'(2i5)') i+1,1
          if (i.lt.nres2-1) write (10,'(2i5)') i+2,1
        enddo
        close(10)
        call concat(pref,exten(2),cfname)
        open(10,file=cfname,status='unknown')
        write (10,'(a)') '#Electrostatic contacts'
        do i=istart,iend
          do j=1,ncont1(i)
            write (10,'(2f5.1)') i+0.5,icont1(i,j)+0.5
          enddo
        enddo
        close(10)
        call concat(pref,exten(3),cfname)
        open(10,file=cfname,status='unknown')
        write(10,'(a)') '#Sterically-allowed contacts'
*       do i=1,npath
*         do j=1,nmem(i)-1
*           write (10,'(2f5.1)') ipath(i,j)+0.5,ipath(i,j+1)+0.5
*         enddo
*       enddo
        do i=istart,iend
          do j=1,ncont1(i)
            call contdir(i,icont1(i,j),idir)
            if (idir.gt.0) write (10,'(2f5.1)') i+0.5,icont1(i,j)+0.5
          enddo
        enddo
        close(10)
        call concat(pref,exten(4),cfname)
        open(10,file=cfname,status='unknown')
        write (10,'(a)') '#Forbidden contacts'
        do i=istart,iend-2
          if (ipro(i+1).gt.0) then
            do j=1,i-2
              write (10,'(2f5.1)') i+0.5,j+0.5
            enddo
            do j=i+2,iend-1
              if (ipro(i+1).gt.0) write (10,'(2f5.1)') i+0.5,j+0.5
            enddo
          else
            write (10,'(2f5.1)') i+0.5,i+2.5
          endif
        enddo
        close(10)
        call concat(pref,exten(5),cfname)
        open(10,file=cfname,status='unknown')
        write (10,'(a)') '#Conditionally allowed contacts'
        do i=istart,iend-1
          do j=1,i-2
            if (ipro(j+1).eq.1 .and. ipro(i+1).eq.0)
     &      write (10,'(2f5.1)') i+0.5,j+0.5
          enddo
        enddo
        do i=istart,iend-1
          do j=i+2,iend-1
            if (ipro(j+1).eq.1 .and. ipro(i+1).eq.0) then
              write (10,'(2f5.1)') i+0.5,j+0.5
            endif
          enddo
        enddo
        close(10)
      endif
      if (nocalc .or. contacts_only) stop
   10 format (/'The ',i3,' dipole paths are as follows: '/)
   20 format (i3,' residues: ',7(a3,'(',i3,') - '),
     1                     10(/7(a3,'(',i3,') - ')))
   30 format (/'The following ',i2,' residues do not participate in ',
     1        'path formation: ',
     2        30(/8(a3,'(',i3,'), ')))
   40 format (/'The following',i3,' lambda angles ',
     1         'are dependent on proline position:'/
     2         30(/7(a3,'(',i3,'), ')))
   50 format (/'The  peptide bond pairs of the following',i3,' proline',
     1         ' residues'/'will be aligned in the electrostatic field:'
     2         /30(/7(a3,'(',i3,'), ')))
      return
      end
********************
      subroutine add2path(ip,ires,ic,whichend)
      include 'parcom.dat'
      logical whichend
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      nm=nmem(ip)+1
      nmem(ip)=nm
      if (whichend) then
        ipath(ip,nm)=ires
	ires1=ipath(ip,nm-1)
	call contpos(ires,ires1,ic)
	write (2,*) 'ires=',ires,' ires1=',ires1,' ic=',ic
      else
        do i=nm,2,-1
	  ipath(ip,i)=ipath(ip,i-1)
        enddo
        ipath(ip,1)=ires
	ires1=ipath(ip,1)
      endif
      call delcont(ires1,ic)
      return
      end
********************
      subroutine helcont(ires,ih)
      include 'parcom.dat'
      logical dumy
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
      ih=0
      if (dumy(ires)) return 
      nci=ncont(ires)
      do i=1,nci
        if (icont(ires,i).eq.ires-3 .and. ipro(ires+1).eq.0 .and.
     &     .not. dumy(ires-3) ) then
          ih=i
          return
        endif
      enddo
      return
      end
*********************
      subroutine contpos(i,j,jc)
      include 'parcom.dat'
*
* Find the position of electrostatic contact between peptide groups (i,j)
* in the electrostatic-contact array.
*      
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      do k=1,ncont(j)
        if (i.eq.icont(j,k)) then
	  jc=k
	  return
        endif
      enddo
      jc=0
      return
      end	  
*********************
      subroutine prophelf(ip,ir)
*      
* Extend forward an alpha-helical path.
*
      do k=ir,1,-3
        call helcont(k,ih1)
        if (ih1.eq.0) return
        call add2path(ip,k-3,ih1,.true.)
      enddo
      return
      end
*********************
      subroutine prophelb(ip,ir)
*
* Extend backward an alpha-helical path.
*      
      do k=ip,nres1,3
        call helcont(k,ih1)
        if (ih1.eq.0) return
        call add2path(ip,k,ih1,.false.)
      enddo
      return
      end
*********************
      logical function inhel(i)
      include 'parcom.dat'
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      logical inpath
      do ip=1,npath
        if (inpath(i,ip,1,nmem(ip)).and.inpath(i-3,ip,1,nmem(ip))) then
	  inhel=.true.
          return	  
        endif	  
      enddo
      inhel=.false.
      return
      end      	  		
*********************
      subroutine invpath(np)
      include 'parcom.dat'
      common /pept/ nres,nres1,nres2
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      nm=nmem(np) 
      do i=1,nm/2
        call exch(ipath(np,i),ipath(np,nm-i+1))
      enddo
      i1=ipath(np,nm)
      i2=ipath(np,1)
      write (2,*) 'invpath: i1=',i1,' i2=',i2
      nci1=0
      do i=1,nres1
        call contpos(i1,i,ic)
cd	write (2,*) 'i=',i,' ic=',ic
	if (ic.gt.0) then
	  if (i-i1.gt.2 .and. ipro(i+1).eq.0) then
             nci1=nci1+1
             icont(i1,nci1)=i
             ncont(i1)=nci1
          endif	     
          ncont(i)=ncont(i)-1
	  do j=ic,ncont(i)
	    icont(i,j)=icont(i,j+1)
	  enddo  
        endif
      enddo	
      do i=1,ncont(i2)
        jj=icont(i2,i)
	ncont(jj)=ncont(jj)+1
	icont(jj,ncont(jj))=i2
      enddo
      ncont(i2)=0	
      return
      end
*********************
      subroutine exch(ia,ib)
      iaux=ib
      ib=ia
      ia=iaux
      return
      end 
*********************
      logical function dumy(ires)
      include 'parcom.dat'
      character*4 inamp
      common /pept/ nres,nres1,nres2,inamp(maxres)
      dumy=.false.
      if (ires.lt.1 .or. inamp(ires).eq.'TER' .or. 
     &  inamp(ires+1).eq.'TER') dumy=.true.
      return
      end
*********************
      subroutine propsheet(ib,jb,ie,je,isi,iidir)
      include 'parcom.dat'
      common /pept/ nres,nres1,nres2
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
cd      write (2,*) 'propsheet: ib=',ib,' jb=',jb,' ie=',ie,' je=',je
      ie=ib
      je=jb
      jj=jb
      call contdir(ib,jb,idir)
cd      write (2,*) 'idir=',idir
      iidir=idir
      do i=ib+1,nres
        nci=ncont(i)
cd	write (2,*) 'i=',i,' nci=',nci
        if (nci.eq.0) return
        jj=jj+isi
cd	write (2,*) 'jj=',jj
        do j=1,nci
          if (icont(i,j).eq.jj) then
	    call contdir(i,jj,idir1)
cd	    write (2,*) 'i=',i,' jj=',jj,' idir1=',idir1
	    if (idir1.eq.0) then
	      return
	    elseif (idir.eq.2 .or. idir1.eq.2) then
	      goto 1
cd	    elseif (idir*idir1.eq.1 .and. i-ib.lt.2) then
	    elseif (idir*idir1.eq.1) then
	      return
	    endif
	    goto 1
          endif
        enddo
	return
    1   ie=i
        je=jj
cd        write (2,*) 'ie=',ie,' je=',je
        if (idir.ne.2) then
          idir=-idir
	else if (idir1.ne.2) then
	  idir=idir1
	  iidir=idir*(-1)**(i-ib)
	endif  
      enddo
      return
      end
*********************
      subroutine contdir(ii,jj,idir)
      include 'parcom.dat'
      character*4 inamp
      common /pept/ nres,nres1,nres2,inamp(maxres)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
      common /atoms/ natoms,x(maxat,3)
      common /geo/ pi,dwapi,conv,rad2deg
      dimension u1(3),u2(3),v(3),w(3)
*
* This subroutine determines the direction of a part of dipole path composed
* of the dipoles ii and jj, so as to lead to sterically-allowed local 
* conformations.
* Returns 1, if dipole ii should be directed at dipole jj; -1, if opposite,
* 0, if no sterically-allowed direction exists and 2, if both residues
* are glycines and therefore both directions result in sterically allowed
* conformations.
*
      if (jj-ii.eq.2) then
        if (ipro(jj+1).ne.0) then
	  idir=0
	else
          idir=-1
	endif
      else if (ipro(ii+1).ne.0) then
        idir=-1
      else if (ipro(jj+1).ne.0) then
        idir=-1
      else if ( (ii.eq.nres1 .or. inamp(ii+1).eq.'GLY')
     &  .and.   (jj.eq.nres1 .or. inamp(jj+1).eq. 'GLY') ) then
        idir=2
      else
        do i=1,3
	  u1(i)=x(ii+1,i)-x(ii,i)
	  u2(i)=x(ii+2,i)-x(ii+1,i)
	enddo
        call vecprod(u1,u2,v)
	do i=1,3
	  u1(i)=x(jj+1,i)-x(jj,i)
	  u2(i)=x(jj+2,i)-x(jj+1,i)
	enddo
	call vecprod(u1,u2,w)
	do i=1,3
	  u1(i)=0.5*(x(jj,i)+x(jj+1,i)-x(ii,i)-x(ii+1,i))
	enddo
	u1norm=sqrt(scalar(u1,u1))
	vnorm=sqrt(scalar(v,v))
	wnorm=sqrt(scalar(w,w))
	do i=1,3
	  u1(i)=u1(i)/u1norm
	  v(i)=v(i)/vnorm
	  w(i)=w(i)/wnorm
	enddo
	dir1=scalar(u1,v)
	dir2=scalar(u1,w)
cd	write (2,*) 'ii=',ii,' jj=',jj,' dir1=',dir1,' dir2=',dir2
	if (abs(dir1).lt.0.1 .and. abs(dir2).lt.0.1) then
	  idir=2
	  return
        endif	  
	idir1=-sign(1.0,dir1)
	idir2=-sign(1.0,dir2)
        if (idir1.eq.idir2) then
	  idir=idir1
	elseif (ii.eq.nres1 .or. inamp(ii+1).eq.'GLY' 
     &	.or. abs(dir2).lt.0.1) then
	  idir=idir1
	elseif (jj.eq.nres1 .or. inamp(jj+1).eq.'GLY' 
     &	.or. abs(dir1).lt.0.1) then
	  idir=idir2
        else
          idir=0		  
        endif
      endif
      return
      end	
**********************************************************
      subroutine vecprod(u,v,w)
      dimension u(3),v(3),w(3)
      w(1)=u(2)*v(3)-u(3)*v(2)
      w(2)=-u(1)*v(3)+u(3)*v(1)
      w(3)=u(1)*v(2)-u(2)*v(1)
      return
      end
**********************************************************
      subroutine delete(isheet,ipos)
      include 'parcom.dat'
      common /sheets/ nstrand,nstres(maxres,5)
      if (nstres(isheet,1).eq.nstres(isheet,3)) then
        nstrand=nstrand-1
	do i=isheet,nstrand
	  do j=1,5
	    nstres(i,j)=nstres(i+1,j)
	  enddo
        enddo	    
      elseif (ipos.eq.nstres(isheet,1)) then
        nstres(isheet,1)=nstres(isheet,1)+1
	nstres(isheet,2)=nstres(isheet,2)+nstres(isheet,5)
	nstres(isheet,4)=-nstres(isheet,4)
      elseif (ipos.eq.nstres(isheet,3)) then
        nstres(isheet,3)=nstres(isheet,3)-1
      else
        nstrand=nstrand+1
	do i=nstrand,isheet+1,-1
	  do j=1,5
  	    nstres(i,j)=nstres(i-1,j)
          enddo
        enddo
        nstres(isheet+1,4)=nstres(isheet,4)
	idir=nstres(isheet,4)
	isi=nstres(isheet,5)
	ii=ipos+1-nstres(isheet,1)
	nstres(isheet+1,5)=idir*(-1)**ii
	nstres(isheet+1,1)=ipos+1
	nstres(isheet+1,2)=nstres(isheet,2)+ii*isi
	nstres(isheet,3)=ipos-1
      endif
      return
      end	
*******************************************************************
      subroutine buildsheet(jj,isig,whichend,found)
      include 'parcom.dat'
      logical found,whichend
      common /pept/ nres,nres1,nres2
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      common /sheets/ nstrand,nstres(maxres,5)
      common /sheet1/ i,k,ii,ib,iib,iidir,iiidir,iiid,iiiid,ic
      found=.false.
cd      write (2,*) 'buildsheet: iiid=',iiid,' iiiid=',iiiid,' isig=',isig
cd      write (2,*) 'iidir=',iidir,' iiidir=',iiidir,' ic=',ic
cd      write (*,*) 'buildsheet: iiid=',iiid,' iiiid=',iiiid,' isig=',isig
cd      write (*,*) 'iidir=',iidir,' iiidir=',iiidir,' ic=',ic
cd      do l=1,nres1
cd        write (2,'(16i5)') l,(icont(l,ll),ll=1,ncont(l))
cd      enddo
      if (iidir.eq.2 .and. iiidir.eq.2) then
cd	write (2,*) 'contacts',jj,':',(icont(jj,l),l=1,ncont(jj))
        call add2path(npath,jj,ic,whichend)
cd	write (2,*) 'contacts',jj,':',(icont(jj,l),l=1,ncont(jj))
        found=.true.
      elseif (iidir.eq.2) then
	iiid=isig*iiiid
	iidir=iiid*(-1)**(i-ib)
cd	write (2,*) 'contacts',jj,':',(icont(jj,l),l=1,ncont(jj))
        call add2path(npath,jj,ic,whichend)
cd	write (2,*) 'contacts',jj,':',(icont(jj,l),l=1,ncont(jj))
cd	write (2,*) npath,(ipath(npath,l),l=1,nmem(npath))
        found=.true.
	if (iidir.eq.-1) then
	  nnp=npath-(i-ib)
	  do l=nnp,npath
	    call invpath(l)
	  enddo
	endif    
cd	write (2,*) npath,(ipath(npath,l),l=1,nmem(npath))
	found=.true.
      elseif (iiidir.eq.2) then
        nstres(k,4)=isig*iiid*(-1)**(ii-iib)
cd	write (2,*) 'contacts',jj,':',(icont(jj,l),l=1,ncont(jj))
        call add2path(npath,jj,ic,whichend)
cd	write (2,*) 'contacts',jj,':',(icont(jj,l),l=1,ncont(jj))
        found=.true.
      elseif (iiid.eq.isig*iiiid) then
cd	write (2,*) 'buildsheet: jj=',jj,' whichend=',whichend
cd	write (2,*) 'contacts',jj,':',(icont(jj,l),l=1,ncont(jj))
        call add2path(npath,jj,ic,whichend)
cd	write (2,*) 'contacts',jj,':',(icont(jj,l),l=1,ncont(jj))
        found=.true.
      endif
      if (.not.found) then
        jj1=icont(jj,ic)
	call contpos(jj,jj1,ic1)
cd	write (2,*) 'jj=',jj,' ic=',ic,' jj1=',jj1,' ic1=',ic1
        if (ic.gt.0) then
          ncont(jj)=ncont(jj)-1
          do j=ic,ncont(jj)
            icont(jj,j)=icont(jj,j+1)
          enddo	
        endif	
        if (ic1.gt.0) then
	  ncont(jj1)=ncont(jj1)-1
	  do j=ic1,ncont(jj1)
	    icont(jj1,j)=icont(jj1,j+1)
	  enddo
	endif
      endif	    
      return
      end
**********************************************************
      function curvat(ii,jj,kk)
      include 'parcom.dat'
      common /atoms/ natoms,x(maxat,3),itype(maxat)
      common /geo/ pi,dwapi,conv,rad2deg
      do k=1,3
        x(natoms+1,k)=0.5*(x(ii,k)+x(ii+1,k))
        x(natoms+2,k)=0.5*(x(jj,k)+x(jj+1,k))
        x(natoms+3,k)=0.5*(x(kk,k)+x(kk+1,k))
      enddo
      curvat=alpha(natoms+1,natoms+2,natoms+3)/conv
      return
      end
***********************************************************
      subroutine delcont(ires,ic)
      include 'parcom.dat'
*
* Delete all the electrostatic contacts originated by peptide group ires 
* (that has already been found to originate a dipole-path element) 
* and all the electrostatic contacts that are directed at the peptide group 
* forming a dipole-path element with it (iic).
*      
      common /pept/ nres,nres1,nres2,inamp(maxres),gama(maxres),
     1 theta(maxres),alph(maxres),rrl(maxres)
      common /contact/ ncont(maxres),icont(maxres,max_cont)
cd      write (2,*) 'delcont: ires=',ires,' ic=',ic
      if (ic.le.0) return
      iic=icont(ires,ic)
      ncont(ires)=0
cd      write (2,*) 'iic=',iic
cd      write (2,*) 'ncont(ires)=',ncont(ires)
      call contpos(ires,iic,ic)
cd      write (2,*) 'ic=',ic
cd      write (2,*) 'ncont(iic)=',ncont(iic)
      if (ic.gt.0) then
        ncont(iic)=ncont(iic)-1
        do j=ic,ncont(iic)
          icont(iic,j)=icont(iic,j+1)
        enddo	
      endif	
cd      write (2,*) 'ncont(iic)=',ncont(iic)
      do i=1,nres1
        call contpos(iic,i,ic) 
cd	write (2,*) 'iic=',iic,' i=',i,' ic=',ic
        if (ic.gt.0) then
          ncont(i)=ncont(i)-1
cd	  write (2,*) 'ncont(i)=',ncont(i)
          do j=ic,ncont(i)
            icont(i,j)=icont(i,j+1)
          enddo
cd      write (2,*) 'ncont(iic)=',ncont(iic)
        endif	  
      enddo
cd      write (2,*) 'ncont(iic)=',ncont(iic)
      return
      end
************************************************************
      subroutine catpath(ip1,ip2)
      include 'parcom.dat'
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      nm1=nmem(ip1)
      nm2=nm1+nmem(ip2)
      do i=nm1+1,nm2
        ipath(ip1,i)=ipath(ip2,i-nm1)
      enddo
      nmem(ip1)=nm2
      npath=npath-1
      do ip=ip2,npath
        nmem(ip)=nmem(ip+1)
        do i=1,nmem(ip)
          ipath(ip,i)=ipath(ip+1,i)
        enddo
      enddo
      return
      end
***************************************************************
      logical function inpath(ires,ip,is,ie)
      include 'parcom.dat'
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      inpath=.false.
      do i=is,ie
        if (ipath(ip,i).eq.ires) then
          inpath=.true.
          return
        endif
      enddo
      return
      end	
***************************************************************
      subroutine propathf(ii)
      include 'parcom.dat'      
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      common /pept/ nres,nres1,nres2
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      nmemi=nmem(ii)
      kp=ipath(ii,nmemi-1)
      lp=ipath(ii,nmemi)
      nclp=ncont(lp)
      do while (nclp.gt.0)
        mp=icont(lp,1)
	call contdir(lp,mp,idir)
	if (idir.eq.1 .and. curvat(kp,lp,mp).gt.90.0) then
	  call add2path(ii,mp,1,.true.)
	  kp=lp
	  lp=mp
	  nclp=ncont(lp)
        else	  
	  nclp=nclp-1
	  ncont(lp)=nclp
	  do i=1,nclp
	    icont(lp,i)=icont(lp,i+1)
	  enddo
	endif
      enddo
      return
      end 	    
***************************************************************
      subroutine propathb(ii)
      include 'parcom.dat'      
      logical found
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      common /pept/ nres,nres1,nres2
      common /contact/ ncont(maxres),icont(maxres,max_cont)
      found=.true.
      do while (found)
        found=.false.
        ip=ipath(ii,1)
        jp=ipath(ii,2)
	do i=1,nres1
	  call contpos(ip,i,ic)
	  if (ic.gt.0) then
            call contdir(i,ip,idir)
            if (idir.eq.1 .and. curvat(i,ip,jp).gt.90.0) then
              call add2path(ii,i,ic,.false.)
	      found=.true.
	      goto 10
            else	  
              ncont(i)=ncont(i)-1
              do j=ic,ncont(i)
                icont(i,j)=icont(i,j+1)
              enddo
            endif
          endif
        enddo
   10 enddo	
      return
      end 	    
      
