C
C------------------------------------------------------------------------------
C
      function alpha(i1,i2,i3)
      include 'parcom.dat'
c
c  Calculates the planar angle between atoms (i1), (i2), and (i3).
c
      common /atoms/ natoms,cart(maxat,3)
      x12=cart(i1,1)-cart(i2,1)
      x23=cart(i3,1)-cart(i2,1)
      y12=cart(i1,2)-cart(i2,2)
      y23=cart(i3,2)-cart(i2,2)
      z12=cart(i1,3)-cart(i2,3)
      z23=cart(i3,3)-cart(i2,3)
      vnorm=sqrt(x12*x12+y12*y12+z12*z12)
      wnorm=sqrt(x23*x23+y23*y23+z23*z23)
      scalar=(x12*x23+y12*y23+z12*z23)/(vnorm*wnorm)
      if (abs(scalar).gt.1.0) scalar=0.99999*scalar/abs(scalar)
      alpha=acos(scalar)
      return
      end
C
C------------------------------------------------------------------------------
C
      function beta(i1,i2,i3,i4)
      include 'parcom.dat'
c
c  Calculates the dihedral angle between atoms (i1), (i2), (i3) and (i4)
c
      common /atoms/ natoms,cart(maxat,3)
      common /geo/ pi,dwapi,conv,rad2deg
      x12=cart(i1,1)-cart(i2,1)
      x23=cart(i3,1)-cart(i2,1)
      x34=cart(i4,1)-cart(i3,1)
      y12=cart(i1,2)-cart(i2,2)
      y23=cart(i3,2)-cart(i2,2)
      y34=cart(i4,2)-cart(i3,2)
      z12=cart(i1,3)-cart(i2,3)
      z23=cart(i3,3)-cart(i2,3)
      z34=cart(i4,3)-cart(i3,3)
      wx=-y23*z34+y34*z23
      wy=x23*z34-z23*x34
      wz=-x23*y34+y23*x34
      wnorm=sqrt(wx*wx+wy*wy+wz*wz)
      vx=y12*z23-z12*y23
      vy=-x12*z23+z12*x23
      vz=x12*y23-y12*x23
      vnorm=sqrt(vx*vx+vy*vy+vz*vz)
      if (vnorm.gt.1.E-7 .and. wnorm.gt.1.E-7) then
      scalar=(vx*wx+vy*wy+vz*wz)/(vnorm*wnorm)
      if (abs(scalar).gt.1.0) scalar=0.9999999*scalar/abs(scalar)
      angle=acos(scalar)
      else
      angle=pi
      endif 
      if (angle.le.0.0) angle=pi+angle
      tx=vy*wz-vz*wy
      ty=-vx*wz+vz*wx
      tz=vx*wy-vy*wx
      scalar=tx*x23+ty*y23+tz*z23
      if (scalar.lt.0.0) angle=-angle
      beta=angle
      return
      end
C
C------------------------------------------------------------------------------
C
      function dist(i1,i2)
      include 'parcom.dat'
c
c  Calculates the distance between atoms (i1) and (i2).
c
      common /atoms/ natoms,cart(maxat,3)
      x12=cart(i1,1)-cart(i2,1)
      y12=cart(i1,2)-cart(i2,2)
      z12=cart(i1,3)-cart(i2,3)
      dist=sqrt(x12*x12+y12*y12+z12*z12)
      return
      end
C
