      PROGRAM PHOENIX2
*
*  Version 2.0 extended to dipole alignment (not only dipole pairing)  
*  Newly derived formulas used 
*
*  /////////////////////  UNIX version - fall 1990  /////////////////
*
*  1/8/91 Proline residue treatment included
*
*  2/20/91 Continuation method implemented in evaluating the angles theta
*          Conservation of original virtual geometry included
*
*  May 1993 The segment GENPATH has been modified to perform automatic
*           construction of the dipole-path network, if requested.
*
*  6/28/93 Added the construction of files for the plotting of dipole-path
*          network.
*
      PARAMETER (NUNIT=5)
      include 'parcom.dat'
      LOGICAL OPTSH,OPTRE,FAIL,FAIL1,RDPATH,PRINTMAP,NOCALC,
     & CONTACTS_ONLY
      REAL KSI
*     INTEGER*2 ITYPE,IREF,IPATH,NLEFT,ILEFT
      CHARACTER*4 INAMP
      DIMENSION GAMAOLD(MAXRES),ROLD(MAXRES),THETA1(MAXRES),IA(5),
     1 THETA2(MAXRES),STEPKSI(MAXRES),STEPETA(MAXRES),STEPALPHA(MAXRES)
      INTEGER IUNIT(NUNIT)/1,2,7,8,3/,IRW(NUNIT)/1,4*0/,
     1 IOVRD(NUNIT)/0,0,3*1/
      CHARACTER*8 STAT(NUNIT) /'OLD',4*'UNKNOWN'/
      CHARACTER*64 
     1        DUMFNM(NUNIT) /'phoenix.dat','phoenix.out','phoenix.ang',
     2        'phoenix.pdb','error.msg'/
      CHARACTER*16 FORMA(NUNIT) /5*'FORMATTED'/
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      COMMON /OPTPAR/ NOPT,N1,IOPT(20),MXIT,TOLX,TOLG,TOLREC,OPTSH,OPTRE
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES),KSI(MAXRES),ETA(MAXRES),
     2 ROLD1(MAXRES)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /PARAM/ NSTEP,MAXIT,TOL,STABFAC
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      COMMON /POCHODNE/ NX,NY
      common /mapa/ pref
      character*16 pref
*
      CALL OPENUNITS(NUNIT,IUNIT,IRW,STAT,FORMA,IOVRD,DUMFNM)
*
* The following options can be entered either in the option string (after
* the "-" sign in the command line) or in input data:
*
* r or READ_PATHS - GENPATH will not construct the dipole-path network;
*                   they'll be read from the input file instead;
*
* nc or NO_CALC - the program will stop after GENPATH; it will not calculate
*                 the peptide-group rotation angles lambda;
*
* p or PRINT_CONTACT_MAP - GENPATH will construct files for plotting the
*                 electrostatic-contact map.
*
      INP=IUNIT(1)
      IOUT=IUNIT(2)
      IPUN=IUNIT(3)
      IERRO=IUNIT(5)
      print *,'Program PHOENIX2 started'
************
*  Read data and set up internal coordinates table
cd    print *,'calling START'
      CALL START(INP,IOUT,RDPATH,PRINTMAP,NOCALC,CONTACTS_ONLY)
cd    print *,'exit START'
      if (printmap) then
        ii=index(dumfnm(1),'.')
        pref=dumfnm(1)(1:ii-1)
      endif
cd    print *,'calling CART'
      CALL CART(FAIL)
cd    print *,'exit CART'
************
*  Construct or read hydrogen-bond topology (the dipole-path network)
cd    print *,'calling GENPATH'
      CALL GENPATH(INP,IOUT,RDPATH,PRINTMAP,NOCALC,CONTACTS_ONLY)
cd    print *,'exit GENPATH'
************
      CALL TRANSFER(NRES2,THETA,THETA1)
*       do i=1,nres1
*         i1=4*(i-1)+nres2+1
*         write (iout,'(i5,3f10.3)') i,d(i1,2),d(i1+1,2),alph(i)
*         write (*   ,'(i5,3f10.3)') i,d(i1,2),d(i1+1,2),alph(i)
*       enddo
      DO I=1,NRES1
        STEPKSI(I)=KSI(I)/NSTEP
        STEPETA(I)=ETA(I)/NSTEP
      ENDDO
      DO I=3,NRES2
        STEPALPHA(I)=(ALPH(I)-THETA(I))/NSTEP
        ALPH(I)=THETA(I)
      ENDDO 
      do i=1,nres1
        i1=4*(i-1)+nres2+1
        i2=i1+1
        d(i1,2)=0.0
        d(i2,2)=0.0
      enddo
*     DO ISTEP=1,NSTEP
* Change 5/14/92. Adaptive step length
      delta=1.0/nstep
      odcinek=0.0
      istep=0
      do while (odcinek.le.0.999999)
        ISTEP=ISTEP+1
        write (iout,*) 'ISTEP',ISTEP
        write (*   ,*) 'ISTEP',ISTEP
        do i=1,nres1
          i1=4*(i-1)+nres2+1
          i2=i1+1
          d(i1,2)=d(i1,2)+stepksi(i)
          d(i2,2)=d(i2,2)+stepeta(i)
        enddo
        DO I=3,NRES2
          ALPH(I)=ALPH(I)+STEPALPHA(I)
        ENDDO
*       do i=1,nres1
*         i1=4*(i-1)+nres2+1
*         write (iout,'(i5,3f10.3)') i,d(i1,2),d(i1+1,2),alph(i)
*         write (*   ,'(i5,3f10.3)') i,d(i1,2),d(i1+1,2),alph(i)
*       enddo
        do ii=1,nres2
          theta2(ii)=theta1(ii)
        enddo
        IF (ISTEP.EQ.1) GOTO 448
        DO II=1,NRES1
          ROLD(II)=RRL(II)
          ROLD1(II)=RRL(II)
        ENDDO
  448   difold=1000.0
        DO IT=1,MAXIT
          CALL ORIENT(IOUT,ISTEP)
          write (iout,*) 'Iteration #',it
          write (iout,*) 'Angles lambda after ORIENT:'
          write (iout,'(10f8.3)') (rrl(i)/conv,i=1,nres1)
          IF (NLEFT.GT.0 .OR. NDEP.GT.0) CALL ALIGN(IOUT)
          write (iout,*) 'Angles lambda after ALIGN:'
          write (iout,'(10f8.3)') (rrl(i)/conv,i=1,nres1)
          CALL DEPEN(IOUT)
          write (iout,*) 'Angles lambda after DEPEN:'
          write (iout,'(10f8.3)') (rrl(i)/conv,i=1,nres1)
          RRL(NRES1)=ANG(RRL(NRES1)+PI)
          IF (ISTEP.GT.1 .OR. IT.GT.1) THEN
          DO I=1,NRES1
            DELTANG=RRL(I)-ROLD(I)
            IF (DELTANG.GT.PI) THEN
              DELTANG=DELTANG-DWAPI
            ELSE IF (DELTANG.LT.-PI) THEN
              DELTANG=DELTANG+DWAPI
            ENDIF
            if (abs(deltang).gt.1.8) then
              write (2,*) 'Angle',i,' freezed (delta=',deltang/conv,')' 
              deltang=0.0
            endif
            RRL(I)=ANG(ROLD(I)+STABFAC*DELTANG)
          ENDDO
          ENDIF
          CALL THETEV(IOUT)
          write (iout,*) 'Iteration:',it
          write (iout,*) 'Angles lambda:'
          write (iout,'(10f8.3)') (rrl(i)/conv,i=1,nres1)
          write (iout,*) 'Angles theta'
          write (iout,'(10f8.3)') (theta(i),i=1,nres2)

          DIF=0.0
          DO I=3,NRES2
*           DIF=DIF+(THETA1(I)-THETA(I))**2
            difi=abs(theta1(i)-theta(i))
            if (difi.gt.dif) dif=difi
          ENDDO
*         DIF=SQRT(DIF)/NRES1
          IF (IPRINT.GT.0) WRITE (IOUT,10) IT,DIF 
          write (*,10) it,dif  
          if (dif.gt.difold) then
            do ii=1,nres2
              theta(ii)=theta1(ii)
            enddo
            do i=1,nres1
              rrl(i)=rold(i)
            enddo
            goto 447
          endif
          difold=dif
          IF (DIF .LT. TOL) GOTO 447   
          DO II=1,NRES1
            ROLD(II)=RRL(II)       
          ENDDO
          DO II=1,NRES2
            THETA(II)=STABFAC*THETA(II)+(1.0-STABFAC)*THETA1(II)
            THETA1(II)=THETA(II)
          ENDDO
          DO II=1,NRES2
            D(II,2)=THETA(II)
          ENDDO
          CALL LOCATE(1,NRES2,FAIL,IERRO)
          print *,'LOCATE called from main program fail',fail
        ENDDO
*
*---- Half down the increments, if the procedure fails to converge
*
        do ii=1,nres2
          theta1(ii)=theta2(ii)
        enddo
        do ii=1,nres1
          rold(ii)=rold1(ii)
        enddo
        if (delta.le.0.05) goto 447
        delta=0.5*delta
        do i=1,nres1
          i1=4*(i-1)+nres2+1
          i2=i1+1
          stepksi(i)=0.5*stepksi(i)
          stepeta(i)=0.5*stepeta(i)
          d(i1,2)=d(i1,2)-stepksi(i)
          d(i2,2)=d(i2,2)-stepeta(i)
        enddo
        do i=3,nres2
          stepalpha(i)=0.5*stepalpha(i)
          alph(i)=alph(i)-stepalpha(i)
        enddo
        goto 448
  447   CALL DISTFIT(IOUT,F0)
        CALL THETEV(IOUT)
        CALL ENERGY(ENG)
        odcinek=odcinek+delta
        print *,'odcinek=',odcinek
        write(iout, *) 'odcinek=',odcinek
cd      write (iout,*) 'Angles ksi and eta:'
cd      write (*   ,*) 'Angles ksi and eta:'
cd      do i=1,nres1
cd        i1=4*(i-1)+nres2+1
cd        i2=i1+1
cd        write (iout,'(i5,2f10.3)') i,d(i1,2),d(i2,2)
cd        write (*   ,'(i5,2f10.3)') i,d(i1,2),d(i2,2)
cd      enddo
        IF (IPRINT.GT.0)
     &  WRITE (IOUT,20) (INAMP(I),I,THETA(I+1),GAMA(I+1),
     &                   RRL(I)/CONV, I=1,NRES1)
        WRITE (IOUT,30) ENG
      ENDDO
      call thetev(iout)
      call depen(iout)
      do it=1,10  
        call distfit(iout,ff0)
        call thetev(iout)
        call depen(iout)
        if (abs((ff0-f0)/f0).lt.0.001) goto 449
        f0=ff0
      enddo
  449 sumwei=0.0
      do i=1,ny
        sumwei=sumwei+w(i)
      enddo
      f0=sqrt(f0/sumwei)
      write (iout,*) 'Final average distance discrepancy:',f0
      IF (IPRINT.EQ.0)
     &  WRITE (IOUT,20) (INAMP(I),I,THETA(I+1),GAMA(I+1),
     &                   RRL(I)/CONV, I=1,NRES1)
*
*  Build up the table of internal coordinates.
*
      DO K=1,NRES
        D(4*(K-1)+NRES2+1,3)=ANG(PI-RRL(K))/CONV
      ENDDO
      D(4*NRES+NRES2+1,3)=ANG(RRL(NRES1))/CONV
      DO K=1,NRES2
        D(K,2)=THETA(K)
        D(K,3)=GAMA(K)
      ENDDO   
************
*  Print final internal coordinates
*
C     CALL READGM(NATOMS+1,INP,IOUT,FAIL,FAIL1)
*
*  Calculate Cartesian coordinates.
*
      CALL CART(FAIL)
*  diagnostics
      do i=1,nres
        i1=4*(i-1)+nres2+1
        i2=i+1
        i3=i1+5
        write (iout,1111) i1,i2,i3,alpha(i1,i2,i3)/conv
        write (*,1111) i1,i2,i3,alpha(i1,i2,i3)/conv
      enddo    
 1111 format (' alpha(',i3,',',i3,',',i3,')=',f10.3) 
*
*  Calculate and print fi and psi angles.
*
      CALL FIPSI(IOUT,IPUN)
*
* Write final Cartesian coordinates in .pdb format
      do i=1,nres
        i1=4*(i-1)+nres2+1
        i2=i+1
        i3=i1+5
        il1=natoms+2*(i-1)+1
        il2=il1+1
        if (inamp(i+1).eq.'GLY ') then
          d(il1,1)=1.1
        else
          d(il1,1)=1.53
        endif
        d(il2,1)=1.1
        d(il1,2)=111.0
        d(il2,2)=109.5
        d(il1,3)=-120.0
        d(il2,3)=120.0
        iref(il1,1)=il1
        iref(il2,1)=il2
        iref(il1,2)=i2 
        iref(il2,2)=i2
        iref(il1,3)=i1 
        iref(il2,3)=i1
        iref(il1,4)=i3
        iref(il2,4)=i3
        iref(il1,5)=0
        iref(il2,5)=0
      enddo
      natoms=natoms+2*nres
      call cart(fail)
      ind=0
      ires=0
      do 555 i=0,nres1
        if (inamp(i+1).eq.'TER '.and.inamp(i+2).eq.'TER ') goto 555 
        ires=ires+1
        i1=4*(i-1)+nres2+1
        i2=i1+2
        i3=i+1
        i4=5*nres1+2*(i-1)+3
        i5=i4-1
        i6=i1+5
        i7=i6+2
        if (i.gt.0) then
          ind=ind+1
          write(8,360) ind,'N ',inamp(i+1),ires,(x(i1,j),j=1,3)
          ind=ind+1
          if (inamp(i+1).eq.'PRO ') then
            write(8,360) ind,'CD ',inamp(i+1),ires,(x(i2,j),j=1,3)
          else
            write(8,360) ind,'HN ',inamp(i+1),ires,(x(i2,j),j=1,3)
          endif
        endif
        ind=ind+1
        write(8,360) ind,'CA',inamp(i+1),ires,(x(i3,j),j=1,3)
        if (i.gt.0 .and. i.lt.nres1) then
          ind=ind+1
          write(8,360) ind,'HA',inamp(i+1),ires,(x(i4,j),j=1,3)
          ind=ind+1
          if (inamp(i+1).eq.'GLY ') then
            write(8,360) ind,'HB',inamp(i+1),ires,(x(i5,j),j=1,3)
          else
            write(8,360) ind,'CB',inamp(i+1),ires,(x(i5,j),j=1,3)
          endif
        endif
        if (i.lt.nres1) then
          ind=ind+1
          write(8,360) ind,'C ',inamp(i+1),ires,(x(i6,j),j=1,3)
          ind=ind+1
          write(8,360) ind,'O ',inamp(i+1),ires,(x(i7,j),j=1,3)
        endif
  555 continue
      write (2,'(a80)')
      write (2,'(10x,i5,28x,f10.5)') 1,eng
      write (2,'(a80)')
      do i=1,nres2
        write (2,'(3h CA,3(2x,f10.5,i3),3i5)') 
     1  (d(i,j),0,j=1,3),(iref(i,j),j=2,4)
      enddo
360   FORMAT('ATOM    ',T7,I5,T14,A2,T18,A3,T23,I4,T31,3F8.3)
   10 FORMAT ('ITERATION:',I4,' MEAN DIFFERENCE',F10.5)
   20 FORMAT (//'RESIDUE        THETA     GAMMA    LAMBDA'/
     1       200(A3,'[',I2,']',3X,3F10.2/)/)
   30 FORMAT ('FINAL ENERGY IS ',1PE15.5,' KCAL/MOL')        
      END
******************************************************************************
      SUBROUTINE DISTFIT(IOUT,F0)
      include 'parcom.dat'
      CHARACTER*4 INAMP
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES),KSI(MAXRES),ETA(MAXRES)
      COMMON /LOC/ NLIN,IREF(MAXRES,5),D(MAXRES,3)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /PARAM/ NSTEP,MAXIT,TOL,STABFAC,MAXMAR
      COMMON /POCHODNE/ NX,NY,DRDG(MAXRES2,MAXRES),DD(MAXRES2),
     1 H(MAXRES,MAXRES),XX(MAXRES)
      DIMENSION X(MAXRES),DIAGH(MAXRES),GAMAOLD(MAXRES)
      LOGICAL FAIL     
      RL=100.0
      CALL TRANSFER(NRES2,GAMA,GAMAOLD)
      F0=RDIF(GAMA,IOUT) 
      IF (IPRINT.GT.0) WRITE (IOUT,*) 'DISTFIT: F0=',F0 
      DO 1 IT=1,MAXIT 
        CALL RDERIV
        CALL HEVAL
*       do i=1,nx
*         write (iout,'(i3,8(1pe10.2))') i,(h(i,j),j=1,nx),xx(i)
*       enddo
        DO I=1,NX
          DIAGH(I)=H(I,I)
        ENDDO
        RL=RL/10.0
        DO IMAR=1,MAXMAR
          DO I=1,NX
            H(I,I)=DIAGH(I)+RL
          ENDDO
          CALL TRANSFER(NX,XX,X)
          CALL BANACH(NX,H,X) 
*         do i=1,nx
*           write (iout,*) 'x',i,' =',x(i)
*         enddo
          AIN=0.0
          DO I=1,NX
            AIN=AIN+ABS(X(I))
          ENDDO
          IF (AIN.LT.0.1*TOL .AND. RL.LT.1.0E-4) THEN
            WRITE (IOUT,*) 'DISTFIT: CONVERGENCE HAS BEEN ACHIEVED'
            WRITE (IOUT,*) 'F=',F0
            RETURN
          ENDIF
          DO I=4,NRES2
            GAMA(I)=GAMAOLD(I)+X(I-3)
          ENDDO
          F1=RDIF(GAMA,IOUT)
          IF (IPRINT.GT.1) WRITE (IOUT,*) 'IMAR=',IMAR,' RL=',RL,
     &               ' F1=',F1 
          IF (F1.LT.F0) THEN
            CALL TRANSFER(NRES2,GAMA,GAMAOLD)
            F0=F1
            GOTO 1
          ELSE IF (ABS(F1-F0).LT.1.0E-5) THEN  
            WRITE (IOUT,*) 'DISTFIT: CANNOT IMPROVE DISTANCE FIT'
            WRITE (IOUT,*) 'F=',F1
            RETURN
          ENDIF
          RL=RL*10.0
        ENDDO
        WRITE (IOUT,*) 'DISTFIT: MARQUARDT PROCEDURE HAS FAILED' 
        WRITE (IOUT,*) 'F=',F0
        CALL TRANSFER(NRES2,GAMAOLD,GAMA)
        DO I=4,NRES2
          D(I,3)=GAMA(I)
        ENDDO
        CALL LOCATE(1,NRES2,FAIL,3)
        print *,'LOCATE called in DISTFIT: fail=',fail
        RETURN
        IF (IPRINT.GT.0) WRITE (IOUT,*) 'IT=',IT,' AIN=',AIN,
     &    ' F=',F0
    1 CONTINUE 
      WRITE (IOUT,*) 'DISTFIT: FINAL F=',F0
      END  
******************************************************************************
      FUNCTION RDIF(GORBI,IOUT)
      include 'parcom.dat'
      DIMENSION GORBI(MAXRES)
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /POCHODNE/ NX,NY,DRDG(MAXRES2,MAXRES),DD(MAXRES2),
     1 H(MAXRES,MAXRES),X(MAXRES)
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      DIMENSION E12(3),R13(3),R24(3)
      LOGICAL FAIL     
      DO I=4,NRES2
        D(I,3)=GORBI(I)
      ENDDO
      CALL LOCATE(1,NRES2,FAIL,3)
      print *,'LOCATE called in RDIF fail=',fail
      SUMA=0.0
      IND=0
      DO I=1,NRES    
        DO J=I+3,NRES2
          IND=IND+1
          DIJ=DIST(I,J)
          SUMA=SUMA+W(IND)*(DIJ-D0(IND))**2
          DD(IND)=DIJ
        ENDDO
      ENDDO
      RDIF=SUMA
      RETURN
      END 
******************************************************************************
      SUBROUTINE RDERIV        
      include 'parcom.dat'
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /POCHODNE/ NX,NY,DRDG(MAXRES2,MAXRES),DD(MAXRES2),
     1 H(MAXRES,MAXRES),X(MAXRES)
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      DIMENSION E12(3),R13(3),R24(3),PROD(3)
      LOGICAL FAIL     
      DO I=1,NY
        DO J=1,NX
          DRDG(I,J)=0.0
        ENDDO
      ENDDO
      DO I=1,NX
        I1=I+1
        I2=I+2
        CALL VEC(I1,I2,E12)
        DO J=1,I
          DO K=1,3
            R13(K)=XYZ(J,K)-XYZ(I1,K)
          ENDDO
          DO K=I2+1,NRES2
            DO L=1,3
              R24(L)=XYZ(K,L)-XYZ(I2,L)
            ENDDO
            IND=((J-1)*(2*NRES2-J-6))/2+K-3
            PROD(1)=R13(2)*R24(3)-R13(3)*R24(2)
            PROD(2)=R13(3)*R24(1)-R13(1)*R24(3)
            PROD(3)=R13(1)*R24(2)-R13(2)*R24(1)
            DRDG(IND,I)=CONV*SCALAR(E12,PROD)/DIST(J,K)
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END
******************************************************************************
      SUBROUTINE HEVAL
      include 'parcom.dat'
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
      COMMON /POCHODNE/ NX,NY,B(MAXRES2,MAXRES),DD(MAXRES2),
     1 H(MAXRES,MAXRES),X(MAXRES)
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      DO I=1,NX
        XI=0.0
        HII=0.0
        DO K=1,NY
          BKI=B(K,I)
          BKIWK=W(K)*BKI
          XI=XI+BKIWK*(D0(K)-DD(K))
          HII=HII+BKI*BKIWK
        ENDDO
        H(I,I)=HII
        X(I)=XI
        DO J=I+1,NX
          HIJ=0.0
          DO K=1,NY
            HIJ=HIJ+B(K,I)*B(K,J)*W(K)
          ENDDO
          H(I,J)=HIJ
          H(J,I)=HIJ
        ENDDO
      ENDDO
      RETURN
      END
******************************************************************************
      SUBROUTINE OPT(IOUT,ENG)
      COMMON /OPTPAR/ NOPT,N1,IOPT(20),MXIT,TOLX,TOLG,TOLREC,OPTSH,REST
      LOGICAL OPTSH,REST
      write(2,*) mxit,tolx,tolg,tolrec,optsh,rest
*     CALL DFP(IOUT,10,50,MXIT,TOLX,TOLG,TOLREC,.FALSE.,1,LINT,*1)
    1 CALL ENERGY(ENG)
      RETURN 
      END
******************************************************************************
      SUBROUTINE THETEV(IOUT)
      include 'parcom.dat'
*     INTEGER*2 ITYPE,IREF
      CHARACTER*4 INAMP
      REAL KSI,KSID
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      DO I=3,NRES2
        RL1=RRL(I-2)
        RL2=ALAM2(I-1)
        THETA(I)=THET(I,RL1,RL2)
      ENDDO
      RETURN
      END
******************************************************************************  
      FUNCTION THET(I,RL1,RL2)  
      include 'parcom.dat'
*     INTEGER*2 ITYPE,IREF
      REAL KSI,KSID
      CHARACTER*4 INAMP
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
C
      IF (INAMP(I-1).EQ.'TER '.AND.(INAMP(I-2).EQ.'TER '.OR.
     &    INAMP(I).EQ.'TER ')) THEN  
        THET=THETA(I)
        RETURN
      ENDIF
      I1=4*(I-3)+NRES2+1
      I2=I1+5 
      KSI=D(I1,2)*CONV
      ETA=D(I2,2)*CONV
*     print *,i,rl1/conv,rl2/conv,ksi/conv,eta/conv,alpha(i)
      COSKSI=COS(KSI)
      SINKSI=SIN(KSI)
      COSETA=COS(ETA)
      SINETA=SIN(ETA)
      COSL1=COS(RL1)
      SINL1=SIN(RL1)
      COSL2=COS(RL2)
      SINL2=SIN(RL2)
      COSALF=COS(ALPHA(I)*CONV)
      BB=-SINKSI*COSETA*COSL1-COSKSI*SINETA*COSL2
      AA=COSKSI*COSETA-SINKSI*SINETA*COSL1*COSL2
      CC=-SINKSI*SINETA*SINL1*SINL2-COSALF
      DELTA=SQRT(AA*AA+BB*BB-CC*CC)
      IF (DELTA.LT.0.0) DELTA=0.0
      T1=-ATAN2((BB+DELTA),(CC-AA))
      T2=-ATAN2((BB-DELTA),(CC-AA))
      IF (T1.LT.0.0) T1=T1+PI
      IF (T2.LT.0.0) T2=T2+PI
      T1=2.0*T1
      T2=2.0*T2
      T=T1
*     print *,i,t1/conv,t2/conv
*     pause
      IF (T1.GT.PI) T=T2
      THET=T/CONV
*     print *,acos(aa*cos(t)+bb*sin(t)-sinksi*sineta*sinl1*sinl2)/conv
      RETURN
      END
******************************************************************************
      SUBROUTINE FIPSI(IOUT,IPUN)
      include 'parcom.dat'
      REAL KSI,KSID
      CHARACTER*4 INAMP
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /SADDAM/ FIPSICHI(MAXRES,10)
      WRITE (IOUT,90)
   90 FORMAT ('RESIDUE               PHI                PSI'/50(1H-))
      DO 1 I=1,NRES
        I1=4*I+NRES2+1
        I2=4*I+NRES2+2
        I3=I+1
        I4=4*(I-1)+NRES2+1
        I5=4*(I-1)+NRES2+2
        FIPSICHI(I+1,1)=BETA(I2,I3,I4,I5)/CONV
        FIPSICHI(I+1,2)=BETA(I1,I2,I3,I4)/CONV
        WRITE(IOUT,100) INAMP(I+1),I+1,FIPSICHI(I+1,1),FIPSICHI(I+1,2)
    1 CONTINUE
  100 FORMAT (A3,'[',I3,']',10X,F10.3,10X,F10.3)
      WRITE (IPUN,'(10F8.3)') ( (FIPSICHI(I,J),J=1,10),I=1,NRES2)
      RETURN
      END
******************************************************************************
      SUBROUTINE START(INP,IOUT,RDPATH,PRINTMAP,NOCALC,CONTACTS_ONLY)
C
C  This subroutine reads in the peptide geometry parameters (i.e. the
C  angles theta and gama), optionally other peptide backbone parameters,
C  and the remaining geometry (for example that of the sidechains).
C
      include 'parcom.dat'
      LOGICAL FAIL,FAIL1,DIHED,CLOSES,OPTSH,OPTRE,RDPATH,PRINTMAP,
     &        NOCALC,CONTACTS_ONLY,DUMMY_N_TERM,DUMMY_C_TERM
*     INTEGER*2 ICODE,ITYPE,IR,IBOND,ITORS,NAME,IREF
      REAL KSI,KSID
      CHARACTER*4 INAMP 
      CHARACTER*80 CONTROLCARD,TITLE,ucase
      DIMENSION IPAIR(100,2),WPAIR(100)
      COMMON /PARAM/ MAXSTEP,MAXIT,TOL,STABFAC,MAXMAR
      COMMON /OPTPAR/ NOPT,N1,IOPT(20),MXIT,TOLX,TOLG,TOLREC,OPTSH,OPTRE
      COMMON /DRUK/ IPRINT
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPH(MAXRES),RRL(MAXRES),KSI(MAXRES),ETA(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /BND/ NBOND,NVDW,IBOND(MAXAT,2)
      COMMON /DSULF/ DIHED,CLOSES,DSS,ALCSS,BECSSC,AINCFI,ILOC(6,10)
      COMMON /NAMAT/ NAME(30)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
      COMMON /POCHODNE/ NX,NY,DRDG(MAXRES2,MAXRES),DD(MAXRES2),
     1     H(MAXRES,MAXRES),XX(MAXRES)
      COMMON /WAGI/ W(MAXRES2),D0(MAXRES2)
      COMMON /SADDAM/ FIPSICHI(MAXRES,10)
      COMMON /ELEC/ IEL12
      COMMON /HEADER/ TITLE
      character*4 one_to_three
      common /cmdlopt/ optstring
      character*16 optstring
      dimension bls(4,4),aksis(4,4),aetas(4,4)
      character*8 form
      data alphgly /111.0/,alphpro /111.0/
      data bls/8*3.785,4*3.810,3*3.875,0.0/,
     &   aksis/14.93,2*14.94,14.93,14.92,14.95,2*14.93,
     &         15.30,15.32,15.31,15.30,3*14.93,0.0/,
     &   aetas/4*20.95,20.95,20.95,20.96,20.95,4*20.31,3*20.95,0.0/

      ALCSS=CONV*ALCSS
      BECSSC=CONV*BECSSC
      READ (INP,'(a)') TITLE
      WRITE (IOUT,'(a)') TITLE
 2000 FORMAT (20A4)
      read (inp,'(a80)') controlcard
      controlcard=ucase(controlcard)
      nocalc=(index(controlcard,'NO_CALC').gt.0 
     &   .or. index(optstring,'nc').gt.0)
      rdpath=(index(controlcard,'READ_PATHS').gt.0
     &   .or. index(optstring,'r').gt.0)
      printmap=(index(controlcard,'PRINT_CONT_MAP').gt.0 
     &   .or. index(optstring,'p').gt.0)
      contacts_only=(index(controlcard,'CONTACTS_ONLY').gt.0
     &   .or. index(optstring,'co') .gt.0)
      READ (INP,*) NRES,IPRINT,IWEI,IEL12
      NRES1=NRES+1
      NRES2=NRES+2
      NBOND=5*NRES1
      NATOMS=5*NRES1+1
      if (index(controlcard,'ONE_LETTER').gt.0) then
        read (inp,'(80a1)') (inamp(i)(1:1),i=1,nres2)
        do i=1,nres2
         inamp(i)=one_to_three(inamp(i))
        enddo
      else
        READ (INP,'(20A4)') (INAMP(I),I=1,NRES2)
      endif
C
C Interface to ECEPP
C Assign extended conformations to backbone & side chains
C
      do i=1,nres1
        do j=1,10
          fipsichi(i,j)=180.0
        enddo
        fipsichi(i,4)=-120.0
      enddo
C
C  NRES - the number of residues (excluding the blocking groups)       
C  NRES1- the number of peptide bonds                            
C  NRES2- the number of peptide bond vertices (including the blocking groups)
C
C  Determine fixed geometry parameters
C
      alph(1)=0.0
      alph(2)=0.0
      do i=1,nres1
        if (inamp(i).eq.'GLY ') then
          alph(i+1)=alphgly
        else if (inamp(i).eq.'PRO ') then
          alph(i+1)=alphpro
        else
          alph(i+1)=alphad
        endif
      enddo
C
C Read in virtual-chain geometry 
C
      READ (INP,'(A8)') FORM

      IF (INDEX(FORM,'MOPAC').GT.0) THEN

      DO I=1,NRES2
        READ (INP,1030) D(I,1),THETA(I),GAMA(I)
        IF (D(I,1).LE.3.4) D(I,1)=BLCCD
        D(I,2)=THETA(I)
        D(I,3)=GAMA(I)
      ENDDO

      ELSE IF (INDEX(FORM,'ZIP').GT.0) THEN

      DO I=1,NRES2
        D(I,1)=3.8
C        D(I,2)=90.0
C        THETA(I)=90.0
      ENDDO
      D(1,1)=0.0
      D(1,2)=0.0
      THETA(1)=0.0
      D(2,2)=0.0
      THETA(2)=0.0
      D(1,3)=0.0
      D(2,3)=0.0
      D(3,3)=0.0
      GAMA(1)=0.0
      GAMA(2)=0.0
      GAMA(3)=0.0
C 6/29/98 - Read the THETA angles too
      READ (INP,'(8F10.5)') (THETA(I),I=3,NRES2)
      READ (INP,'(8F10.5)') (GAMA(I),I=4,NRES2)
C 6/29/98
      DO I=3,NRES2
        D(I,2)=THETA(I)
      ENDDO
      DO I=4,NRES2
        D(I,3)=GAMA(I)
      ENDDO

      ELSE IF (INDEX(FORM,'PDB').GT.0) THEN

      ISREAD=2
      IEREAD=NRES1
      dummy_n_term=(INAMP(1).EQ.'D')
      dummy_c_term=(INAMP(NRES2).EQ.'D')
      IF (.not.dummy_n_term) ISREAD=1       
      IF (.not.dummy_c_term) IEREAD=NRES2
      READ (INP,'(30X,3F8.3)') ((X(I,J),J=1,3),I=ISREAD,IEREAD)

      DO I=ISREAD+3,IEREAD
        D(I,1)=DIST(I,I-1)
        D(I,2)=ALPHA(I,I-1,I-2)/CONV
        D(I,3)=BETA(I,I-1,I-2,I-3)/CONV
      ENDDO
      D(1,1)=0.0
      if (dummy_n_term) then
        D(2,1)=3.8
        D(4,1)=DIST(3,4)
      else
        D(2,1)=DIST(1,2)
      endif
      D(3,1)=DIST(2,3)
      D(1,2)=0.0
      D(2,2)=0.0
      if (dummy_n_term) then
        D(3,2)=106.3
        D(4,2)=ALPHA(2,3,4)/CONV
      else
        D(3,2)=ALPHA(1,2,3)/CONV
      endif
      D(1,3)=0.0
      D(2,3)=0.0
      D(3,3)=0.0 
      if (dummy_n_term) D(4,3)=180.0
      if (dummy_c_term) then
        D(NRES2,1)=3.8
        D(NRES2,2)=106.3
        D(NRES2,3)=180.0
      endif
      DO I=1,NRES2
        THETA(I)=D(I,2)
        GAMA(I)=D(I,3)
      ENDDO

      ELSE

      WRITE(IOUT,'(2a)')'Illegal format specification for virtual ',
     & 'geometry; program stopped.' 
      stop 

      ENDIF
               
*******************
* Changes on 1/8/91 (proline treatment)
*******************
      DO I=1,NRES2
        IPRO(I)=0
      ENDDO

      DO I=1,NRES2
        IF (INAMP(I).EQ.'Pro' .OR. INAMP(I).EQ.'PRO') IPRO(I)=1
        IF (INAMP(I).EQ.'pro') IPRO(I)=-1
      ENDDO
********************
 1030 FORMAT (3X,F12.5,3X,F12.5,3X,F12.5)
      WRITE (IOUT,2010) NRES,NATOMS
      DO 6 I=1,NRES2
    6   WRITE (IOUT,2020) INAMP(I),I,D(I,1),THETA(I),GAMA(I),ALPH(I)
      WRITE (IOUT,2030)
 2010 FORMAT(80(1H*)//'The peptide contains',I4,' residues',
     1 ' and',I4,' backbone atoms.'//80(1H*)//'residue',2X,'vb length',
     2 6X,'theta',6X,'gamma',7X,'alpha'/80(1H-)/)
 2020 FORMAT (A3,'(',I3,')',5X,F5.3,5X,F6.2,5X,F6.1,6X,F6.1)
 2030 FORMAT (80(1H-)//)
C
C  Generate the part of the location table (IREF) corresponding
C  to the peptide shape
C
  222 NREACT=NREACT+1
      IREF(1,1)=1
      IREF(2,1)=2
      IREF(2,2)=1
      IREF(3,1)=3
      IREF(3,2)=2
      IREF(3,3)=1
      IF (NRES2.LT.4) GOTO 4
      DO 3 I=4,NRES2
        DO 33 J=1,4
   33     IREF(I,J)=I-J+1
    3 CONTINUE
C
C  Assign types for atoms of the peptide backbone, reads the
C  geometry parameters necessary to locate the rest of the backbone
C  as well as constructs a part of the bond table.
C
C   4 READ (INP,1010) ITYPE(1)
    4 itype(1)=1
      DO 2 I=1,NRES1
        ITY1=1
        IF (INAMP(I).EQ.'GLY ') THEN
          ITY1=2
        ELSE IF (INAMP(I).EQ.'PRO ') THEN
          ITY1=3
        ELSE IF (INAMP(I).EQ.'TER ') THEN
          ITY1=4
        ENDIF
        ITY2=1
        IF (INAMP(I+1).EQ.'GLY ') THEN
          ITY2=2
        ELSE IF (INAMP(I+1).EQ.'PRO ') THEN
          ITY2=3
        ELSE IF (INAMP(I+1).EQ.'TER ') THEN
          ITY2=4
        ENDIF
C       READ (INP,1010) ITC1,ITN,ITC,ITH,ITO,
C    1  BLCN,BLNC,KSI(I),ETA(I),BLNH,ALCNH,BLCO,ALCCO
 1010 FORMAT (5I5/8F10.5)
        ITC=ITCD
        ITN=ITND
        ITC1=ITC1D
        ITH=ITHD
        ITO=ITOD
        BLCN=BLCND
        BLNC=BLNCD
        KSI(I)=AKSIS(ITY1,ITY2)
        ETA(I)=AETAS(ITY1,ITY2)
        BLNH=BLNHD
        ALCNH=ALCNHD
        BLCO=BLCOD
        ALCCO=ALCCOD
        I1=I+1
        ITYPE(I1)=ITC1
        I1=4*(I-1)+NRES2+1
        I2=I1+1
        I3=I1+2
        I4=I1+3
        II1=5*(I-1)+1
        II2=II1+1
        II3=II2+1
        II4=II3+1
        II5=II4+1
        IBOND(II1,1)=I+1
        IBOND(II1,2)=I1
        IBOND(II2,1)=I1
        IBOND(II2,2)=I2
        IBOND(II3,1)=I2
        IBOND(II3,2)=I
        IBOND(II4,1)=I1
        IBOND(II4,2)=I3
        IBOND(II5,1)=I2
        IBOND(II5,2)=I4
        ITYPE(I1)=ITN
        ITYPE(I2)=ITC
        ITYPE(I3)=ITH
        ITYPE(I4)=ITO
        IREF(I1,1)=I1
        IREF(I2,1)=I2
        IREF(I3,1)=I3
        IREF(I4,1)=I4
        IREF(I1,2)=I+1
        IREF(I2,2)=I
        IREF(I3,2)=I1
        IREF(I4,2)=I2
        IREF(I1,3)=I
        IREF(I2,3)=I+1
        IREF(I3,3)=I+1
        IREF(I4,3)=I
        IREF(I3,4)=I
        IREF(I4,4)=I+1
        IREF(I2,4)=I1
        IREF(I1,4)=I+2
        IF (I.EQ.NRES1) IREF(I1,4)=I-1
        D(I1,1)=BLCN
        D(I1,2)=KSI(I)
        D(I1,3)=180.
        D(I2,1)=BLNC
        D(I2,2)=ETA(I)
        D(I2,3)=180.
        D(I3,1)=BLNH
        D(I3,2)=ALCNH
        D(I3,3)=180.
        D(I4,1)=BLCO
        D(I4,2)=ALCCO
    2   D(I4,3)=180.
      OPTRE=.FALSE.
      OPTSH=.FALSE.
C
C Read in parameters that control the iterative process
C
      READ (INP,*) MAXSTEP,MAXIT,TOL,STABFAC,MAXMAR   
      IF (MAXSTEP.EQ.0) MAXSTEP=20
      IF (MAXIT.EQ.0) MAXIT=20
      IF (TOL.EQ.0) TOL=0.5  
      IF (STABFAC.EQ.0) STABFAC=1.0
      IF (MAXMAR.EQ.0) MAXMAR=10
      WRITE (IOUT,2050) MAXSTEP,MAXIT,TOL,STABFAC,MAXMAR  
 2050 FORMAT (/'Max. number of continuation-method steps:',I3/      
     1         'Max. number of iterations in theta angle adjusting:',I3/
     2         'Tolerance in theta angle adjusting (deg):',F8.2/
     3         'Stability factor in theta angle adjusting:',F8.2/
     4         'Max. number of Marquardt iterations:',I3/)
      if (iel12.gt.0) write (iout,*) 'Electrostatic interactions ',
     &'between the neighboring centers included.'
      if (iel12.le.0) write (iout,*) 'Electrostatic interactions ',
     &'between the neighboring centers discarded.'
      READ (INP,*) NPAIR
      write (iout,*)
      if (npair.gt.0)
     & WRITE (IOUT,'(a,i5,a)') 
     & 'There are',NPAIR,' distances to be weighed specially'
      DO I=1,NPAIR
        READ (INP,*) IPAIR(I,1),IPAIR(I,2),WPAIR(I)
        WRITE (IOUT,*) IPAIR(I,1),IPAIR(I,2),WPAIR(I)
      ENDDO
*
*  Calculate Cartesian coordinates of the shape.
*
      fail=.false.
      CALL LOCATE(1,NRES2,FAIL,3)
      print *,'LOCATE called from START: fail=',fail
      IF (FAIL) STOP
      NX=NRES-1
      NY=((NRES-2)*(NRES-3))/2
      write (2,*) 'nx=',nx,' ny=',ny
*     do i=1,nres1
*       do j=i+1,nres2
*         write (iout,'(2i5,f10.5)') i+1,j+1,dist(i,j)
*       enddo
*     enddo
*     stop
      IND=0
      DO I=1,NRES-1
        DO J=I+3,NRES2
          IND=IND+1
          D0(IND)=DIST(I,J)
          W(IND)=1.0
          IF (IWEI.GT.0) W(IND)=1.0/D0(IND)**2
          DO K=1,NPAIR
            IF (IPAIR(I,1).EQ.I .AND. IPAIR(I,2).EQ.J) THEN
              W(IND)=WPAIR(K)**2
              GOTO 224
            ENDIF
          ENDDO
  224     CONTINUE
        ENDDO
      ENDDO
      DO I=2,NRES2
        ITY1=1
        IF (INAMP(I-1).EQ.'GLY ') THEN
          ITY1=2
        ELSE IF (INAMP(I-1).EQ.'PRO ') THEN
          ITY1=3
        ELSE IF (INAMP(I-1).EQ.'TER ') THEN
          ITY1=4
        ENDIF
        ITY2=1
        IF (INAMP(I).EQ.'GLY ') THEN
          ITY2=2
        ELSE IF (INAMP(I).EQ.'PRO ') THEN
          ITY2=3
        ELSE IF (INAMP(I).EQ.'TER ') THEN
          ITY2=4
        ENDIF
        IF (ITY1+ITY2.LT.8) D(I,1)=BLS(ITY1,ITY2)
      ENDDO
      RETURN
      END
******************************************************************************
      character*(*)function one_to_three(one_letter_code)
      character*1 ucase
      character*1 one_letter_code,aux
      character*1 one(21)
      character*4 three(21)
      character*4 lcase
      data one 
     & /'A',  'R',  'N',  'D',  'C',  'E',  'Q',  'G',  'H',  'I',
     &  'L',  'K',  'M',  'F',  'P',  'S',  'T',  'W',  'Y',  'V',  'X'/
      data three
     & /'ALA','ARG','ASN','ASP','CYS','GLU','GLN','GLY','HIS','ILE',
     &  'LEU','LYS','MET','PHE','PRO','SER','THR','TRP','TYR','VAL',
     &  'D  '/
      aux=ucase(one_letter_code)
      i=1
      do while (aux.ne.one(i) .and. i.lt.21)
        i=i+1
      enddo    
      if (aux.ne.one_letter_code) then
        one_to_three=lcase(three(i))
      else
        one_to_three=three(i)
      endif
      return 
      end 
******************************************************************************
      SUBROUTINE COEFFT(IOUT,ISTEP)
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NLEFT,ILEFT
      CHARACTER*4 INAMP
      LOGICAL FAIL
      REAL LAM0,LAMB1,LAMB2,L2OLD
      DIMENSION U1(3),V1(3),W1(3),U2(3),V2(3),W2(3),ER(3),AUX(3)
      dimension uaux(3),vaux(3)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U(3),ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      COMMON /APPROX/ LAM0(maxpath,maxlength)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /DRUK/ IPRINT
*
*  Loop over paths
*
      DO 1 IP=1,NPATH
        LENGTH=NMEM(IP)
	II=IPATH(IP,1)
	X1=0.5*(X(II)+X(II+1))
	Y1=0.5*(Y(II)+Y(II+1))
	Z1=0.5*(Z(II)+Z(II+1))
 3333 format (' ip=',i2,'i=',i2,' j=',i2,' x=',f10.5,' y=',f10.5,
     1        ' z=',f10.5,' ref.sys. ',3i4)	
	I4=II+2
	IF (I4.GT.NRES2) THEN
	  I2=II+1
	  I3=II
	  I4=II-1
	ELSE
	  I2=II
	  I3=II+1
	ENDIF    
*       write (iout,3333) ip,1,ii,x1,y1,z1,i2,i3,i4
	call vec(i3,i2,uaux)
	CALL REFSYS(FAIL,3)
	DO 11 I=1,3
	  U1(I)=E1(I)
	  V1(I)=E2(I)
	  W1(I)=E3(I)
   11   CONTINUE  	  
	DO 2 J=2,LENGTH
	  JJ=IPATH(IP,J)
          X2=0.5*(X(JJ)+X(JJ+1))
          Y2=0.5*(Y(JJ)+Y(JJ+1))
          Z2=0.5*(Z(JJ)+Z(JJ+1))
          I4=JJ+2
	  IF (I4.GT.NRES2) THEN
	    I2=JJ+1
	    I3=JJ
	    I4=JJ-1
	  ELSE
	    I2=JJ
	    I3=JJ+1
	  ENDIF    
*         write(iout,3333) ip,j,jj,x2,y2,z2,i2,i3,i4
	  CALL REFSYS(FAIL,3)
	  AUX(1)=X2-X1
	  AUX(2)=Y2-Y1
	  AUX(3)=Z2-Z1
	  RR=SQRT(SCALAR(AUX,AUX))
	  DO 22 K=1,3
   22       AUX(K)=AUX(K)/RR	  	    
          U2(1)=SCALAR(U1,E1)
	  U2(2)=SCALAR(V1,E1)
	  U2(3)=SCALAR(W1,E1)
	  V2(1)=SCALAR(U1,E2)
	  V2(2)=SCALAR(V1,E2)
	  V2(3)=SCALAR(W1,E2)
	  W2(1)=SCALAR(U1,E3)
	  W2(2)=SCALAR(V1,E3)
	  W2(3)=SCALAR(W1,E3)
*         write (iout,3334) u2(1),u2(2),u2(3),v2(1),v2(2),v2(3),w2(1),
*    1 	  w2(2),w2(3)
 3334 format (' u=',3f10.5/' v=',3f10.5/' w=',3f10.5)
	  ER(1) = SCALAR(U1,AUX)
	  ER(2) = SCALAR(V1,AUX)
	  ER(3) = SCALAR(W1,AUX)
	  ERV2  = SCALAR(ER, V2)
	  ERW2  = SCALAR(ER, W2)
*         write (iout,3335) er(1),er(2),er(3),erv2,erw2
 3335 format (' er=',3f10.5,' erv2=',f10.5,' erw2=',f10.5)	  
	  Q11   = V2(2)-3.0*ERV2*ER(2)
	  Q12   = W2(2)-3.0*ERW2*ER(2)
	  Q21   = V2(3)-3.0*ERV2*ER(3)
	  Q22   = W2(3)-3.0*ERW2*ER(3)
          FI0(IP,J-1) =ATAN2(Q12+Q21,Q11-Q22)
          PSI0(IP,J-1)=ATAN2(Q21-Q12,Q11+Q22)
*
*  Determine starting angles for alignment procedure
*
	  LAMB1=ANG(0.5*( FI0(IP,J-1)+PSI0(IP,J-1) ) + PI)
	  LAMB2=ANG(0.5*( FI0(IP,J-1)-PSI0(IP,J-1) ))
*         write ( iout,4446) lamb1/conv,lamb2/conv
 4446 format (' theta1=',f10.3,' theta2=',f10.3)	  
*
*  Determine dipole alignment with path direction
*
          PER=ER(2)*COS(LAMB1)+ER(3)*SIN(LAMB1)
*         print *,'er(2)=',er(2),' er(3)=',er(3),' coslam=',cos(lamb1),
*    1    ' sinlam=',sin(lamb1),' per=',per	  
	  IF (PER .LT. 0.0) THEN
	    LAMB1=ANG(LAMB1+PI)
	    LAMB2=ANG(LAMB2+PI)
	  ENDIF
*         if (istep.eq.1) then
	  IF (J.GT.2) THEN
            DELTAL=LAMB1-L2OLD
            IF (DELTAL.GT.PI) DELTAL=DELTAL-DWAPI
            LAM0(IP,J-1)=L2OLD+0.5*DELTA
*           LAM0(IP,J-1)=0.5*(LAMB1+L2OLD)  
	    L2OLD=LAMB2
	  ELSE
	    LAM0(IP,J-1)=LAMB1
	    L2OLD=LAMB2
	  ENDIF    
*         endif
	  AUX1=Q11*Q11+Q12*Q12+Q21*Q21+Q22*Q22
	  AUX2=2.0*(Q11*Q22-Q12*Q21)
*	  print *,'q11=',q11,' q12=',q12,' q21=',q21,' q22=',q22
*	  print *,'aux1=',aux1,' aux2=',aux2
	  ZPLUS(IP,J-1)=100.0*SQRT(AUX1-AUX2)/(RR*RR*RR)
	  ZMINUS(IP,J-1)=100.0*SQRT(AUX1+AUX2)/(RR*RR*RR)
*          cosa=u2(1)
*	  cosb=er(1)
*	  cosg=scalar(er,u2)
*         call vec(i3,i2,vaux)
*         anorm1=sqrt(scalar(uaux,uaux))
*         anorm2=sqrt(scalar(vaux,vaux))
*         cosa=scalar(uaux,vaux)/(anorm1*anorm2)
*         cosb=scalar(aux,uaux)/anorm1
*         cosg=scalar(aux,vaux)/anorm2
*         fac1=cosa-3.0*cosb*cosg
*         fac2=cosb+cosg
*         fac3=cosb-cosg
*         fac4=rr*rr*rr/100.0
*         zzp=sqrt( 4.0*(1.0+cosa) + fac1*fac1 - 3.0*fac2*fac2 ) / fac4
*         zzm=sqrt( 4.0*(1.0-cosa) + fac1*fac1 - 3.0*fac3*fac3 ) / fac4
*         write (  * ,5555) ip,j,cosa,cosb,cosg,fac1,zzp,zzm
*         write (iout,5555) ip,j,cosa,cosb,cosg,fac1,zzp,zzm
*5555 format (' path ',i2,' j=',i2,'cosa=',f10.5,' cosb=',f10.5,
*    1 ' cosg=',f10.5,' fac1=',f10.5,' zzp=',f10.5,' zzm=',f10.5 ) 	  
	  X1=X2
	  Y1=Y2
	  Z1=Z2
          DO 12 I=1,3
	    U1(I)=E1(I)
	    V1(I)=E2(I)
	    W1(I)=E3(I)
   12     CONTINUE  	  
          CALL TRANSFER(3,VAUX,UAUX)
    2   CONTINUE  
        LAM0(IP,LENGTH)=LAMB2
*       if(istep.eq.1) lam0(ip,length)=lamb2
    1 CONTINUE
      IF (IPRINT.GT.0) THEN
      DO 222 IP=1,NPATH
        LENGTH=NMEM(IP)
        WRITE (*,2221) IP
        WRITE (IOUT,2221) IP
        WRITE ( *  ,2222) (INAMP(IPATH(IP,I)),IPATH(IP,I),
     1  ZPLUS(IP,I),ZMINUS(IP,I),FI0(IP,I)/CONV,PSI0(IP,I)/CONV,
     2  LAM0(IP,I)/CONV,-ZPLUS(IP,I)- ZMINUS(IP,I), I=1,LENGTH)
	WRITE (IOUT,2222) (INAMP(IPATH(IP,I)),IPATH(IP,I),
     1  ZPLUS(IP,I),ZMINUS(IP,I),FI0(IP,I)/CONV,PSI0(IP,I)/CONV,
     2  LAM0(IP,I)/CONV,-ZPLUS(IP,I)-ZMINUS(IP,I), I=1,LENGTH)
  222 CONTINUE
      ENDIF
 2221 FORMAT ('PATH ',i2/' RESIDUE    Z+        Z-           PHI0',
     1        '      PSI0   LAMBDA0      ENERGY')  
 2222 FORMAT (10(1X,A4,'(',I3,')',2F10.5,3F10.3,F12.5/) )
      RETURN
      END
C******************************************************************************
      SUBROUTINE ORIENT(IOUT,ISTEP)
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NLEFT,ILEFT
      DIMENSION RL(maxlength+1),ZP(maxlength),ZM(maxlength),
     & CP(maxlength),CM(maxlength),SP(maxlength),SM(maxlength),
     & F0(maxlength),P0(maxlength)
      LOGICAL FAIL,CONV
      REAL LAM0
      CHARACTER*4 INAMP
      DIMENSION A(maxlength+1,maxlength+1),RESD(maxlength+1),
     & G(maxlength+1)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,X(MAXAT),Y(MAXAT),Z(MAXAT),ITYPE(MAXAT)
      COMMON /LOCAL/ E1(3),E2(3),E3(3),U(3),ZZ(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /APPROX/ LAM0(maxpath,maxlength)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      COMMON /GEO/ PI,DWAPI,CONVER,RAD2DEG
      COMMON /DRUK/ IPRINT
      DATA MAXIT /100/
*
      CALL COEFFT(IOUT,ISTEP)
*
      DO 111 IP=1,NPATH
        RLAMBD=0.01
        LENGTH=NMEM(IP)
        DO 1 I=1,LENGTH-1
	  ZP(I)=ZPLUS(IP,I)
	  ZM(I)=ZMINUS(IP,I)
	  F0(I)=FI0(IP,I)
    1	  P0(I)=PSI0(IP,I)
    
        DO 12 I=1,LENGTH
   12     RL(I)=LAM0(IP,I)
        EOLD=PATHENG(IP,LENGTH,RL)
        IF (LENGTH.LE.2) GOTO 333
*
*  Begin iteration
*
        DO 3 I=1,LENGTH
	DO 3 J=1,LENGTH
    3     A(I,J)=0.0	
        DO 222 IT=1,MAXIT
*
          DO 11 I=1,LENGTH-1
            CP(I) = ZP(I)*COS(RL(I)+RL(I+1)-F0(I))
	    CM(I) = ZM(I)*COS(RL(I)-RL(I+1)-P0(I))
            SP(I) = ZP(I)*SIN(RL(I)+RL(I+1)-F0(I))
   11       SM(I) = ZM(I)*SIN(RL(I)-RL(I+1)-P0(I))	  	
*
          RESD(1)=-SP(1)-SM(1)
	  A(1,1) = CP(1)+CM(1)
	  A(1,2) = CP(1)-CM(1)
	  DO 4 I=2,LENGTH-1
	    RESD(I) = -SP(I-1)+SM(I-1)-SP(I)-SM(I)
            A(I,I-1) = CP(I-1)-CM(I-1)
	    A(I,I)   = CP(I-1)+CM(I-1)+CP(I)+CM(I)
            A(I,I+1) = CP(I) - CM(I)
    4     CONTINUE
        RESD(LENGTH)      =-SP(LENGTH-1)+SM(LENGTH-1)
	CALL TRANSFER(LENGTH,RESD,G)
        A(LENGTH,LENGTH-1)= CP(LENGTH-1)-CM(LENGTH-1)
        A(LENGTH,LENGTH)  = CP(LENGTH-1)+CM(LENGTH-1)
        IF (IPRINT.GT.1) THEN 
           do 444 i=1,length
  444       write (iout,4444) (a(i,j),j=1,length),resd(i)
 4444 format (4f10.5,f15.5)  
        ENDIF
        CALL INCR(IP,LENGTH,A,G,RL,CONV,AMAX,EOLD,RLAMBD)
        IF (IPRINT.GT.1) THEN
          write (iout,*) 'conv=',conv
      write (iout,2222) it,(i,ipath(ip,i),g(i)/conver,rl(i)/conver,
     2                      i=1,length)
 2222 format ('Iteration ',I3
     1       /'Increments & new variable values:'/10(2i4,2f15.5/) )
        ENDIF
        IF (CONV) GOTO 333
  222   CONTINUE
        WRITE (*,1000) IP,AMAX,RLAMBD
	WRITE (IOUT,1000) IP,AMAX,RLAMBD
  333   DO 5 I=1,LENGTH
*         LAM0(IP,I)=ANG(RL(I))
    5     RRL(IPATH(IP,I))=ANG(RL(I)+PI)
        IF (IPRINT.GT.1) WRITE (IOUT,1010) IP,EOLD,RLAMBD
	IF (IPRINT.GT.1) WRITE ( *  ,1010) IP,EOLD,RLAMBD
  111 CONTINUE
 1000 FORMAT (' Path:',I3,', convergence has not been achieved. AMAX:',
     &                F10.5,' Lambda:',1pe12.3)    	  	
 1010 FORMAT (' Path ',I3,' energy=',F10.5,' lambda=',f10.5)
      RETURN
      END           
C*******************************************************************************
      SUBROUTINE DEPEN(IOUT)
      include 'parcom.dat'
*     INTEGER*2 IPATH,NLEFT,ILEFT
      CHARACTER*4 INAMP
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONVER,RAD2DEG
      DO 1 I=1,NFIXED
        II=IFIX(I)
        IF (IPRO(II+1).NE.0) THEN
          DO III=II+1,2,-1
            IF (IPRO(III).EQ.0) GOTO 1
            CALL LAMEVAL(III,1,IPRO(III),IOUT)
          ENDDO 
        ELSE
          CALL LAMEVAL(II,2,IPRO(II),IOUT)
        ENDIF
    1 CONTINUE
      RETURN
      END      
C*******************************************************************************
      FUNCTION ALAM2(I)
      include 'parcom.dat'
      CHARACTER*4 INAMP
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      IF (I.LT.NRES1) THEN
        RL2=ANG(CONV*GAMA(I+2)-RRL(I)-PI)
      ELSE
        RL2=RRL(I)
      ENDIF
      ALAM2=RL2
      RETURN
      END
C*******************************************************************************
      SUBROUTINE LAMEVAL(IRES,ILAM,IANG,IOUT)
      include 'parcom.dat'
      REAL LAM1,LAM2,LAMF
      CHARACTER*4 INAMP
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      DIMENSION XINT(100,2),OBFUN(100,2)
c 6/29/98 - changed to reflect the phi angle of proline in the new ECEPP
c      PHI0=-75.0*IANG*CONV
      PHI0=-68.78*IANG*CONV
      NINT=0
*     write (iout,*) (rrl(i),i=1,nres2)
      IF (ILAM.EQ.2) THEN
        LAM1=RRL(IRES-1)
*       write (iout,*) 'ires',ires,' lam1 ',lam1
        LAMF=LAM1
      ELSE
        LAM2=ALAM2(IRES)
*       write (iout,*) 'ires',ires,' lam2 ',lam2
        LAMF=LAM2
      ENDIF
      F1=0.0
      DO I=-180,180,2
        IF (ILAM.EQ.1) THEN
          LAM1=(I+0.0)*CONV    
        ELSE 
          LAM2=(I+0.0)*CONV
        ENDIF
        F2=ANG(PHI(IRES,LAM1,LAM2)-PHI0)
*       write (iout,*) 'x ',i*conv,' f ',f2
        IF (F1*F2.LT.0.0 .AND. ABS(F2-F1).LT.DWAPI-0.5) THEN
          NINT=NINT+1
          XINT(NINT,1)=(I-2)*CONV
          XINT(NINT,2)=I*CONV
          OBFUN(NINT,1)=F1
          OBFUN(NINT,2)=F2
*         write (iout,*) 'nint ',nint,' f1 ',f1,' f2 ',f2
        ENDIF 
        F1=F2
      ENDDO  
      IF (NINT.EQ.0) THEN
      WRITE (IOUT,*) 'ERROR - PROLINE IMPOSSIBLE TO LOCATE'    
      ENDIF
*     write (iout,*) 'ires',ires,' ilam',ilam,' nint',nint
      DO II=1,NINT
*       write (iout,*) 'x1 ',xint(ii,1),' x2 ',xint(ii,2)
*       write (iout,*) 'f1 ',obfun(ii,1),' f2 ',obfun(ii,2) 
        CALL FALSI(IRES,ILAM,XINT(II,1),XINT(II,2),OBFUN(II,1),
     1             OBFUN(II,2),LAMF,PHI0)
*       write (iout,*) 'x ',xint(ii,1),' f ',obfun(ii,1)
        IF (ILAM.EQ.1) THEN  
          RRL(IRES-1)=XINT(II,1)
        ELSE
          IF (IRES.LT.NRES1) THEN
            RRL(IRES)=ANG(CONV*GAMA(IRES+2)-PI-XINT(II,1))
          ELSE
            RRL(IRES)=XINT(II,1)
          ENDIF
        ENDIF
      ENDDO
      RETURN
      END
****************************************************************************
      FUNCTION PHI(I,RL1,RL2)
      include 'parcom.dat'
      REAL KSI
      CHARACTER*4 INAMP
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG

      TT=THET(I+1,RL1,RL2)*CONV 
*     write (2,*) 'i',i,' lambda1 ',rl1/conv,' lambda2 ',rl2/conv,
*    1            ' theta ',tt/conv
      I1=4*(I-2)+NRES2+1
      I2=I1+5
      KSI=D(I1,2)*CONV
      ETA=D(I2,2)*CONV
      COSKSI=COS(KSI)
      SINKSI=SIN(KSI)
      COSETA=COS(ETA)
      SINETA=SIN(ETA)
      COSL1=COS(RL1)
      SINL1=SIN(RL1)
      COSL2=COS(RL2)
      SINL2=SIN(RL2)
      COSTHETA=COS(TT)
      SINTHETA=SIN(TT)
      COSA=COS(ALPHA(I+1)*CONV)
      SINA=SIN(ALPHA(I+1)*CONV)
      U1=SINKSI
      U2=COSKSI*COSL1 
      U3=COSKSI*SINL1
      A1=COSKSI
      A2=-SINKSI*COSL1
      A3=-SINKSI*SINL1
      B1=COSTHETA*COSETA-SINTHETA*SINETA*COSL2
      B2=SINTHETA*COSETA+COSTHETA*SINETA*COSL2
      B3=SINETA*SINL2
      PROD=A1*B1+A2*B2+A3*B3
      V1=B1-PROD*A1
      V2=B2-PROD*A2
      V3=B3-PROD*A3
      VNORM=SQRT(V1*V1+V2*V2+V3*V3)
      V1=V1/VNORM
      V2=V2/VNORM
      V3=V3/VNORM
      UV1=U2*V3-U3*V2
      UV2=V1*U3-U1*V3
      UV3=U1*V2-U2*V1
      COSPHI=U1*V1+U2*V2+U3*V3
      znak=uv1*a1+uv2*a2+uv3*a3
      znak=-sign(1.0,znak)
*     write (2   ,*) arcos(cosphi)/conv,znak
      PHI=ZNAK*ARCOS(COSPHI)
      RETURN
      END        
C*******************************************************************************
      FUNCTION ARCOS(X)
      COMMON /GEO/ PI,DWAPI,DEG2RAD,RAD2DEG 
      IF (ABS(X).LT.1.0) GOTO 1
      ARCOS=0.5*(PI+SIGN(1.0,X)*PI)
      RETURN
    1 ARCOS=ACOS(X)
      RETURN
      END
C*******************************************************************************
      SUBROUTINE FALSI(IRES,ILAM,X1,X2,F1,F2,YY,PHI0)
      include 'parcom.dat'
      REAL KSI
      CHARACTER*4 INAMP
      COMMON /ATOMS/ NATOMS,X(MAXAT,3),ITYPE(MAXAT)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PARPE/ ITC1D,ITND,ITCD,ITHD,ITOD,BLCCD,BLCND,BLNCD,BLNHD,
     1 KSID,ETAD,ALCNHD,BLCOD,ALCCOD,ALPHAD,CHC,CHC1,CHN1,CHH,CHO
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      DATA MAXIT /100/, TOLX /0.0001/ TOLF /0.0001/
*
* Regula falsi method
*       
      DO IT=1,MAXIT
        XMED=X1-F1*(X2-X1)/(F2-F1)
        IF (ILAM.EQ.1) THEN
          FMED=ANG(PHI(IRES,XMED,YY)-PHI0)
        ELSE
          FMED=ANG(PHI(IRES,YY,XMED)-PHI0)
        ENDIF
*       write (2,*) 'it',it,' xmed ',xmed,' fmed ',fmed
        IF ( (ABS(XMED-X1).LT.TOLX .OR. ABS(X2-XMED).LT.TOLX)
     1       .AND. ABS(FMED).LT.TOLF ) THEN
          X1=XMED
          F1=FMED
          RETURN
        ELSE IF ( FMED*F1.LT.0.0 ) THEN
          X2=XMED
          F2=FMED
        ELSE
          X1=XMED
          F1=FMED
        ENDIF
      ENDDO
      RETURN
      END 
C*******************************************************************************
      SUBROUTINE INCR(IP,N,A,G,X,CONV,AMAX,EOLD,RLAMBD)
      include 'parcom.dat'
      DIMENSION A(maxlength+1,maxlength+1),X(N),G(N),XX(maxlength)
      DIMENSION DX(maxlength+1),AOLD(maxlength+1,maxlength+1)
      COMMON /GEO/ PI,DWAPI,RAD2DEG
      LOGICAL CONV,FAIL
      DATA TOL /0.00001/, ATOL /0.180/
      RLAMBD=RLAMBD/10.0
      FAC=1.0
      DO I=1,N
        DO J=1,N
          AOLD(I,J)=A(I,J)
        ENDDO
      ENDDO
      EOLD=PATHENG(IP,N,X)
      CALL TRANSFER(N,X,XX)
      DO 10 IMAR=1,10
      AMAX=0.0
      DO I=1,N
        DO J=1,N
          A(I,J)=AOLD(I,J)
        ENDDO
        A(I,I)=A(I,I)*(1.0+RLAMBD)
        DX(I)=G(I)
cd      write (2,*) a(i,i),dx(i)
      ENDDO
      CALL GAUSS(maxlength+1,N,1,A,DX,FAIL)
cd    write (2,*) 'fail=',fail
      IF (FAIL) THEN
        RLAMBD=RLAMBD*10.0
        GOTO 10
      ENDIF
      DO 1 I=1,N
cd      write (2,*) i,dx(i)
        IF (ABS(DX(I)).GT.AMAX) AMAX=ABS(DX(I))
    1 CONTINUE
cd    write (2,*) 'amax=',amax,' rlambd=',rlambd
      IF (AMAX.GT.ATOL) THEN
*       DO 2 I=1,N
*   2     DX(I)=DX(I)*ATOL/AMAX
        RLAMBD=RLAMBD*10.0
        GOTO 10
      ENDIF
      CONV=(AMAX.LE.TOL.AND.RLAMBD.LE.0.1)
      IF (CONV) RETURN
      DO I=1,N
        X(I)=XX(I)+DX(I)
      ENDDO
*     IF (AMAX.LE.TOL) THEN
*       CONV=.TRUE.
*     ELSE	
*       CALL TRANSFER(N,X,XX)
*       DO 4 IT=1,20
*       DO 3 I=1,N
*   3     XX(I)=ANG(X(I)+FAC*(FAC*DX(I)-(1.0-FAC)*G(I)))
       ENERGY=PATHENG(IP,N,X)
       IF (ENERGY.LE.EOLD .OR. ABS(ENERGY-EOLD).LE.1.0E-4) THEN
          do i=1,n
            g(i)=dx(i)
          enddo
	  EOLD=ENERGY
	  RETURN
       ENDIF
       RLAMBD=RLAMBD*10.0
*      FAC=0.5*FAC
*   4  CONTINUE
*     ENDIF       	  
   10 CONTINUE
      RETURN
      END
C*******************************************************************************
      FUNCTION PATHENG(IP,N,X)
      include 'parcom.dat'
      DIMENSION X(N)
*     INTEGER*2 ITYPE,IREF,IPATH,NLEFT,ILEFT
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      ENERGY=0.0
      DO 4 I=1,N-1
        ENERGY=ENERGY+ZPLUS(IP,I)*COS( X(I)+X(I+1)-FI0(IP,I) ) +
     1               ZMINUS(IP,I)*COS( X(I)-X(I+1)-PSI0(IP,I) )
    4 CONTINUE
      PATHENG=ENERGY
      RETURN
      END
C*******************************************************************************
      SUBROUTINE TRANSFER(N,X1,X2)
      DIMENSION X1(N),X2(N)
      DO 1 I=1,N
    1   X2(I)=X1(I)
      RETURN
      END      
C*******************************************************************************
      SUBROUTINE GAUSS(MT,M,N,RO,AP,FAIL)
C
C  Calculates RO**(-1)*AP by the Gauss elimination. RO is a square
C  matrix. The calculated product is stored in AP. Alarm if ro is
C  singular.
C
      LOGICAL FAIL
      DIMENSION RO(MT,M),AP(MT,N)
      IF (M.NE.1) GOTO 10
C
C Case of dimension one.
C
      X=RO(1,1)
      IF (ABS(X).GT.1.E-7) GOTO 111
      FAIL=.TRUE.
      RETURN
  111 X=1.0/X
      DO 16 I=1,N
   16   AP(1,I)=AP(1,I)*X
      RETURN
C
C Case of dimension greater than one. Triangularising the matrix.
C
   10 M1=M-1
      DO 1 I=1,M1
C
C Finding the maximal element in i-th column of RO.
C
        IM=I
        RM=ABS(RO(I,I))
        I1=I+1
        DO 2 J=I1,M
          IF (ABS(RO(J,I)).LE.RM) GOTO 2
          RM=ABS(RO(J,I))
          IM=J
    2   CONTINUE
        IF (IM.EQ.I) GOTO 17
        DO 3 J=1,N
          PR=AP(I,J)
          AP(I,J)=AP(IM,J)
    3     AP(IM,J)=PR
        DO 4 J=I,M
          PR=RO(I,J)
          RO(I,J)=RO(IM,J)
    4     RO(IM,J)=PR
   17   X=RO(I,I)
        IF (ABS(X).GT.1.0E-7) GOTO 112
        FAIL=.TRUE.
        RETURN
  112   X=1.0/X
        DO 5 J=1,N
    5     AP(I,J)=X*AP(I,J)
        DO 6 J=I1,M
    6     RO(I,J)=X*RO(I,J)
        DO 7 J=I1,M
          Y=RO(J,I)
          DO 8 K=1,N
    8       AP(J,K)=AP(J,K)-Y*AP(I,K)
          DO 9 K=I1,M
    9       RO(J,K)=RO(J,K)-Y*RO(I,K)
    7   CONTINUE
    1 CONTINUE
      X=RO(M,M)
      IF (ABS(X).GT.1.0E-7) GOTO 113
      FAIL=.TRUE.
      RETURN
  113 X=1.0/X
      DO 11 J=1,N
   11   AP(M,J)=X*AP(M,J)
      DO 12 I=1,M1
        MI=M-I
        MI1=MI+1
        DO 14 J=1,N
          X=AP(MI,J)
          DO 15 K=MI1,M
   15     X=X-AP(K,J)*RO(MI,K)
   14   AP(MI,J)=X
   12 CONTINUE
      RETURN
      END
******************************************************************************
      SUBROUTINE ALIGN(IOUT)
      include 'parcom.dat'
*     INTEGER*2 IPATH,ITYPE,IREF,NL,ILEFT
      REAL LAMBDA
      LOGICAL FAIL
      CHARACTER*4 INAMP
      DIMENSION XX(3),F(3),FF1(10,3),FF2(3),RLL(10)
      COMMON /LOC/ NLIN,IREF(MAXAT,5),D(MAXAT,3)
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /PATH/ NPATH,NMEM(maxpath),IPATH(maxpath,maxlength),NLEFT,
     &ILEFT(maxleft),ZPLUS(maxpath,maxlength),ZMINUS(maxpath,maxlength),
     & FI0(maxpath,maxlength),PSI0(maxpath,maxlength) 
      COMMON /PROLINE/NFIXED,IFIX(maxfix),NDEP,IDEP(maxfix),IPRO(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /LOCAL/ E1(3),E2(3),E3(3),DUM(3),Z(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      COMMON /DRUK/ IPRINT
      COMMON /ELEC/ IEL12
      IDE=1
      IF (IEL12.GT.0) IDE=0
      DO 1 IL=1,NLEFT
        IIL=ILEFT(IL)
        DO 11 I=1,3
   11     XX(I)=0.5*(XYZ(IIL,I)+XYZ(IIL+1,I))
        DO 12 I=1,3
   12     F(I)=0.0
        DO 2 IP=1,NPATH
	  DO 22 II=1,NMEM(IP)
	    IP1=IPATH(IP,II)
            IF (IABS(IP1-IIL).GT.IDE) CALL FIELD(IP1,RRL(IP1),XX,F)
   22     CONTINUE	    
    2   CONTINUE
        IF (IIL.LT.NRES1) THEN
          I2=IIL
          I3=IIL+1
          I4=IIL+2
          CALL REFSYS(FAIL,3)
          print *,'REFSYS called from ALIGN fail=',fail
          IF (FAIL) STOP
          F2=SCALAR(E2,F)
          F3=SCALAR(E3,F)
          IF (F2.NE.0.0 .OR. F3.NE.0.0) THEN
            RRL(IIL)=ATAN2(F2,F3)
          ELSE
            RRL(IIL)=PI/2.0
          ENDIF
        ELSE
          I2=IIL+1
          I3=IIL
          I4=IIL-1
          CALL REFSYS(FAIL,3)
          IF (FAIL) STOP
          F2=-SCALAR(E2,F)
          F3=-SCALAR(E3,F)
          IF (F2.NE.0.0 .AND. F3.NE.0.0) THEN
            RRL(IIL)=ATAN2(F2,F3)
          ELSE
            RRL(IIL)=PI/2.0
          ENDIF
        ENDIF
        ENG=332.0*(F2*COS(RRL(IIL))+F3*SIN(RRL(IIL)))
        IF (ENG.GT.0.0) THEN
          RRL(IIL)=ANG(RRL(IIL)+PI)
          ENG=-ENG
        ENDIF
        IF (IPRINT.GT.0) THEN
        WRITE (IOUT,100) iil,(I,F(I),I=1,3),RRL(IIL)/CONV,ENG
        write (*,100) iil,(i,f(i),i=1,3),rrl(iil)/conv,eng
        ENDIF
    1 CONTINUE
*
* Proline handling 1/10/91
*
      IF (NDEP.GT.0 .AND. IPRINT.GT.0) WRITE (IOUT,150)
      DO III=1,NDEP
        NPB=0
        IDI=IDEP(III)
        DO IDII=IDI,2,-1
          IF (IPRO(IDII).EQ.0) GOTO 112 
          NPB=NPB+1
          DO I=1,3
            XX(I)=0.5*(XYZ(IDII-1,I)+XYZ(IDII,I))
          ENDDO
          DO I=1,3
            F(I)=0.0
          ENDDO
          DO IP=1,NPATH
	    DO II=1,NMEM(IP)
	      IP1=IPATH(IP,II)
              IF (IABS(IP1-IDII).GT.IDE) CALL FIELD(IP1,RRL(IP1),XX,F)
            ENDDO        
          ENDDO    
          I1=I-1
          I2=I
          I3=I+1
          CALL REFSYS(FAIL,3)
          FF1(NPB,1)=SCALAR(E1,F)
          FF1(NPB,2)=SCALAR(E2,F)
          FF1(NPB,3)=SCALAR(E3,F)
        ENDDO
  112   DO I=1,3
          XX(I)=0.5*(XYZ(IDI,I)+XYZ(IDI+1,I))
        ENDDO
        DO I=1,3
          F(I)=0.0
        ENDDO
        DO IP=1,NPATH
	  DO II=1,NMEM(IP)
	    IP1=IPATH(IP,II)
            IF (IABS(IP1-IP1).GT.IDE) CALL FIELD(IP1,RRL(IP1),XX,F)
          ENDDO        
        ENDDO    
        IF (IDI.LT.NRES1) THEN
          I1=I  
          I2=I+1
          I3=I+2
        ELSE
          I1=I+1
          I2=I
          I3=I-1
        ENDIF
        CALL REFSYS(FAIL,3)
        FF2(1)=SCALAR(E1,F)
        FF2(2)=SCALAR(E2,F)
        FF2(3)=SCALAR(E3,F)
        ENOLD=100000.0
*
* Vary the positions of the two peptide bonds at proline, subject to
* the constraint phi(Pro)=+-75 deg (depending on proline chirality),
* in order to achieve an optimum alignment with the field generated
* by the dipole paths. Because in such a case lambda1 is a univocal
* function of lambda2, the latter is chosen as an independent variable.
*
        DO IIA=-180,180,10
          RRL(IDI)=IIA*CONV
          CALL LAMEVAL(IDI,1,IPRO(IDI),IOUT)
          energia=0.0
          do k=idi-1,2,-1
            if (ipro(k).eq.0) goto 111
            call lameval(k,1,ipro(k),iout)
          enddo
  111     do k=idi-1,idi-npb,-1
            cosl1=cos(rrl(k))
            sinl1=sin(rrl(k))
           energia=energia-332.0*(cosl1*ff1(idi-k,2)+sinl1*ff1(idi-k,3))
          enddo
          COSL2=COS(RRL(IDI))
          SINL2=SIN(RRL(IDI)) 
          IF (IDI.LT.NRES1) THEN
            ENERGIA=ENERGIA+332.0*(COSL2*FF2(2)+SINL2*FF2(3))
          ELSE
            ENERGIA=ENERGIA-332.0*(COSL2*FF2(2)+SINL2*FF2(3))
          ENDIF
          IF (ENERGIA.LT.ENOLD) THEN
            ENOLD=ENERGIA
            do kk=1,npb
              rll(kk)=rrl(idi-kk)
            enddo
            RL2=RRL(IDI)
          ENDIF
*         write (2,*) 'rl1 ',rrl(idi-1)/conv,' rl2 ',rrl(idi)/conv,
*    1                ' energy ',energia
        ENDDO
        RL1=RLL(1)
        IF (IPRINT.GT.0)WRITE (2,160) IDI,RL1/CONV,ALAM2(IDI)/CONV,ENOLD
        do kk=1,npb
          rrl(idi-kk)=rll(kk)
        enddo
        RRL(IDI)=RL2
      ENDDO
  100 FORMAT (' Dipole: ',i3/1X,3('F(',I3,')=',1PE11.4,3X)/
     1 ' alignment angle:',0PF10.3,' energy=',1PE11.4) 
  150 FORMAT (/'      PROLINE RESIDUE ALIGNMENT'/
     1         'RESIDUE   LAMBDA1   LAMBDA2      ENERGY'
     2        /'---------------------------------------')
  160 FORMAT (I5,2F10.1,F12.3)
      RETURN
      END                    
******************************************************************************
      SUBROUTINE FIELD(II,RLAMBD,XX,F)
      include 'parcom.dat'
      DIMENSION XX(3),F(3),RIJ(3),P(3)
*     INTEGER*2 ITYPE
      REAL LAMBDA
      CHARACTER*4 INAMP
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /LOCAL/ E1(3),E2(3),E3(3),DUM(3),Z(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      DO 1 I=1,3
    1   RIJ(I)=-0.5*(XYZ(II,I)+XYZ(II+1,I))+XX(I)
      RRIJ=SQRT(SCALAR(RIJ,RIJ))
      DO 2 I=1,3
    2   RIJ(I)=RIJ(I)/RRIJ
      RRIJ=RRIJ**3  
      IF (II.LT.NRES1) THEN
        I2=II
        I3=II+1
        I4=II+2
        CALL REFSYS(FAIL,3)
        SINT=-SIN(RLAMBD)
        COST=-COS(RLAMBD)
        DO 3 I=1,3
    3     P(I)=(COST*E2(I)+SINT*E3(I))/RRIJ
      ELSE
        I2=II+1
        I3=II
        I4=II-1
        CALL REFSYS(FAIL,3)
        SINT=-SIN(RLAMBD)
        COST=-COS(RLAMBD)
        DO 4 I=1,3
    4     P(I)=-(COST*E2(I)+SINT*E3(I))/RRIJ
      ENDIF
      PER=SCALAR(P,RIJ)
      DO 5 I=1,3
    5   F(I)=F(I)-P(I)+3.0*PER*RIJ(I)
      RETURN
      END  
******************************************************************************
      SUBROUTINE ENERGY(ENG)
      include 'parcom.dat'
      LOGICAL FAIL
*     INTEGER*2 ITYPE
      REAL LAMBDA
      CHARACTER*4 INAMP
      DIMENSION XX(3),F(3),U(3),V(3)
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      COMMON /PEPT/ NRES,NRES1,NRES2,INAMP(MAXRES),GAMA(MAXRES),
     1 THETA(MAXRES),ALPHA(MAXRES),RRL(MAXRES)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      COMMON /LOCAL/ E1(3),E2(3),E3(3),DUM(3),Z(3),S1,S2
      COMMON /LOCSYS/ I1,I2,I3,I4,DIA,ALFIAB,BIABC,COSA
      COMMON /ELEC/ IEL12
      ENG=0.0
      DO 1 II=1,NRES-1
*       print *,ii,inamp(ii),inamp(ii+1)
        if (inamp(ii).eq.'TER '.and.inamp(ii+1).eq.'TER ') goto 1
        RL1=RRL(II)
        DO 2 JJ=II+1,NRES1
          if (jj.eq.ii+1 .and. iel12.le.0) goto 2
*         print *,jj,inamp(jj),inamp(jj+1)
          if (inamp(jj).eq.'TER '.and.inamp(jj+1).eq.'TER ') goto 2
          DO 11 I=1,3
   11       XX(I)=0.5*(XYZ(JJ,I)+XYZ(JJ+1,I))
          IF (JJ.LT.NRES1) THEN
            RL2=ANG(GAMA(JJ+2)*CONV-RRL(JJ)+PI)
          ELSE
            RL2=RRL(JJ)
          ENDIF
          DO 12 I=1,3
   12       F(I)=0.0
          CALL FIELD(II,RL1,XX,F)
          I2=JJ+1
          I3=JJ
          I4=JJ-1
          CALL REFSYS(FAIL,3)
          IF (FAIL) STOP
          F2=-SCALAR(E2,F)
          F3=-SCALAR(E3,F)
          ENE=332.0*(F2*COS(RL2)+F3*SIN(RL2))
*
*  Scale 1-3 interactions
*
*         IF (JJ.EQ.II+1) ENE=0.2*ENE
*         if (jj.eq.ii+1) ene=0.0
          ENG=ENG+ENE
*          write (2,100) ii,jj,rl1/conv,rl2/conv,f(1),f(2),f(3),ene
    2   CONTINUE
    1 CONTINUE
*     DO 3 I=1,NRES-2
*       CALL VEC(I,I+1,U) 
*       DO 4 J=I+3,NRES1
*         CALL VEC(J,J+1,V)
*         A12=0.0
*         B1=0.0
*         B2=0.0
*         DO 333 K=1,3
*           A12=A12-U(K)*V(K)
*           B1=B1+U(K)*(XYZ(J,K)-XYZ(I,K))
*           B2=B2-V(K)*(XYZ(J,K)-XYZ(I,K))
* 333     CONTINUE
*         DET=1.0-A12*A12
*          write (2,*) a12,b1,b2,det
*         IF (ABS(DET).GT.1.0E-6) THEN
*           T1=(B1-B2*A12)/DET
*           T2=(B2-B1*A12)/DET
*         ELSE
*           T1=0.0
*           T2=0.0
*         ENDIF
*         IF (T1.LT.0.0) T1=0.0
*         IF (T1.GT.3.8) T1=3.8
*         IF (T2.LT.0.0) T2=0.0
*         IF (T2.GT.3.8) T2=3.8
*         DIS=0.0
*         DO 334 K=1,3
*           DRK=XYZ(J,K)+T2*V(K)-XYZ(I,K)-T1*U(K)
* 334       DIS=DIS+DRK*DRK     
*         DIS=SQRT(DIS)  
*          write(2,100) i,j,dis,t1,t2
*  100 format (' i=',i2,'  j=',i2,'  distance=',f10.5,' t1=',f10.5,
*     1        ' t2=',f10.5)    
*   4     ENG=ENG+1.0/(DIS/3.8)**12
*   3 CONTINUE     
*  100 format (' i=',i2,' j=',i2,' l1=',f10.3,' l2=',f10.3,
*     1        3f12.5,' energy=',f10.5,' kcal/mol')
      RETURN
      END  
******************************************************************************
      FUNCTION SCALAR(U,V)
      DIMENSION U(3),V(3)
      P=0.0
      DO 1 I=1,3
    1   P=P+U(I)*V(I)
      SCALAR=0.0
      SCALAR=P
      RETURN
      END
******************************************************************************
      FUNCTION ANG(THETA)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      THETA=AMOD(THETA,DWAPI)
      IF (THETA.LT.-PI) THEN
        ANG=THETA+DWAPI
      ELSE IF (THETA.GT.PI) THEN
        ANG=THETA-DWAPI
      ELSE
        ANG=THETA
      ENDIF
      RETURN
      END
******************************************************************************
      FUNCTION ANGS(PROD)
      COMMON /GEO/ PI,DWAPI,CONV,RAD2DEG
      IF (ABS(PROD).GT.1.0) THEN 
         ANGS=0.5*PI*(1.0-PROD/ABS(PROD))
      ELSE
       ANGS=ACOS(PROD)
      ENDIF
      RETURN
      END 
******************************************************************************
      SUBROUTINE VEC(I,J,U)
*
*  Find the unit vector from atom (I) to atom (J). Store in U.
*
*     INTEGER*2 ITYPE 
      include 'parcom.dat'
      DIMENSION U(3)
      COMMON /ATOMS/ NATOMS,XYZ(MAXAT,3),ITYPE(MAXAT)
      ANORM=0.0
      DO 1 K=1,3
        UK=XYZ(J,K)-XYZ(I,K)
        ANORM=ANORM+UK*UK
    1   U(K)=UK
      ANORM=SQRT(ANORM)
      DO 2 K=1,3
    2   U(K)=U(K)/ANORM
      RETURN
      END
**************************************************************************
      SUBROUTINE CART(FAIL)
      common /atoms/ natoms
C
C  Calculating the coordinates without closing the disulphide bond.
C
      CALL LOCATE(1,NATOMS,FAIL,3)
      RETURN
      END

