#ifdef MPI
      subroutine init_task
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.SETUP'
      include 'COMMON.INFO'
c  start parallel processing
      call mpi_init(ierr)
      if (ierr.ne.0) then
       print *, ' cannot initiate MPI'
       stop
      endif
c  determine # of nodes and current node
      call mpi_comm_rank(mpi_comm_world,me,ierr)
      if (ierr.ne.0) then
       print *, ' cannot determine rank of all processes'
       stop
      endif
      call mpi_comm_size(mpi_comm_world,nodes,ierr)
      if (ierr.ne.0) then
       print *, ' cannot determine number of processes'
       stop
      endif
      Nprocs=nodes
      MyRank=me
      MyID=me
      do i=1,nodes+1
        ccglist(i)=i
      enddo
      do i=0,nodes
        cgdone(i)=.false.
      enddo
C Initialize other variables.
      call initialize
C Open task-dependent files.
      call openunits
      return
      end
C-----------------------------------------------------------------------------
      subroutine master_mail(result)
!  During this subroutine, the master reads all the incoming mail from the
! other CG nodes and processes their data.
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.SETUP'
      integer i
      integer ierr,status(mpi_status_size)
      integer source, mtype, dummyint
      logical flag,result

      result = .false.
      source = mpi_any_source
!      mtype  = mpi_any_tag
      mtype=is_done
      call mpi_iprobe(source,mtype,mpi_comm_world,flag,status,ierr)
c      print *,'Master_mail:',me,' mtype',mtype
      do while (flag)
          source = status(mpi_source)
          mtype  = status(mpi_tag)
c          print *,'Master_mail:',me,' flag:',flag,' mtype',mtype
          if (mtype == is_done) then
             call mpi_recv(dummyint,1,mpi_integer,source,is_done,          &
     &           mpi_comm_world,status,ierr)
             cgdone(source) = .true.
             result=.true.
             write(*,*)'processor ', source, 'has finished'
          else
             write(*,*)'Unrecognized msg type: MTYPE= ', MTYPE
          endif
          source = mpi_any_source
!          mtype  = mpi_any_tag
          mtype=is_done
          call mpi_iprobe(source,mtype,mpi_comm_world,flag,status,ierr)
      enddo
      return
      end 
C---------------------------------------------------------------------------- 
      subroutine finish_task
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.SETUP'
      include 'COMMON.INFO'
      call mpi_barrier(mpi_comm_world,ierr)
      call mpi_finalize(ierr)
      return
      end
#else
      subroutine init_task
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      integer nbuf(4),iproc
      do iproc=0,Nprocs
        Koniec(iproc)=.false.
      enddo 
C Determine parallel environment variables.
      call mp_environ(NProcs,MyId)
      call mp_task_query(nbuf,4,3)
      DontCare=nbuf(1)
      AllGrp=nbuf(4)
      MasterID=0
C Initialize other variables.
      call initialize
C Open task-dependent files.
      call openunits
      write (iout,*) 'NProcs,MyId,DontCare,AllGrp',
     & NProcs,MyId,DontCare,AllGrp
      write (*,*) 'NProcs,MyId,DontCare,AllGrp',
     & Nprocs,MyId,DontCare,AllGrp
      return
      end 
c-------------------------------------------------------------------------
#endif
#ifdef MPL
      subroutine finish_task
      include 'DIMENSIONS'
      include 'COMMON.TIME1'
      include 'COMMON.INFO'
      include 'COMMON.THREAD'
      include 'COMMON.IOUNITS'
      include 'COMMON.CONTROL'
      double precision MojCzas,CalkCzas,Czas,MinTime,HrTime,SecTime,
     & tcpu
C
C... A imie jego czterdziesci cztery - Mickiewicz.
C
      integer iproc,CzasID,CzasTyp,BRecv,ReadyType,ReadyID,Ready
      integer istop,StopType,StopID,source
      CzasId=44
      CzasTyp=44 
      StopType=66
      ReadyType=666
      Ready=1
      MojCzas=tcpu()
      if (modecalc.eq.2) then
        call pattern_receive
      endif
      call recv_stop_sig(Kwita)
      call DajCzas(MojCzas,MinTime,HrTime,SecTime)
      if (MyID.eq.MasterID) then
C Master collects workers' execution times.
        CalkCzas=MojCzas
        do iproc=1,nprocs-1
C Sending READY signal to iproc.
          write (iout,*) 'Master is sending READY signal to processor',
     &                    iproc
       	  write (*,*) 'Master is sending READY signal to processor',
     &                    iproc
          call mp_send(Ready,4,iproc,ReadyType,ReadyID) 
          call mp_wait(ReadyID,4)
          write (iout,*) 'Master has sent READY signal to processor',
     &                    iproc
          write (*,*) 'Master has sent READY signal to processor',iproc
c         source=dontcare
          source=iproc
          print *,'MASTER: source=',source
          nbytes=-1
          do while (nbytes.le.0)
            if (modecalc.eq.2) then
              call pattern_receive
            endif
            call recv_stop_sig(Kwita)
            call mp_probe(source,CzasTyp,nbytes)
          enddo
          print *,'MASTER: source=',source,' Nbytes=',Nbytes
          write (iout,*)'Master is receiving time from processor',source
          write (*,*) 'Master is receiving time from processor',source
          call mp_recv(Czas,8,source,CzasTyp,NBytes)
          call mp_wait(CzasId,BRecv)
          write (iout,*) 'Master received time from processor',source
          write (*,*) 'Master received time from processor',source
          if (modecalc.eq.2) call receive_thread_results(source)
          CalkCzas=CalkCzas+Czas
          call DajCzas(CalkCzas,MinTime,HrTime,SecTime)
        enddo
        if (modecalc.eq.2) then
           call write_thread_summary
        endif
        write (iout,'(a,1pe14.5,a)') 'Total time:',CalkCzas,' secs.'
        write (*,'(a,1pe14.5,a)') 'Total time:',CalkCzas,' secs.'
      else
C Workers mail their execution times and threading results to the master.
        if (.not.Koniec(MasterID)) then
          print *,'Processor',MyID,' is waiting for STOP signal from',
     &            ' master.'
          call mp_brecv(Kwita,4,MasterID,StopType,NBytes)
        endif
C Wait for the READY signal from master.
        write (iout,*) 'Processor',MyID,
     &            ' is waiting for READY signal from master.'
        write (*,*) 'Processor',MyID,
     &            ' is waiting for READY signal from master.'
        call mp_brecv(Ready,4,MasterID,ReadyType,NBytes) 
        write (iout,*) 'Processor',MyID,
     &              ' has received READY signali from master.'
        write (iout,*) 'Processor',MyID,' is sending time to master.'
        write (*,*) 'Processor',MyID,' is sending time to master.'
        call mp_send(MojCzas,8,MasterID,CzasTyp,CzasID)
        call mp_wait(CzasID,nbytes)
C Sending threading results
        if (modecalc.eq.2) then
          call send_thread_results
        endif
      endif 
cd    call mp_sync(allgrp)
      return
      end
c-------------------------------------------------------------------------
      subroutine pattern_receive      
      include 'DIMENSIONS'
      include 'COMMON.INFO'
      include 'COMMON.THREAD'
      include 'COMMON.IOUNITS'
      integer source,ThreadType,ThreadID,brcvd
      ThreadType=45
      ThreadID=45
      source=dontcare
      call mp_probe(source,ThreadType,nbytes)
      do while (nbytes.ne.-1)
        write (iout,*) 'Processor ',MyId,' is receiving threading',
     & ' pattern from processor',source
        write (*,*) 'Processor ',MyId,' is receiving threading',
     & ' pattern from processor',source
        nexcl=nexcl+1
        call mp_recv(iexam(1,nexcl),8,source,ThreadType,brcvd)
        write (iout,*) 'Received pattern:',nexcl,iexam(1,nexcl),
     &    iexam(2,nexcl)
        source=dontcare
        call mp_probe(source,ThreadType,nbytes)
      enddo
      return
      end
c----------------------------------------------------------------------------
      subroutine pattern_send
      include 'DIMENSIONS'
      include 'COMMON.INFO'
      include 'COMMON.THREAD'
      include 'COMMON.IOUNITS'
      integer source,ThreadType,ThreadID,brcvd
      ThreadType=45 
      ThreadID=45 
      do iproc=0,nprocs-1
        if (iproc.ne.MyId .and. .not.Koniec(iproc) ) then
          call mp_send(iexam(1,nexcl),8,iproc,ThreadType,ThreadID)
          write (iout,*) 'Processor ',MyId,' has sent pattern ',
     &    'to processor',iproc
          write (*,*) 'Processor ',MyId,' has sent pattern ',
     &    'to processor',iproc
          write (iout,*) 'Pattern:',nexcl,iexam(1,nexcl),iexam(2,nexcl)
        endif
      enddo
      return
      end
c-----------------------------------------------------------------------------
      subroutine send_stop_sig(Kwita)
      include 'DIMENSIONS'
      include 'COMMON.INFO'
      include 'COMMON.IOUNITS'
      integer StopType,StopId,iproc,Kwita,NBytes
      StopType=66
c     Kwita=-1
C     print *,'Processor',MyID,' StopType=',StopType
      Koniec(MyID)=.true.
      if (MyID.eq.MasterID) then
C Master sends the STOP signal to everybody.
        write (iout,'(a,a)') 
     &   'Master is sending STOP signal to other processors.'
        do iproc=1,nprocs-1
          print *,'Koniec(',iproc,')=',Koniec(iproc)
          if (.not. Koniec(iproc)) then
            call mp_send(Kwita,4,iproc,StopType,StopID)
            call mp_wait(StopID,NBytes)
            write (iout,*) 'Iproc=',iproc,' StopID=',StopID
            write (*,*) 'Iproc=',iproc,' StopID=',StopID
          endif
        enddo
      else
C Else send the STOP signal to Master.
        call mp_send(Kwita,4,MasterID,StopType,StopID)
        call mp_wait(StopID,NBytes)
        write (iout,*) 'Processor=',MyID,' StopID=',StopID
        write (*,*) 'Processor=',MyID,' StopID=',StopID
      endif
      return
      end 
c-----------------------------------------------------------------------------
      subroutine recv_stop_sig(Kwita)
      include 'DIMENSIONS' 
      include 'COMMON.INFO'
      include 'COMMON.IOUNITS'
      integer source,StopType,StopId,iproc,Kwita,brcvd
      StopType=66
      Kwita=0
      source=dontcare
c     print *,'Processor:',MyID,' StopType=',StopType
      call mp_probe(source,StopType,brcvd)
      do while (brcvd.ne.-1)
        Koniec(source)=.true.
        write (iout,*) 'Processor ',MyId,' is receiving STOP signal',
     & ' from processor',source
        write (*,*) 'Processor ',MyId,' is receiving STOP signal',
     & ' from processor',source
        call mp_recv(Kwita,4,source,StopType,brcvd)
        source=dontcare
        call mp_probe(source,StopType,brcvd)
      enddo
      return
      end
c-----------------------------------------------------------------------------
      subroutine send_thread_results
      include 'DIMENSIONS'
      include 'COMMON.INFO'
      include 'COMMON.THREAD'
      include 'COMMON.IOUNITS'
      integer ibuffer(2*maxthread+2),ThreadType,ThreadID,EnerType,
     &   EnerID,msglen,nbytes
      double precision buffer(20*maxthread+2) 
      ThreadType=444
      EnerType=555
      ibuffer(1)=nthread
      ibuffer(2)=nexcl
      do i=1,nthread
        ibuffer(2*(i-1)+3)=ipatt(1,i)
        ibuffer(2*i+2)=ipatt(2,i) 
        do j=1,10
          buffer(20*(i-1)+j)=ener0(j,i)
          buffer(20*(i-1)+j+10)=ener(j,i)
        enddo
      enddo
      buffer(20*nthread+1)=max_time_for_thread
      buffer(20*nthread+2)=ave_time_for_thread
C Send the IPATT array
      write (iout,*) 'Processor',MyID,
     & ' is sending IPATT array to master: NTHREAD=',nthread
      write (*,*) 'Processor',MyID,
     & ' is sending IPATT array to master: NTHREAD=',nthread
      msglen=4*(2*nthread+2)
      call mp_send(ibuffer(1),msglen,MasterID,ThreadType,ThreadID)
      call mp_wait(ThreadID,NBytes)
      write (iout,*) 'Processor',MyID,' has sent IPATT array to master.'
      write (*,*) 'Processor',MyID,' has sent IPATT array to master.'
C Send the energies.
      msglen=8*(20*nthread+2)
      write (iout,*) 'Processor',MyID,' is sending energies to master.'
      write (*,*) 'Processor',MyID,' is sending energies to master.'
      call mp_send(buffer(1),msglen,MasterID,EnerType,EnerID)
      call mp_wait(EnerID,NBytes)
      write (iout,*) 'Processor',MyID,' has sent energies to master.'
      write (*,*) 'Processor',MyID,' has sent energies to master.'
      return
      end
c----------------------------------------------------------------------------
      subroutine receive_thread_results(iproc)
      include 'DIMENSIONS'
      include 'COMMON.INFO'
      include 'COMMON.THREAD'
      include 'COMMON.IOUNITS'
      integer ibuffer(2*maxthread+2),ThreadType,ThreadID,EnerType,
     &   EnerID,ReadyType,ReadyID,Ready,msglen,nbytes,nthread_temp
      double precision buffer(20*maxthread+2),max_time_for_thread_t,
     & ave_time_for_thread_t
      ThreadType=444
      EnerType=555
C Receive the IPATT array
      do while (NBytes.eq.-1)
        call mp_probe(iproc,ThreadType,NBytes)
      enddo
      write (iout,*) 'Master is receiving IPATT array from processor:',
     &    iproc
      write (*,*) 'Master is receiving IPATT array from processor:',
     &    iproc
      msglen=NBytes
      call mp_recv(ibuffer(1),msglen,iproc,ThreadType,NBytes)
      call mp_wait(AllMsg,NBytes)
      write (iout,*) 'Master has received IPATT array from processor:',
     &    iproc,' NBytes=',NBytes
      write (*,*) 'Master has received IPATT array from processor:',
     &    iproc,' NBytes=',NBytes
C Receive the energies.
      call mp_probe(iproc,EnerType,NBytes)
      write (iout,*) 'Master is receiving energies from processor:',
     &    iproc,' NBytes=',NBytes
      write (*,*) 'Master is receiving energies from processor:',
     &    iproc,' NBytes=',NBytes
      do while (NBytes.eq.-1)
        call mp_probe(iproc,EnerType,NBytes)
      enddo
      msglen=NBytes
      call mp_recv(buffer(1),msglen,iproc,EnerType,NBytes)
      write (iout,*) 'NBytes=',NBytes
      write (*,*) 'NBytes=',NBytes
      call mp_wait(EnerID,NBytes)
      write (iout,*) 'Master has received energies from processor',iproc
      write (*,*) 'Master has received energies from processor',iproc
      nthread_temp=ibuffer(1)
      nexcl_temp=ibuffer(2)
      write (iout,*) 'NTHREAD_TEMP=',nthread_temp,' NEXCL=',nexcl_temp
      write (*,*) 'NTHREAD_TEMP=',nthread_temp,' NEXCL=',nexcl_temp
      do i=1,nthread_temp
        ipatt(1,nthread+i)=ibuffer(2*(i-1)+3)
        ipatt(2,nthread+i)=ibuffer(2*i+2) 
        do j=1,10
          ener0(j,nthread+i)=buffer(20*(i-1)+j)
          ener(j,nthread+i)=buffer(20*(i-1)+j+10)
        enddo
      enddo
      max_time_for_thread_t=buffer(20*nthread_temp+1)
      ave_time_for_thread_t=buffer(20*nthread_temp+2)
      write (iout,*) 'MAX_TIME_FOR_THREAD:',max_time_for_thread_t
      write (iout,*) 'AVE_TIME_FOR_THREAD:',ave_time_for_thread_t
      write (*,*) 'MAX_TIME_FOR_THREAD:',max_time_for_thread_t
      write (*,*) 'AVE_TIME_FOR_THREAD:',ave_time_for_thread_t
      if (max_time_for_thread_t.gt.max_time_for_thread)
     & max_time_for_thread=max_time_for_thread_t
      ave_time_for_thread=(nthread*ave_time_for_thread+
     & nthread_temp*ave_time_for_thread_t)/(nthread+nthread_temp)
      nthread=nthread+nthread_temp
      return
      end
#endif
