c---------------------------------
      subroutine refresh_bank(ntrial)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.IOUNITS'

c loop over all newly obtained conformations
      do n=1,ntrial
cccccccccccccccccccccccccccccccccccccccccccc
       if(etot(n).gt.ebmax) goto 100
c Find the conformation closest to the conformation n in the bank
       difmin=9.d9
       do m=1,nbank
        call get_diff12(dihang(1,1,1,n),bvar(1,1,1,m),diff)
        if(diff.lt.difmin) then
         difmin=diff
         idmin=m
        endif
       enddo

       if(difmin.lt.cutdif) then
c n is redundant to idmin
        if(etot(n).lt.bene(idmin)) then
         if(etot(n).lt.bene(idmin)-0.01d0) then
          ibank(idmin)=0
          jbank(idmin)=0
         endif
         call replace_bvar(idmin,n)
         if(idmin.eq.ibmax) call find_max
        endif
       else
c got new conformation
        dele=0.0
        if(ebmax-ebmin.gt.dele) then
         call replace_bvar(ibmax,n)
         ibank(ibmax)=0
         jbank(ibmax)=0
         call find_max
        else
         if(dele.lt.0.0001) then
          write (iout,*) 'ERROR in refresh_bank: '
          write (iout,*) 'ebmax: ',ebmax
          write (iout,*) 'ebmin: ',ebmin
          write (iout,*) 'dele: ',dele
          call mpi_abort(mpi_comm_world,ierrcode)
         endif
         if(nbank.lt.nbmax) then
          nbank=nbank+1
          call replace_bvar(nbank,n)
          ibank(nbank)=0
          jbank(nbank)=0
         else
          call replace_bvar(ibmax,n)
          ibank(ibmax)=0
          jbank(ibmax)=0
          call find_max
         endif
        endif
       endif
cccccccccccccccccccccccccccccccccccccccccccc
  100 continue
      enddo
c end of loop over all newly obtained conformations

c Update dij
      do i1=1,nbank-1
       do i2=i1+1,nbank
        if(jbank(i1).eq.0.or.jbank(i2).eq.0) then
         call get_diff12(bvar(1,1,1,i1),bvar(1,1,1,i2),diff)
         dij(i1,i2)=diff
         dij(i2,i1)=diff
        endif
       enddo
      enddo

      do i=1,nbank
       jbank(i)=1
      enddo

      return
      end
c---------------------------------
      subroutine replace_bvar(iold,inew)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.IOUNITS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.CHAIN'

      if (iold.gt.mxio .or. iold.lt.1 .or. inew.gt.mxio .or. inew.lt.1) 
     &  then
        write (iout,*) 'Dimension ERROR in REPLACE_BVAR: IOLD',iold,
     &  ' INEW',inew
        call mpi_abort(mpi_comm_world,ierrcode)
      endif
      do k=1,numch
       do j=2,nres-1
        do i=1,4
         bvar(i,j,k,iold)=dihang(i,j,k,inew)
        enddo
       enddo
      enddo
      bene(iold)=etot(inew)

      return
      end
c---------------------------------------
      subroutine write_rbank(jlee,adif,nft)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.CHAIN'
      include 'COMMON.GEO'

      open(30,status="unknown")
      write (30,900) jlee,nbank,nstep,nft,icycle,adif
      do k=1,nbank
       write (30,952) k,rene(k)
       do j=1,numch
        do l=2,nres-1
         write (30,850) (rad2deg*rvar(i,l,j,k),i=1,4)
        enddo
       enddo
      enddo
      close(30)

  850 format (10f8.3)
  900 format (1x,"jlee =",i3,3x,"nbank =",i4,3x,"nstep =",
     &        i8,i10,i2,f15.5)
  952 format (1x,'# ',i3,' - total energy ',f12.3,i5)

      return
      end
c---------------------------------------
      subroutine read_rbank(jlee,adif)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.IOUNITS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.CHAIN'
      include 'COMMON.GEO'

      open(30,status="old")
      read (30,901) jleer,nbankr,nstepr,nftr,icycler,adif
c       print *, 'adif from read_rbank ',adif
      if(nbankr.ne.nbank) then
        write (iout,*) 'ERROR in READ_BANK: NBANKR',nbankr,
     &  ' NBANK',nbank
        call mpi_abort(mpi_comm_world,ierrcode)
      endif
      if(jleer.ne.jlee) then
        write (iout,*) 'ERROR in READ_BANK: JLEER',jleer,
     &  ' JLEE',jlee
        call mpi_abort(mpi_comm_world,ierrcode)
      endif

      do k=1,nbank
       read (30,953) kdummy,rene(k)
       do j=1,numch
        do l=2,nres-1
         read (30,850) (rvar(i,l,j,k),i=1,4)
         do i=1,4
          rvar(i,l,j,k)=deg2rad*rvar(i,l,j,k)
         enddo
        enddo
       enddo
      enddo
      close(30)

  850 format (10f8.3)
  901 format (1x,6x,i3,3x,7x,i4,3x,7x,i8,i10,i2,f15.5)
  953 format (1x,2x,i3,16x,f12.3,i5)

      return
      end
c---------------------------------------
      subroutine write_bank(jlee,nft)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.CHAIN'
      include 'COMMON.GEO'
      include 'COMMON.SBRIDGE'

      open(33,status="unknown")
      write (33,900) jlee,nbank,nstep,nft,icycle,cutdif
      open (igeom,file=intname,status='UNKNOWN')
      do k=1,nbank
       write (33,952) k,bene(k),ibank(k)
       do j=1,numch
        do l=2,nres-1
         write (33,850) (rad2deg*bvar(i,l,j,k),i=1,4)
        enddo
       enddo
       if (nss.lt.9) then
         write (igeom,'(I5,F10.5,I2,9(1X,2I3))') k,bene(k),
     &     nss,(ihpb(i),jhpb(i),i=1,nss)
       else
         write (igeom,'(I5,F10.5,I2,9(1X,2I3))') k,bene(k),
     &     nss,(ihpb(i),jhpb(i),i=1,9)
         write (igeom,'(3X,11(1X,2I3))') (ihpb(i),jhpb(i),i=10,nss)
       endif
       write (igeom,200) (rad2deg*bvar(1,i,1,k),i=2,nres-1)
       write (igeom,200) (rad2deg*bvar(2,i,1,k),i=2,nres-2)
       write (igeom,200) (rad2deg*bvar(3,i,1,k),i=2,nres-1)
       write (igeom,200) (rad2deg*bvar(4,i,1,k),i=2,nres-1)
      enddo
      close(33)
      close(igeom)

  200 format (8f10.4)
  850 format (10f8.3)
  900 format (1x,"jlee =",i3,3x,"nbank =",i4,3x,"nstep =",
     &        i8,i10,i2,f15.5)
  952 format (1x,'# ',i3,' - total energy ',f12.3,i5)

      return
      end
c---------------------------------
      subroutine read_bank(jlee,nft,cutdifr)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.CHAIN'
      include 'COMMON.GEO'

      open(33,status="old")
       read (33,901) jleer,nbank,nstep,nft,icycle,cutdifr
c      if(jleer.ne.jlee) then
c        write (iout,*) 'ERROR in READ_BANK: JLEER',jleer,
c    &   ' JLEE',jlee
c        call mpi_abort(mpi_comm_world,ierrcode)
c      endif

       do k=1,nbank
        read (33,953) kdummy,bene(k),ibank(k)
        do j=1,numch
         do l=2,nres-1
          read (33,850) (bvar(i,l,j,k),i=1,4)
          do i=1,4
           bvar(i,l,j,k)=deg2rad*bvar(i,l,j,k)
          enddo
         enddo
        enddo
       enddo
      close(33)

  850 format (10f8.3)
  952 format (1x,'# ',i3,' - total energy ',f12.3,i5)
  901 format (1x,6x,i3,3x,7x,i4,3x,7x,i8,i10,i2,f15.5)
  953 format (1x,2x,i3,16x,f12.3,i5)

      return
      end
c---------------------------------------
      subroutine write_bank1(jlee)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.CHAIN'
      include 'COMMON.GEO'

#ifdef AIX
      open(34,position="append")
#else
      open(34,access="append")
#endif
      write (34,900) jlee,nbank,nstep,cutdif
      do k=1,nbank
       write (34,952) k,bene(k),ibank(k)
       do j=1,numch
        do l=2,nres-1
         write (34,850) (rad2deg*bvar(i,l,j,k),i=1,4)
        enddo
       enddo
      enddo
      close(34)
  850 format (10f8.3)
  900 format (4x,"jlee =",i5,3x,"nbank =",i5,3x,"nstep =",i10,f15.5)
  952 format (1x,'# ',i3,' - total energy ',f12.3,i5)

      return
      end
c---------------------------------
      subroutine save_is(ind)
      include 'DIMENSIONS'
      include 'mpif.h'
      include 'COMMON.IOUNITS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.CHAIN'

      index=nbank+ind
      if (index.gt.mxio .or. index.lt.1 .or. 
     &  is(ind).gt.mxio .or. is(ind).lt.1) then
        write (iout,*) 'Dimension ERROR in SAVE_IS: INDEX',index,
     &  ' IND',ind,' IS',is(ind)
        call mpi_abort(mpi_comm_world,ierrcode)
      endif
      do k=1,numch
       do j=2,nres-1
        do i=1,4
         bvar(i,j,k,index)=bvar(i,j,k,is(ind))
        enddo
       enddo
      enddo
      bene(index)=bene(is(ind))
      ibank(is(ind))=1

      return
      end
c---------------------------------
      subroutine select_is(n,ifar,idum)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      dimension itag(mxio),adiff(mxio)

      iuse=0
      do i=1,nbank
       if(ibank(i).eq.0) then
        iuse=iuse+1
        itag(iuse)=i
       endif
      enddo
      iusesv=iuse

      if(iuse.eq.0) then
       icycle=icycle+1
       do i=1,nbank
        if(ibank(i).eq.2) then
         ibank(i)=1
        else
         ibank(i)=0
        endif
       enddo
       imade=0
       call get_is(idum,ifar,n,imade,0)
      else if(iuse.eq.n) then
       do i=1,iuse
        is(i)=itag(i)
        call save_is(i)
       enddo
      else if(iuse.lt.n) then
c      if(icycle.eq.0) then
c       do i=1,n
c        ind=mod(i-1,iuse)+1
c        is(i)=itag(ind)
c        call save_is(i)
c       enddo
c      else
c      endif
       do i=1,iuse
        is(i)=itag(i)
        call save_is(i)
       enddo
       imade=iuse
c      call get_is_ran(idum,n,imade,1)
       call get_is(idum,ifar,n,imade,1)
c      if(iusesv.le.n/10) then
       if(iusesv.le.0) then
        icycle=icycle+1
        do i=1,nbank
         if(ibank(i).eq.2) then
          ibank(i)=1
         else
          ibank(i)=0
         endif
        enddo
       endif
      else
       imade=0
       call get_is(idum,ifar,n,imade,0)
      endif
      iuse=iusesv

      return
      end
c---------------------------------
      subroutine get_is_ran(idum,n,imade,k)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      real ran1,ran2
      dimension itag(mxio),adiff(mxio)

      do j=imade+1,n
       iuse=0
       do i=1,nbank
        if(ibank(i).eq.k) then
         iuse=iuse+1
         itag(iuse)=i
        endif
       enddo
       iran=iuse*  ran1(idum)+1
       is(j)=itag(iran)
       call save_is(j)
      enddo

      return
      end
c---------------------------------
      subroutine get_is(idum,ifar,n,imade,k)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      real ran1,ran2
      dimension itag(mxio),adiff(mxio)

      iuse=0
      do i=1,nbank
       if(ibank(i).eq.k) then
        iuse=iuse+1
        itag(iuse)=i
       endif
      enddo
      iran=iuse*  ran1(idum)+1
      imade=imade+1
      is(imade)=itag(iran)
      call save_is(imade)

      do i=imade+1,ifar-1
       if(icycle.eq.-1) then
        call select_iseed_max(i,k)
       else
        call select_iseed_min(i,k)
       endif
       call save_is(i)
      enddo

      do i=ifar,n
       call select_iseed_far(i,k)
       call save_is(i)
      enddo

      return
      end
c---------------------------------
      subroutine select_iseed_max(imade1,ik)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      dimension itag(mxio),adiff(mxio)

      iuse=0
      avedif=0.d0
      difmax=0.d0
      do n=1,nbank
       if(ibank(n).eq.ik) then
        iuse=iuse+1
        diffmn=9.d19
        do imade=1,imade1-1
c        m=nbank+imade
c        call get_diff12(bvar(1,1,1,n),bvar(1,1,1,m),diff,idiff)
         m=is(imade)
         diff=dij(n,m)
         if(diff.lt.diffmn) diffmn=diff
        enddo
        if(diffmn.gt.difmax) difmax=diffmn
        adiff(iuse)=diffmn
        itag(iuse)=n
        avedif=avedif+diffmn
       endif
      enddo

      avedif=avedif/iuse
c     avedif=(avedif+difmax)/2
      emax=-9.d19
      do i=1,iuse
       if(adiff(i).ge.avedif) then
        itagi=itag(i)
        benei=bene(itagi)
        if(benei.gt.emax) then
         emax=benei
         is(imade1)=itagi  
        endif
       endif
      enddo

      if(ik.eq.0) iuse=iuse-1

      return
      end
c---------------------------------
      subroutine select_iseed_min(imade1,ik)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      dimension itag(mxio),adiff(mxio)

      iuse=0
      avedif=0.d0
      difmax=0.d0
      do n=1,nbank
       if(ibank(n).eq.ik) then
        iuse=iuse+1
        diffmn=9.d19
        do imade=1,imade1-1
c        m=nbank+imade
c        call get_diff12(bvar(1,1,1,n),bvar(1,1,1,m),diff,idiff)
         m=is(imade)
         diff=dij(n,m)
         if(diff.lt.diffmn) diffmn=diff
        enddo
        if(diffmn.gt.difmax) difmax=diffmn
        adiff(iuse)=diffmn
        itag(iuse)=n
        avedif=avedif+diffmn
       endif
      enddo

      avedif=avedif/iuse
c     avedif=(avedif+difmax)/2
      emin=9.d19
      do i=1,iuse
       if(adiff(i).ge.avedif) then
        itagi=itag(i)
        benei=bene(itagi)
        if(benei.lt.emin) then
         emin=benei
         is(imade1)=itagi  
        endif
       endif
      enddo

      if(ik.eq.0) iuse=iuse-1

      return
      end
c---------------------------------
      subroutine select_iseed_far(imade1,ik)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'

      dmax=-9.d19
      do n=1,nbank
       if(ibank(n).eq.ik) then
        diffmn=9.d19
        do imade=1,imade1-1
c        m=nbank+imade
c        call get_diff12(bvar(1,1,1,n),bvar(1,1,1,m),diff,idiff)
         m=is(imade)
         diff=dij(n,m)
         if(diff.lt.diffmn) diffmn=diff
        enddo
       endif
       if(diffmn.gt.dmax) then
        dmax=diffmn
        is(imade1)=n  
       endif
      enddo

      return
      end
c---------------------------------
      subroutine find_min
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      
      ebmin=9.d19

      do i=1,nbank
       benei=bene(i)
       if(benei.lt.ebmin) then
        ebmin=benei
        ibmin=i
       endif
      enddo

      return
      end
c---------------------------------
      subroutine find_max
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      
      ebmax=-9.d19

      do i=1,nbank
       benei=bene(i)
       if(benei.gt.ebmax) then
        ebmax=benei
        ibmax=i
       endif
      enddo

      return
      end
c---------------------------------
      subroutine get_diff
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'

      tdiff=0.d0
      difmin=9.d19
      do i1=1,nbank-1
       do i2=i1+1,nbank
        if(jbank(i1).eq.0.or.jbank(i2).eq.0) then
         call get_diff12(bvar(1,1,1,i1),bvar(1,1,1,i2),diff)
         dij(i1,i2)=diff
         dij(i2,i1)=diff
        else
         diff=dij(i1,i2)
        endif
        tdiff=tdiff+diff
        if(diff.lt.difmin) difmin=diff
       enddo
       dij(i1,i1)=0.0
      enddo

      do i=1,nbank
       jbank(i)=1
      enddo

      avedif=tdiff/nbank/(nbank-1)*2

      return
      end
c---------------------------------
      subroutine estimate_cutdif(adif,xct,cutdifr)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      
      ctdif1=adif/cut2

      exponent = cutdifr*cut1/adif
      exponent = dlog(exponent)/dlog(xct)

      nexp=exponent+0.25
      cutdif= adif/cut1*xct**nexp
      if(cutdif.lt.ctdif1) cutdif=ctdif1

      return
      end
c---------------------------------
