      subroutine check_cartgrad
C Check the gradient of Cartesian coordinates in internal coordinates.
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.DERIV'
      dimension temp(6,maxres),xx(3),gg(3)
      indmat(i,j)=((2*(nres-2)-i)*(i-1))/2+j-1
*
* Check the gradient of the virtual-bond and SC vectors in the internal
* coordinates.
*    
      aincr=1.0d-7  
      aincr2=5.0d-8   
      call cartder
      write (iout,'(a)') '**************** dx/dalpha'
      write (iout,'(a)')
      do i=2,nres-1
	alphi=alph(i)
	alph(i)=alph(i)+aincr
	do k=1,3
	  temp(k,i)=dc(k,nres+i)
        enddo
	call chainbuild
	do k=1,3
	  gg(k)=(dc(k,nres+i)-temp(k,i))/aincr
	  xx(k)=dabs((gg(k)-dxds(k,i))/(aincr*dabs(dxds(k,i))+aincr))
        enddo
        write (iout,'(i4,3e15.6/4x,3e15.6,3f9.3)') 
     &  i,(gg(k),k=1,3),(dxds(k,i),k=1,3),(xx(k),k=1,3)
        write (iout,'(a)')
	alph(i)=alphi
	call chainbuild
      enddo
      write (iout,'(a)')
      write (iout,'(a)') '**************** dx/domega'
      write (iout,'(a)')
      do i=2,nres-1
	omegi=omeg(i)
	omeg(i)=omeg(i)+aincr
	do k=1,3
	  temp(k,i)=dc(k,nres+i)
        enddo
	call chainbuild
	do k=1,3
          gg(k)=(dc(k,nres+i)-temp(k,i))/aincr
          xx(k)=dabs((gg(k)-dxds(k+3,i))/
     &          (aincr*dabs(dxds(k+3,i))+aincr))
        enddo
        write (iout,'(i4,3e15.6/4x,3e15.6,3f9.3)') 
     &      i,(gg(k),k=1,3),(dxds(k+3,i),k=1,3),(xx(k),k=1,3)
        write (iout,'(a)')
	omeg(i)=omegi
	call chainbuild
      enddo
      write (iout,'(a)')
      write (iout,'(a)') '**************** dx/dtheta'
      write (iout,'(a)')
      do i=3,nres
	theti=theta(i)
        theta(i)=theta(i)+aincr
        do j=i-1,nres-1
          do k=1,3
            temp(k,j)=dc(k,nres+j)
          enddo
        enddo
        call chainbuild
        do j=i-1,nres-1
	  ii = indmat(i-2,j)
c         print *,'i=',i-2,' j=',j-1,' ii=',ii
	  do k=1,3
	    gg(k)=(dc(k,nres+j)-temp(k,j))/aincr
	    xx(k)=dabs((gg(k)-dxdv(k,ii))/
     &            (aincr*dabs(dxdv(k,ii))+aincr))
          enddo
          write (iout,'(2i4,3e14.6/8x,3e14.6,3f9.3)') 
     &        i,j,(gg(k),k=1,3),(dxdv(k,ii),k=1,3),(xx(k),k=1,3)
          write(iout,'(a)')
        enddo
        write (iout,'(a)')
        theta(i)=theti
        call chainbuild
      enddo
      write (iout,'(a)') '***************** dx/dphi'
      write (iout,'(a)')
      do i=4,nres
        phi(i)=phi(i)+aincr
        do j=i-1,nres-1
          do k=1,3
            temp(k,j)=dc(k,nres+j)
          enddo
        enddo
        call chainbuild
        do j=i-1,nres-1
	  ii = indmat(i-2,j)
c         print *,'ii=',ii
	  do k=1,3
	    gg(k)=(dc(k,nres+j)-temp(k,j))/aincr
            xx(k)=dabs((gg(k)-dxdv(k+3,ii))/
     &            (aincr*dabs(dxdv(k+3,ii))+aincr))
          enddo
          write (iout,'(2i4,3e14.6/8x,3e14.6,3f9.3)') 
     &        i,j,(gg(k),k=1,3),(dxdv(k+3,ii),k=1,3),(xx(k),k=1,3)
          write(iout,'(a)')
        enddo
        phi(i)=phi(i)-aincr
        call chainbuild
      enddo
      write (iout,'(a)') '****************** ddc/dtheta'
      do i=1,nres-2
        thet=theta(i+2)
        theta(i+2)=thet+aincr
        do j=i,nres
          do k=1,3 
            temp(k,j)=dc(k,j)
          enddo
        enddo
        call chainbuild 
        do j=i+1,nres-1
	  ii = indmat(i,j)
c         print *,'ii=',ii
	  do k=1,3
	    gg(k)=(dc(k,j)-temp(k,j))/aincr
	    xx(k)=dabs((gg(k)-dcdv(k,ii))/
     &           (aincr*dabs(dcdv(k,ii))+aincr))
          enddo
          write (iout,'(2i4,3e14.6/8x,3e14.6,3f9.3)') 
     &           i,j,(gg(k),k=1,3),(dcdv(k,ii),k=1,3),(xx(k),k=1,3)
	  write (iout,'(a)')
        enddo
        do j=1,nres
          do k=1,3
            dc(k,j)=temp(k,j)
          enddo 
        enddo
        theta(i+2)=thet
      enddo    
      write (iout,'(a)') '******************* ddc/dphi'
      do i=1,nres-3
        phii=phi(i+3)
        phi(i+3)=phii+aincr
        do j=1,nres
          do k=1,3 
            temp(k,j)=dc(k,j)
          enddo
        enddo
        call chainbuild 
        do j=i+2,nres-1
	  ii = indmat(i+1,j)
c         print *,'ii=',ii
	  do k=1,3
	    gg(k)=(dc(k,j)-temp(k,j))/aincr
            xx(k)=dabs((gg(k)-dcdv(k+3,ii))/
     &           (aincr*dabs(dcdv(k+3,ii))+aincr))
          enddo
          write (iout,'(2i4,3e14.6/8x,3e14.6,3f9.3)') 
     &         i,j,(gg(k),k=1,3),(dcdv(k+3,ii),k=1,3),(xx(k),k=1,3)
	  write (iout,'(a)')
        enddo
        do j=1,nres
          do k=1,3
            dc(k,j)=temp(k,j)
          enddo
        enddo
        phi(i+3)=phii   
      enddo   
      return
      end
C----------------------------------------------------------------------------
      subroutine check_ecart
C Check the gradient of the energy in Cartesian coordinates. 
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.IOUNITS'
      include 'COMMON.VAR'
      include 'COMMON.CONTACTS'
      common /srutu/ icall
      dimension ggg(6),cc(3),xx(3),ddc(3),ddx(3),x(maxvar),g(maxvar)
      dimension grad_s(6,maxres)
      integer uiparm(1)
      double precision urparm(1)
      external fdum
      icg=1
      nf=0
      nfl=0                
      call zerograd
      aincr=1.0D-7
      print '(a)','Calling CHECK_CART.'
      nf=0
      icall=0
      call geom_to_var(nvar,x)
      call etotal(evdw,evdw1,evdw2,ees,ebe,esc,etors,ehpb,edihcnstr,
     &  ecorr,etot)
      call enerprint(evdw,evdw1,evdw2,ees,ebe,esc,etors,ehpb,edihcnstr,
     & ecorr,etot)
      call gradient(nvar,x,nf,g,uiparm,urparm,fdum)
      icall =1
      do i=1,nres
        write (iout,'(i5,3f10.5)') i,(gradxorr(j,i),j=1,3)
      enddo
      do i=1,nres
	do j=1,3
	  grad_s(j,i)=gradc(j,i,icg)
	  grad_s(j+3,i)=gradx(j,i,icg)
        enddo
       enddo
      write (iout,'(/a/)') 'Gradient in virtual-bond and SC vectors'
      do i=1,nres
        do j=1,3
	  xx(j)=c(j,i+nres)
	  ddc(j)=dc(j,i) 
	  ddx(j)=dc(j,i+nres)
        enddo
	do j=1,3
	  dc(j,i)=dc(j,i)+aincr
	  do k=i+1,nres
	    c(j,k)=c(j,k)+aincr
	    c(j,k+nres)=c(j,k+nres)+aincr
          enddo
          call etotal(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
     &       edihcnstr,ecorr,etot1)
	  ggg(j)=(etot1-etot)/aincr
	  dc(j,i)=ddc(j)
	  do k=i+1,nres
	    c(j,k)=c(j,k)-aincr
	    c(j,k+nres)=c(j,k+nres)-aincr
          enddo
        enddo
	do j=1,3
	  c(j,i+nres)=c(j,i+nres)+aincr
	  dc(j,i+nres)=dc(j,i+nres)+aincr
          call etotal(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
     &            edihcnstr,ecorr,etot1)
	  ggg(j+3)=(etot1-etot)/aincr
	  c(j,i+nres)=xx(j)
	  dc(j,i+nres)=ddx(j)
        enddo
	write (iout,'(i3,6(1pe12.5)/3x,6(1pe12.5)/)')
     &   i,(ggg(k),k=1,6),(grad_s(k,i),k=1,6)
      enddo
      return
      end
c----------------------------------------------------------------------------
      subroutine check_eint
C Check the gradient of energy in internal coordinates.
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.IOUNITS'
      include 'COMMON.VAR'
      include 'COMMON.GEO'
#ifdef MPL
      include 'COMMON.INFO'
#endif
      common /srutu/ icall
      dimension x(maxvar),gana(maxvar),gg(maxvar)
      integer uiparm(1)
      double precision urparm(1)
      character*6 key
      external fdum
      call zerograd
      aincr=1.0D-7
      print '(a)','Calling CHECK_INT.'
      nf=0
      nfl=0
      icg=1
      call geom_to_var(nvar,x)
      call var_to_geom(nvar,x)
      call chainbuild
      icall=1
      print *,'ICG=',ICG
      call etotal(evdw,evdw1,evdw2,ees,ebe,esc,etors,ehpb,edihcnstr,
     &  ecorr,etot)
      call enerprint(evdw,evdw1,evdw2,ees,ebe,esc,etors,ehpb,edihcnstr,
     &  ecorr,etot)
      print *,'ICG=',ICG
#ifdef MPL
      if (MyID.ne.BossID) then
        call mp_bcast(x(1),8*(nvar+3),BossID,fgGroupID)
        nf=x(nvar+1)
        nfl=x(nvar+2)
        icg=x(nvar+3)
      endif
#endif
      nf=1
      nfl=3
cd    write (iout,'(10f8.3)') (rad2deg*x(i),i=1,nvar)
      call gradient(nvar,x,nf,gana,uiparm,urparm,fdum)
cd    write (iout,'(i3,1pe14.4)') (i,gana(i),i=1,nvar)
      icall=1
      do i=1,nvar
        xi=x(i)
        x(i)=xi-0.5D0*aincr
        call var_to_geom(nvar,x)
        call chainbuild
        call etotal(evdw,evdw1,evdw2,ees,ebe,esc,etors,ehpb,edihcnstr,
     &    ecorr,etot1)
        x(i)=xi+0.5D0*aincr
        call var_to_geom(nvar,x)
        call chainbuild
        call etotal(evdw,evdw1,evdw2,ees,ebe,esc,etors,ehpb,edihcnstr,
     &   ecorr,etot2)
        gg(i)=(etot2-etot1)/aincr
        write (iout,*) i,etot1,etot2
        x(i)=xi
      enddo
      write (iout,'(/2a)')' Variable        Numerical       Analytical',
     &    '     RelDiff*100% '
      do i=1,nvar
        if (i.le.nphi) then
          ii=i
          key = ' phi'
        else if (i.le.nphi+ntheta) then
          ii=i-nphi
          key=' theta'
        else if (i.le.nphi+ntheta+nside) then
           ii=i-(nphi+ntheta)
           key=' alpha'
        else 
           ii=i-(nphi+ntheta+nside)
           key=' omega'
        endif
        write (iout,'(i3,a,i3,3(1pd16.6))') 
     & i,key,ii,gg(i),gana(i),
     & 100.0D0*dabs(gg(i)-gana(i))/(dabs(gana(i))+aincr)
      enddo
      return
      end
