      subroutine etotal(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
     &                  edihcnstr,ecorr,etot)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
#ifdef MPL
      include 'COMMON.INFO'
      double precision energia(11),energia1(11)
      external d_vadd
      integer ready
#endif
      include 'COMMON.FFIELD'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.SBRIDGE'
cd    print '(a,i2)','Calling etotal ipot=',ipot
cd    print *,'nnt=',nnt,' nct=',nct
C
C Compute the side-chain and electrostatic interaction energy
C
      goto (101,102,103,104,105) ipot
C Lennard-Jones potential.
  101 call elj(evdw)
cd    print '(a)','Exit ELJ'
      goto 106
C Lennard-Jones-Kihara potential (shifted).
  102 call eljk(evdw)
      goto 106
C Berne-Pechukas potential (dilated LJ, angular dependence).
  103 call ebp(evdw)
      goto 106
C Gay-Berne potential (shifted LJ, angular dependence).
  104 call egb(evdw)
      goto 106
C Gay-Berne-Vorobjev potential (shifted LJ, angular dependence).
  105 call egbv(evdw)
C
C Calculate electrostatic (H-bonding) energy of the main chain.
C
  106 call eelec(ees,evdw1)
C
C Calculate excluded-volume interaction energy between peptide groups
C and side chains.
C
      call escp(evdw2)
C 
C Calculate the disulfide-bridge and other energy and the contributions
C from other distance constraints.
      call edis(ehpb)
cd    print *,'EHPB exitted succesfully.'
C
C Calculate the virtual-bond-angle energy.
C
      call ebend(ebe)
cd    print *,'Bend energy finished.'
C
C Calculate the SC local energy.
C
      call esc(escloc)
cd    print *,'SCLOC energy finished.'
C
C Calculate the virtual-bond torsional energy.
C
cd    print *,'nterm=',nterm
      call etor(etors,edihcnstr)
C 
C 12/1/95 Multi-body terms
C
      call multibody_hb(ecorr)
C     call multibody(ecorr)
C 
C Sum the energies
C
#ifdef MPL
      if (fgprocs.gt.1) then
cd      call enerprint(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
cd   &                 edihcnstr,ecorr,etot)
        energia(1)=evdw
        energia(2)=evdw2
        energia(3)=ees
        energia(4)=evdw1
        energia(5)=ecorr
        energia(6)=etors
        energia(7)=ebe
        energia(8)=escloc
        energia(9)=ehpb
        energia(10)=edihcnstr
        msglen=80
        do i=1,10
          energia1(i)=energia(i)
        enddo
cd      write (iout,*) 'BossID=',BossID,' MyGroup=',MyGroup
cd      write (*,*) 'BossID=',BossID,' MyGroup=',MyGroup
cd      write (*,*) 'Processor',MyID,' calls MP_REDUCE in ENERGY',
cd   &   ' BossID=',BossID,' MyGroup=',MyGroup
        call mp_reduce(energia1(1),energia(1),msglen,BossID,d_vadd,
     &                 fgGroupID)
cd      write (iout,*) 'Processor',MyID,' Reduce finished' 
        evdw=energia(1)
        evdw2=energia(2)
        ees=energia(3)
        evdw1=energia(4)
        ecorr=energia(5)
        etors=energia(6)
        ebe=energia(7)
        escloc=energia(8)
        ehpb=energia(9)
        edihcnstr=energia(10)
      endif
c     if (MyID.eq.BossID) then
#endif
      etot=wsc*evdw+wscp*evdw2+welec*(ees+evdw1)
     & +wang*ebe+wtor*etors+wscloc*escloc
     & +wstrain*ehpb+nss*ebr+wcorr*ecorr+edihcnstr
#ifdef MPL
c     endif
#endif
C
C Sum up the components of the Cartesian gradient.
C
      do i=1,nct
	do j=1,3
          gradc(j,i,icg)=wsc*gvdwc(j,i)+wscp*gvdwc_scp(j,i)+
     &                   welec*gelc(j,i)+wstrain*ghpbc(j,i)+
     &                   wcorr*gradcorr(j,i)
          gradx(j,i,icg)=wsc*gvdwx(j,i)+wscp*gradx_scp(j,i)+
     &                   wstrain*ghpbx(j,i)+wcorr*gradxorr(j,i)
        enddo
cd      print '(i3,9(1pe12.4))',i,(gvdwc(k,i),k=1,3),(gelc(k,i),k=1,3),
cd   &        (gradc(k,i),k=1,3)
      enddo
cd    print*,evdw,wsc,evdw2,wscp,ees+evdw1,welec,ebe,wang,
cd   &  escloc,wscloc,etors,wtor,ehpb,wstrain,nss,ebr,etot
cd    call enerprint(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
cd   &     edihcnstr,ecorr,etot)
cd    call intout
cd    stop
      return
      end
C------------------------------------------------------------------------
      subroutine enerprint(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
     &   edihcnstr,ecorr,etot)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.SBRIDGE'
      write (iout,10) evdw,wsc,evdw2,wscp,ees+evdw1,welec,ebe,wang,
     &  escloc,wscloc,etors,wtor,ehpb,wstrain,ecorr,wcorr,
     &  edihcnstr,ebr*nss,etot
   10 format (/'Virtual-chain energies:'//
     & 'EVDW= ',1pD16.6,' WEIGHT=',1pD16.6,' (SC-SC)'/
     & 'EVDW2=',1pD16.6,' WEIGHT=',1pD16.6,' (SC-p)'/
     & 'EES=  ',1pD16.6,' WEIGHT=',1pD16.6,' (p-p)'/
     & 'EBE=  ',1pD16.6,' WEIGHT=',1pD16.6,' (bending)'/
     & 'ESC=  ',1pD16.6,' WEIGHT=',1pD16.6,' (SC local)'/
     & 'ETORS=',1pD16.6,' WEIGHT=',1pD16.6,' (torsional)'/
     & 'EHBP= ',1pD16.6,' WEIGHT=',1pD16.6,
     & ' (SS bridges & dist. cnstr.)'/
     & 'ECORR=',1pD16.6,' WEIGHT=',1pD16.6,' (multi-body)'/
     & 'EDIHC=',1pD16.6,' (dihedral angle constraints)'/
     & 'ESS=  ',1pD16.6,' (disulfide-bridge intrinsic energy)'/ 
     & 'ETOT= ',1pD16.6,' (total)')
      return
      end
C-----------------------------------------------------------------------
      subroutine elj(evdw)
C
C This subroutine calculates the interaction energy of nonbonded side chains
C assuming the LJ potential of interaction.
C
      include 'DIMENSIONS'
      parameter (accur=1.0d-10)
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.TORSION'
      include 'COMMON.SBRIDGE'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.CONTACTS'
      dimension gg(3)
cd    print *,'Entering ELJ nnt=',nnt,' nct=',nct,' expon=',expon
      evdw=0.0D0
      do i=iatsc_s,iatsc_e
        itypi=itype(i)
        itypi1=itype(i+1)
        xi=c(1,nres+i)
        yi=c(2,nres+i)
        zi=c(3,nres+i)
C Change 12/1/95
        num_conti=0
C
C Calculate SC interaction energy.
C
        do iint=1,nint_gr(i)
cd        write (iout,*) 'i=',i,' iint=',iint,' istart=',istart(i,iint),
cd   &                  'iend=',iend(i,iint)
          do j=istart(i,iint),iend(i,iint)
            itypj=itype(j)
            xj=c(1,nres+j)-xi
            yj=c(2,nres+j)-yi
            zj=c(3,nres+j)-zi
C Change 12/1/95 to calculate four-body interactions
            rij=xj*xj+yj*yj+zj*zj
            rrij=1.0D0/rij
c           write (iout,*)'i=',i,' j=',j,' itypi=',itypi,' itypj=',itypj
            eps0ij=eps(itypi,itypj)
            fac=rrij**expon2
            e1=fac*fac*aa(itypi,itypj)
            e2=fac*bb(itypi,itypj)
            evdwij=e1+e2
cd          sigm=dabs(aa(itypi,itypj)/bb(itypi,itypj))**(1.0D0/6.0D0)
cd          epsi=bb(itypi,itypj)**2/aa(itypi,itypj)
cd          write (iout,'(2(a3,i3,2x),6(1pd12.4)/2(3(1pd12.4),5x)/)')
cd   &        restyp(itypi),i,restyp(itypj),j,aa(itypi,itypj),
cd   &        bb(itypi,itypj),1.0D0/dsqrt(rrij),evdwij,epsi,sigm,
cd   &        (c(k,i),k=1,3),(c(k,j),k=1,3)
            evdw=evdw+evdwij
C 
C Calculate the components of the gradient in DC and X
C
	    fac=-rrij*(e1+evdwij)
	    gg(1)=xj*fac
	    gg(2)=yj*fac
	    gg(3)=zj*fac
	    do k=1,3
	      gvdwx(k,i)=gvdwx(k,i)-gg(k)
	      gvdwx(k,j)=gvdwx(k,j)+gg(k)
            enddo
	    do k=i,j-1
	      do l=1,3
	        gvdwc(l,k)=gvdwc(l,k)+gg(l)
              enddo
            enddo
C
C 12/1/95, revised on 5/20/97
C
C Calculate the contact function. The ith column of the array JCONT will 
C contain the numbers of atoms that make contacts with the atom I (of numbers
C greater than I). The arrays FACONT and GACONT will contain the values of
C the contact function and its derivative.
C
C Uncomment next line, if the correlation interactions include EVDW explicitly.
c           if (j.gt.i+1 .and. evdwij.le.0.0D0) then
C Uncomment next line, if the correlation interactions are contact function only
            if (j.gt.i+1.and. eps0ij.gt.0.0D0) then
              rij=dsqrt(rij)
              sigij=sigma(itypi,itypj)
              r0ij=rs0(itypi,itypj)
C
C Check whether the SC's are not too far to make a contact.
C
              rcut=1.5d0*r0ij
              call gcont(rij,rcut,1.0d0,0.2d0*rcut,fcont,fprimcont)
C Add a new contact, if the SC's are close enough, but not too close (r<sigma).
C
              if (fcont.gt.0.0D0) then
C If the SC-SC distance if close to sigma, apply spline.
cAdam           call gcont(-rij,-1.03d0*sigij,2.0d0*sigij,1.0d0,
cAdam &             fcont1,fprimcont1)
cAdam           fcont1=1.0d0-fcont1
cAdam           if (fcont1.gt.0.0d0) then
cAdam             fprimcont=fprimcont*fcont1+fcont*fprimcont1
cAdam             fcont=fcont*fcont1
cAdam           endif
C Uncomment following 4 lines to have the geometric average of the epsilon0's
cga             eps0ij=1.0d0/dsqrt(eps0ij)
cga             do k=1,3
cga               gg(k)=gg(k)*eps0ij
cga             enddo
cga             eps0ij=-evdwij*eps0ij
C Uncomment for AL's type of SC correlation interactions.
cadam           eps0ij=-evdwij
                num_conti=num_conti+1
                jcont(num_conti,i)=j
                facont(num_conti,i)=fcont*eps0ij
                fprimcont=eps0ij*fprimcont/rij
                fcont=expon*fcont
cAdam           gacont(1,num_conti,i)=-fprimcont*xj+fcont*gg(1)
cAdam           gacont(2,num_conti,i)=-fprimcont*yj+fcont*gg(2)
cAdam           gacont(3,num_conti,i)=-fprimcont*zj+fcont*gg(3)
C Uncomment following 3 lines for Skolnick's type of SC correlation.
                gacont(1,num_conti,i)=-fprimcont*xj
                gacont(2,num_conti,i)=-fprimcont*yj
                gacont(3,num_conti,i)=-fprimcont*zj
cd              write (iout,'(2i5,2f10.5)') i,j,rij,facont(num_conti,i)
cd              write (iout,'(2i3,3f10.5)') 
cd   &           i,j,(gacont(kk,num_conti,i),kk=1,3)
              endif
            endif
          enddo      ! j
        enddo        ! iint
C Change 12/1/95
        num_cont(i)=num_conti
      enddo          ! i
      do i=1,nct
        do j=1,3
          gvdwc(j,i)=expon*gvdwc(j,i)
          gvdwx(j,i)=expon*gvdwx(j,i)
        enddo
      enddo
C******************************************************************************
C
C                              N O T E !!!
C
C To save time, the factor of EXPON has been extracted from ALL components
C of GVDWC and GRADX. Remember to multiply them by this factor before further 
C use!
C
C******************************************************************************
      return
      end
C-----------------------------------------------------------------------------
      subroutine eljk(evdw)
C
C This subroutine calculates the interaction energy of nonbonded side chains
C assuming the LJK potential of interaction.
C
      include 'DIMENSIONS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.NAMES'
      dimension gg(3)
      logical scheck
c     print *,'Entering ELJK nnt=',nnt,' nct=',nct,' expon=',expon
      evdw=0.0D0
      do i=iatsc_s,iatsc_e
        itypi=itype(i)
        itypi1=itype(i+1)
        xi=c(1,nres+i)
        yi=c(2,nres+i)
        zi=c(3,nres+i)
C
C Calculate SC interaction energy.
C
        do iint=1,nint_gr(i)
          do j=istart(i,iint),iend(i,iint)
            itypj=itype(j)
            xj=c(1,nres+j)-xi
            yj=c(2,nres+j)-yi
            zj=c(3,nres+j)-zi
            rrij=1.0D0/(xj*xj+yj*yj+zj*zj)
            fac_augm=rrij**expon
            e_augm=augm(itypi,itypj)*fac_augm
            r_inv_ij=dsqrt(rrij)
            rij=1.0D0/r_inv_ij 
            r_shift_inv=1.0D0/(rij+r0(itypi,itypj)-sigma(itypi,itypj))
            fac=r_shift_inv**expon
            e1=fac*fac*aa(itypi,itypj)
            e2=fac*bb(itypi,itypj)
            evdwij=e_augm+e1+e2
cd          sigm=dabs(aa(itypi,itypj)/bb(itypi,itypj))**(1.0D0/6.0D0)
cd          epsi=bb(itypi,itypj)**2/aa(itypi,itypj)
cd          write (iout,'(2(a3,i3,2x),8(1pd12.4)/2(3(1pd12.4),5x)/)')
cd   &        restyp(itypi),i,restyp(itypj),j,aa(itypi,itypj),
cd   &        bb(itypi,itypj),augm(itypi,itypj),epsi,sigm,
cd   &        sigma(itypi,itypj),1.0D0/dsqrt(rrij),evdwij,
cd   &        (c(k,i),k=1,3),(c(k,j),k=1,3)
            evdw=evdw+evdwij
C 
C Calculate the components of the gradient in DC and X
C
            fac=-2.0D0*rrij*e_augm-r_inv_ij*r_shift_inv*(e1+e1+e2)
	    gg(1)=xj*fac
	    gg(2)=yj*fac
	    gg(3)=zj*fac
	    do k=1,3
	      gvdwx(k,i)=gvdwx(k,i)-gg(k)
	      gvdwx(k,j)=gvdwx(k,j)+gg(k)
            enddo
	    do k=i,j-1
	      do l=1,3
	        gvdwc(l,k)=gvdwc(l,k)+gg(l)
              enddo
            enddo
          enddo      ! j
        enddo        ! iint
      enddo          ! i
      do i=1,nct
        do j=1,3
          gvdwc(j,i)=expon*gvdwc(j,i)
          gvdwx(j,i)=expon*gvdwx(j,i)
        enddo
      enddo
      return
      end
C-----------------------------------------------------------------------------
      subroutine ebp(evdw)
C
C This subroutine calculates the interaction energy of nonbonded side chains
C assuming the Berne-Pechukas potential of interaction.
C
      include 'DIMENSIONS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.NAMES'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.CALC'
      common /srutu/ icall
c     double precision rrsave(maxdim)
      logical lprn
      evdw=0.0D0
c     print *,'Entering EBP nnt=',nnt,' nct=',nct,' expon=',expon
      evdw=0.0D0
c     if (icall.eq.0) then
c       lprn=.true.
c     else
        lprn=.false.
c     endif
      ind=0
      do i=iatsc_s,iatsc_e
        itypi=itype(i)
        itypi1=itype(i+1)
        xi=c(1,nres+i)
        yi=c(2,nres+i)
        zi=c(3,nres+i)
        dxi=dc_norm(1,nres+i)
        dyi=dc_norm(2,nres+i)
        dzi=dc_norm(3,nres+i)
        dsci_inv=dsc_inv(itypi)
C
C Calculate SC interaction energy.
C
        do iint=1,nint_gr(i)
          do j=istart(i,iint),iend(i,iint)
            ind=ind+1
            itypj=itype(j)
            dscj_inv=dsc_inv(itypj)
            chi1=chi(itypi,itypj)
            chi2=chi(itypj,itypi)
            chi12=chi1*chi2
            chip1=chip(itypi)
            chip2=chip(itypj)
            chip12=chip1*chip2
            alf1=alp(itypi)
            alf2=alp(itypj)
            alf12=0.5D0*(alf1+alf2)
C For diagnostics only!!!
c           chi1=0.0D0
c           chi2=0.0D0
c           chi12=0.0D0
c           chip1=0.0D0
c           chip2=0.0D0
c           chip12=0.0D0
c           alf1=0.0D0
c           alf2=0.0D0
c           alf12=0.0D0
            xj=c(1,nres+j)-xi
            yj=c(2,nres+j)-yi
            zj=c(3,nres+j)-zi
            dxj=dc_norm(1,nres+j)
            dyj=dc_norm(2,nres+j)
            dzj=dc_norm(3,nres+j)
            rrij=1.0D0/(xj*xj+yj*yj+zj*zj)
cd          if (icall.eq.0) then
cd            rrsave(ind)=rrij
cd          else
cd            rrij=rrsave(ind)
cd          endif
            rij=dsqrt(rrij)
C Calculate the angle-dependent terms of energy & contributions to derivatives.
            call sc_angular
C Calculate whole angle-dependent part of epsilon and contributions
C to its derivatives
            fac=(rrij*sigsq)**expon2
            e1=fac*fac*aa(itypi,itypj)
            e2=fac*bb(itypi,itypj)
            evdwij=eps1*eps2rt*eps3rt*(e1+e2)
            eps2der=evdwij*eps3rt
            eps3der=evdwij*eps2rt
            evdwij=evdwij*eps2rt*eps3rt
            evdw=evdw+evdwij
            if (lprn) then
            sigm=dabs(aa(itypi,itypj)/bb(itypi,itypj))**(1.0D0/6.0D0)
            epsi=bb(itypi,itypj)**2/aa(itypi,itypj)
            write (iout,'(2(a3,i3,2x),15(0pf7.3))')
     &        restyp(itypi),i,restyp(itypj),j,
     &        epsi,sigm,chi1,chi2,chip1,chip2,
     &        eps1,eps2rt**2,eps3rt**2,1.0D0/dsqrt(sigsq),
     &        om1,om2,om12,1.0D0/dsqrt(rrij),
     &        evdwij
            endif
C Calculate gradient components.
            e1=e1*eps1*eps2rt**2*eps3rt**2
            fac=-expon*(e1+evdwij)
            sigder=fac/sigsq
	    fac=rrij*fac
C Calculate radial part of the gradient
            gg(1)=xj*fac
            gg(2)=yj*fac
            gg(3)=zj*fac
C Calculate the angular part of the gradient and sum add the contributions
C to the appropriate components of the Cartesian gradient.
            call sc_grad
          enddo      ! j
        enddo        ! iint
      enddo          ! i
c     stop
      return
      end
C-----------------------------------------------------------------------------
      subroutine egb(evdw)
C
C This subroutine calculates the interaction energy of nonbonded side chains
C assuming the Gay-Berne potential of interaction.
C
      include 'DIMENSIONS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.NAMES'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.CALC'
      logical lprn
      evdw=0.0D0
c     print *,'Entering EGB nnt=',nnt,' nct=',nct,' expon=',expon
      evdw=0.0D0
      lprn=.false.
c     if (icall.eq.0) lprn=.true.
      ind=0
      do i=iatsc_s,iatsc_e
        itypi=itype(i)
        itypi1=itype(i+1)
        xi=c(1,nres+i)
        yi=c(2,nres+i)
        zi=c(3,nres+i)
        dxi=dc_norm(1,nres+i)
        dyi=dc_norm(2,nres+i)
        dzi=dc_norm(3,nres+i)
        dsci_inv=dsc_inv(itypi)
C
C Calculate SC interaction energy.
C
        do iint=1,nint_gr(i)
          do j=istart(i,iint),iend(i,iint)
            ind=ind+1
            itypj=itype(j)
            dscj_inv=dsc_inv(itypj)
            sig0ij=sigma(itypi,itypj)
            chi1=chi(itypi,itypj)
            chi2=chi(itypj,itypi)
            chi12=chi1*chi2
            chip1=chip(itypi)
            chip2=chip(itypj)
            chip12=chip1*chip2
            alf1=alp(itypi)
            alf2=alp(itypj)
            alf12=0.5D0*(alf1+alf2)
C For diagnostics only!!!
c           chi1=0.0D0
c           chi2=0.0D0
c           chi12=0.0D0
c           chip1=0.0D0
c           chip2=0.0D0
c           chip12=0.0D0
c           alf1=0.0D0
c           alf2=0.0D0
c           alf12=0.0D0
            xj=c(1,nres+j)-xi
            yj=c(2,nres+j)-yi
            zj=c(3,nres+j)-zi
            dxj=dc_norm(1,nres+j)
            dyj=dc_norm(2,nres+j)
            dzj=dc_norm(3,nres+j)
            rrij=1.0D0/(xj*xj+yj*yj+zj*zj)
            rij=dsqrt(rrij)
C Calculate angle-dependent terms of energy and contributions to their
C derivatives.
            call sc_angular
            sigsq=1.0D0/sigsq
            sig=sig0ij*dsqrt(sigsq)
            rij_shift=1.0D0/rij-sig+sig0ij
C I hate to put IF's in the loops, but here don't have another choice!!!!
            if (rij_shift.le.0.0D0) then
              evdw=1.0D20
              return
            endif
            sigder=-sig*sigsq
c---------------------------------------------------------------
            rij_shift=1.0D0/rij_shift 
            fac=rij_shift**expon
            e1=fac*fac*aa(itypi,itypj)
            e2=fac*bb(itypi,itypj)
            evdwij=eps1*eps2rt*eps3rt*(e1+e2)
            eps2der=evdwij*eps3rt
            eps3der=evdwij*eps2rt
            evdwij=evdwij*eps2rt*eps3rt
            evdw=evdw+evdwij
            if (lprn) then
            sigm=dabs(aa(itypi,itypj)/bb(itypi,itypj))**(1.0D0/6.0D0)
            epsi=bb(itypi,itypj)**2/aa(itypi,itypj)
            write (iout,'(2(a3,i3,2x),17(0pf7.3))')
     &        restyp(itypi),i,restyp(itypj),j,
     &        epsi,sigm,chi1,chi2,chip1,chip2,
     &        eps1,eps2rt**2,eps3rt**2,sig,sig0ij,
     &        om1,om2,om12,1.0D0/rij,1.0D0/rij_shift,
     &        evdwij
            endif
C Calculate gradient components.
            e1=e1*eps1*eps2rt**2*eps3rt**2
            fac=-expon*(e1+evdwij)*rij_shift
            sigder=fac*sigder
	    fac=rij*fac
C Calculate the radial part of the gradient
            gg(1)=xj*fac
            gg(2)=yj*fac
            gg(3)=zj*fac
C Calculate angular part of the gradient.
            call sc_grad
          enddo      ! j
        enddo        ! iint
      enddo          ! i
      end
C-----------------------------------------------------------------------------
      subroutine egbv(evdw)
C
C This subroutine calculates the interaction energy of nonbonded side chains
C assuming the Gay-Berne-Vorobjev potential of interaction.
C
      include 'DIMENSIONS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.NAMES'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.CALC'
      common /srutu/ icall
      logical lprn
      evdw=0.0D0
c     print *,'Entering EGB nnt=',nnt,' nct=',nct,' expon=',expon
      evdw=0.0D0
      lprn=.false.
c     if (icall.eq.0) lprn=.true.
      ind=0
      do i=iatsc_s,iatsc_e
        itypi=itype(i)
        itypi1=itype(i+1)
        xi=c(1,nres+i)
        yi=c(2,nres+i)
        zi=c(3,nres+i)
        dxi=dc_norm(1,nres+i)
        dyi=dc_norm(2,nres+i)
        dzi=dc_norm(3,nres+i)
        dsci_inv=dsc_inv(itypi)
C
C Calculate SC interaction energy.
C
        do iint=1,nint_gr(i)
          do j=istart(i,iint),iend(i,iint)
            ind=ind+1
            itypj=itype(j)
            dscj_inv=dsc_inv(itypj)
            sig0ij=sigma(itypi,itypj)
            r0ij=r0(itypi,itypj)
            chi1=chi(itypi,itypj)
            chi2=chi(itypj,itypi)
            chi12=chi1*chi2
            chip1=chip(itypi)
            chip2=chip(itypj)
            chip12=chip1*chip2
            alf1=alp(itypi)
            alf2=alp(itypj)
            alf12=0.5D0*(alf1+alf2)
C For diagnostics only!!!
c           chi1=0.0D0
c           chi2=0.0D0
c           chi12=0.0D0
c           chip1=0.0D0
c           chip2=0.0D0
c           chip12=0.0D0
c           alf1=0.0D0
c           alf2=0.0D0
c           alf12=0.0D0
            xj=c(1,nres+j)-xi
            yj=c(2,nres+j)-yi
            zj=c(3,nres+j)-zi
            dxj=dc_norm(1,nres+j)
            dyj=dc_norm(2,nres+j)
            dzj=dc_norm(3,nres+j)
            rrij=1.0D0/(xj*xj+yj*yj+zj*zj)
            rij=dsqrt(rrij)
C Calculate angle-dependent terms of energy and contributions to their
C derivatives.
            call sc_angular
            sigsq=1.0D0/sigsq
            sig=sig0ij*dsqrt(sigsq)
            rij_shift=1.0D0/rij-sig+r0ij
C I hate to put IF's in the loops, but here don't have another choice!!!!
            if (rij_shift.le.0.0D0) then
              evdw=1.0D20
              return
            endif
            sigder=-sig*sigsq
c---------------------------------------------------------------
            rij_shift=1.0D0/rij_shift 
            fac=rij_shift**expon
            e1=fac*fac*aa(itypi,itypj)
            e2=fac*bb(itypi,itypj)
            evdwij=eps1*eps2rt*eps3rt*(e1+e2)
            eps2der=evdwij*eps3rt
            eps3der=evdwij*eps2rt
            fac_augm=rrij**expon
            e_augm=augm(itypi,itypj)*fac_augm
            evdwij=evdwij*eps2rt*eps3rt
            evdw=evdw+evdwij+e_augm
            if (lprn) then
            sigm=dabs(aa(itypi,itypj)/bb(itypi,itypj))**(1.0D0/6.0D0)
            epsi=bb(itypi,itypj)**2/aa(itypi,itypj)
            write (iout,'(2(a3,i3,2x),17(0pf7.3))')
     &        restyp(itypi),i,restyp(itypj),j,
     &        epsi,sigm,sig,(augm(itypi,itypj)/epsi)**(1.0D0/12.0D0),
     &        chi1,chi2,chip1,chip2,
     &        eps1,eps2rt**2,eps3rt**2,
     &        om1,om2,om12,1.0D0/rij,1.0D0/rij_shift,
     &        evdwij+e_augm
            endif
C Calculate gradient components.
            e1=e1*eps1*eps2rt**2*eps3rt**2
            fac=-expon*(e1+evdwij)*rij_shift
            sigder=fac*sigder
	    fac=rij*fac-2*expon*rrij*e_augm
C Calculate the radial part of the gradient
            gg(1)=xj*fac
            gg(2)=yj*fac
            gg(3)=zj*fac
C Calculate angular part of the gradient.
            call sc_grad
          enddo      ! j
        enddo        ! iint
      enddo          ! i
      end
C-----------------------------------------------------------------------------
      subroutine sc_angular
C Calculate eps1,eps2,eps3,sigma, and parts of their derivatives in om1,om2,
C om12. Called by ebp, egb, and egbv.
      implicit none
      include 'COMMON.CALC'
      erij(1)=xj*rij
      erij(2)=yj*rij
      erij(3)=zj*rij
      om1=dxi*erij(1)+dyi*erij(2)+dzi*erij(3)
      om2=dxj*erij(1)+dyj*erij(2)+dzj*erij(3)
      om12=dxi*dxj+dyi*dyj+dzi*dzj
      chiom12=chi12*om12
C Calculate eps1(om12) and its derivative in om12
      faceps1=1.0D0-om12*chiom12
      faceps1_inv=1.0D0/faceps1
      eps1=dsqrt(faceps1_inv)
C Following variable is eps1*deps1/dom12
      eps1_om12=faceps1_inv*chiom12
C Calculate sigma(om1,om2,om12) and the derivatives of sigma**2 in om1,om2,
C and om12.
      om1om2=om1*om2
      chiom1=chi1*om1
      chiom2=chi2*om2
      facsig=om1*chiom1+om2*chiom2-2.0D0*om1om2*chiom12
      sigsq=1.0D0-facsig*faceps1_inv
      sigsq_om1=(chiom1-chiom12*om2)*faceps1_inv
      sigsq_om2=(chiom2-chiom12*om1)*faceps1_inv
      sigsq_om12=-chi12*(om1om2*faceps1-om12*facsig)*faceps1_inv**2
C Calculate eps2 and its derivatives in om1, om2, and om12.
      chipom1=chip1*om1
      chipom2=chip2*om2
      chipom12=chip12*om12
      facp=1.0D0-om12*chipom12
      facp_inv=1.0D0/facp
      facp1=om1*chipom1+om2*chipom2-2.0D0*om1om2*chipom12
C Following variable is the square root of eps2
      eps2rt=1.0D0-facp1*facp_inv
C Following three variables are the derivatives of the square root of eps
C in om1, om2, and om12.
      eps2rt_om1=-4.0D0*(chipom1-chipom12*om2)*facp_inv
      eps2rt_om2=-4.0D0*(chipom2-chipom12*om1)*facp_inv
      eps2rt_om12=4.0D0*chip12*(om1om2*facp-om12*facp1)*facp_inv**2 
C Evaluate the "asymmetric" factor in the VDW constant, eps3
      eps3rt=1.0D0-alf1*om1+alf2*om2-alf12*om12 
C Calculate whole angle-dependent part of epsilon and contributions
C to its derivatives
      return
      end
C----------------------------------------------------------------------------
      subroutine sc_grad
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.CALC'
      double precision dcosom1(3),dcosom2(3)
      eom1=eps2der*eps2rt_om1-2.0D0*alf1*eps3der+sigder*sigsq_om1
      eom2=eps2der*eps2rt_om2+2.0D0*alf2*eps3der+sigder*sigsq_om2
      eom12=evdwij*eps1_om12+eps2der*eps2rt_om12
     &     -2.0D0*alf12*eps3der+sigder*sigsq_om12
      do k=1,3
        dcosom1(k)=rij*(dc_norm(k,nres+i)-om1*erij(k))
        dcosom2(k)=rij*(dc_norm(k,nres+j)-om2*erij(k))
      enddo
      do k=1,3
        gg(k)=gg(k)+eom1*dcosom1(k)+eom2*dcosom2(k)
      enddo 
      do k=1,3
        gvdwx(k,i)=gvdwx(k,i)-gg(k)
     &            +(eom12*dc_norm(k,nres+j)+eom1*erij(k))*dsci_inv
        gvdwx(k,j)=gvdwx(k,j)+gg(k)
     &            +(eom12*dc_norm(k,nres+i)+eom2*erij(k))*dscj_inv
      enddo
C 
C Calculate the components of the gradient in DC and X
C
      do k=i,j-1
        do l=1,3
          gvdwc(l,k)=gvdwc(l,k)+gg(l)
        enddo
      enddo
      return
      end
C--------------------------------------------------------------------------
      subroutine eelec(ees,evdw1)
C
C This subroutine calculates the average interaction energy and its gradient
C in the virtual-bond vectors between non-adjacent peptide groups, based on 
C the potential described in Liwo et al., Protein Sci., 1993, 2, 1715. 
C The potential depends both on the distance of peptide-group centers and on 
C the orientation of 
C 
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      dimension ggg(3),gggp(3),gggm(3),erij(3),dcosb(3),dcosg(3),
     &          erxij(3,3)
      num_conti_hb=0
      ees=0.0D0
      evdw1=0.0D0
      ind=0
      do i=1,nres
        num_cont_hb(i)=0
      enddo
cd    print '(a)','Enter EELEC'
cd    write (iout,*) 'iatel_s=',iatel_s,' iatel_e=',iatel_e
      do i=iatel_s,iatel_e
	dxi=dc(1,i)
        dyi=dc(2,i)
	dzi=dc(3,i)
        dx_normi=dc_norm(1,i)
        dy_normi=dc_norm(2,i)
        dz_normi=dc_norm(3,i)
        xmedi=c(1,i)+0.5d0*dxi
        ymedi=c(2,i)+0.5d0*dyi
        zmedi=c(3,i)+0.5d0*dzi
        num_conti=0
        do j=ielstart(i),ielend(i)
          ind=ind+1
          iteli=itel(i)
          itelj=itel(j)
          if (j.eq.i+2 .and. itelj.eq.2) iteli=2
          aaa=app(iteli,itelj)
          bbb=bpp(iteli,itelj)
C Diagnostics only!!!
c         aaa=0.0D0
c         bbb=0.0D0
c         ael6i=0.0D0
c         ael3i=0.0D0
C End diagnostics
          ael6i=ael6(iteli,itelj)
          ael3i=ael3(iteli,itelj) 
          dxj=dc(1,j)
          dyj=dc(2,j)
          dzj=dc(3,j)
          dx_normj=dc_norm(1,j)
          dy_normj=dc_norm(2,j)
          dz_normj=dc_norm(3,j)
          xj=c(1,j)+0.5D0*dxj-xmedi
          yj=c(2,j)+0.5D0*dyj-ymedi
          zj=c(3,j)+0.5D0*dzj-zmedi
          rij=xj*xj+yj*yj+zj*zj
          rrmij=1.0D0/rij
          rij=dsqrt(rij)
          rmij=1.0D0/rij
          r3ij=rrmij*rmij
          r6ij=r3ij*r3ij  
          cosa=dx_normi*dx_normj+dy_normi*dy_normj+dz_normi*dz_normj
          cosb=(xj*dx_normi+yj*dy_normi+zj*dz_normi)*rmij
          cosg=(xj*dx_normj+yj*dy_normj+zj*dz_normj)*rmij
          fac=cosa-3.0D0*cosb*cosg
          ev1=aaa*r6ij*r6ij
          ev2=bbb*r6ij
          fac3=ael6i*r6ij
          fac4=ael3i*r3ij
          evdwij=ev1+ev2
          el1=fac3*(4.0D0+fac*fac-3.0D0*(cosb*cosb+cosg*cosg))
          el2=fac4*fac       
          eesij=el1+el2
C 12/26/95 - for the evaluation of multi-body H-bonding interactions
          ees0ij=4.0D0+fac*fac-3.0D0*(cosb*cosb+cosg*cosg)
          ees=ees+eesij
          evdw1=evdw1+evdwij
cd        write(iout,'(2(2i3,2x),7(1pd12.4)/2(3(1pd12.4),5x)/)')
cd   &      iteli,i,itelj,j,aaa,bbb,ael6i,ael3i,
cd   &      1.0D0/dsqrt(rrmij),evdwij,eesij,
cd   &      xmedi,ymedi,zmedi,xj,yj,zj
C
C Calculate contributions to the Cartesian gradient.
C
          facvdw=ev1+evdwij 
          facel=el1+eesij  
	  fac1=fac
          fac=-3*rrmij*(facvdw+facvdw+facel)
          erij(1)=xj*rmij
          erij(2)=yj*rmij
          erij(3)=zj*rmij
*
* Radial derivatives. First process both termini of the fragment (i,j)
* 
          ggg(1)=fac*xj
          ggg(2)=fac*yj
          ggg(3)=fac*zj
	  do k=1,3
	    ghalf=0.5D0*ggg(k)
            gelc(k,i)=gelc(k,i)+ghalf
	    gelc(k,j)=gelc(k,j)+ghalf
          enddo
*
* Loop over residues i+1 thru j-1.
*
          do k=i+1,j-1
	    do l=1,3
	      gelc(l,k)=gelc(l,k)+ggg(l)
            enddo
          enddo
*
* Angular part
*          
          ecosa=2.0D0*fac3*fac1+fac4
          fac4=-3.0D0*fac4
	  fac3=-6.0D0*fac3
          ecosb=(fac3*(fac1*cosg+cosb)+cosg*fac4)
          ecosg=(fac3*(fac1*cosb+cosg)+cosb*fac4)
          do k=1,3
            dcosb(k)=rmij*(dc_norm(k,i)-erij(k)*cosb)
            dcosg(k)=rmij*(dc_norm(k,j)-erij(k)*cosg)
          enddo
cd        print '(2i3,2(3(1pd14.5),3x))',i,j,(dcosb(k),k=1,3),
cd   &          (dcosg(k),k=1,3)
          do k=1,3
            ggg(k)=ecosb*dcosb(k)+ecosg*dcosg(k) 
          enddo
	  do k=1,3
	    ghalf=0.5D0*ggg(k)
            gelc(k,i)=gelc(k,i)+ghalf
     &               +(ecosa*dc_norm(k,j)+ecosb*erij(k))*vblinv
            gelc(k,j)=gelc(k,j)+ghalf
     &               +(ecosa*dc_norm(k,i)+ecosg*erij(k))*vblinv
          enddo
          do k=i+1,j-1
	    do l=1,3
              gelc(l,k)=gelc(l,k)+ggg(l)
	    enddo
          enddo
C Change 12/26/95 to calculate four-body contributions to H-bonding energy
          if (j.gt.i+1 .and. num_conti.le.maxconts) then
C
C Calculate the contact function. The ith column of the array JCONT will 
C contain the numbers of atoms that make contacts with the atom I (of numbers
C greater than I). The arrays FACONT and GACONT will contain the values of
C the contact function and its derivative.
c           r0ij=1.02D0*rpp(iteli,itelj)
c           r0ij=1.11D0*rpp(iteli,itelj)
            r0ij=2.20D0*rpp(iteli,itelj)
c           r0ij=1.55D0*rpp(iteli,itelj)
            call gcont(rij,r0ij,1.0D0,0.2d0*r0ij,fcont,fprimcont)
            if (fcont.gt.0.0D0) then
              num_conti=num_conti+1
              if (num_conti.gt.maxconts) then
                write (iout,*) 'WARNING - max. # of contacts exceeded;',
     &                         ' will skip next contacts for this conf.'
              else

                jcont_hb(num_conti,i)=j
C Calculate contact energies
                cosa4=4.0D0*cosa
                wij=cosa-3.0D0*cosb*cosg
                cosbg1=cosb+cosg
                cosbg2=cosb-cosg
c               fac3=dsqrt(-ael6i)/r0ij**3     
                fac3=dsqrt(-ael6i)*r3ij
                ees0pij=dsqrt(4.0D0+cosa4+wij*wij-3.0D0*cosbg1*cosbg1)
                ees0mij=dsqrt(4.0D0-cosa4+wij*wij-3.0D0*cosbg2*cosbg2)
c               ees0mij=0.0D0
                ees0p(num_conti,i)=0.5D0*fac3*(ees0pij+ees0mij)
                ees0m(num_conti,i)=0.5D0*fac3*(ees0pij-ees0mij)
C Diagnostics. Comment out or remove after debugging!
c               ees0p(num_conti,i)=0.5D0*fac3*ees0pij
c               ees0m(num_conti,i)=0.5D0*fac3*ees0mij
c               ees0m(num_conti,i)=0.0D0
C End diagnostics.
c               write (iout,*) 'i=',i,' j=',j,' rij=',rij,' r0ij=',r0ij,
c    & ' ees0ij=',ees0p(num_conti,i),ees0m(num_conti,i),' fcont=',fcont
C Angular derivatives of the contact function
                ees0pij1=fac3/ees0pij 
                ees0mij1=fac3/ees0mij
                fac3p=-3.0D0*fac3*rrmij
                ees0pijp=0.5D0*fac3p*(ees0pij+ees0mij)
                ees0mijp=0.5D0*fac3p*(ees0pij-ees0mij)
c               ees0mij1=0.0D0
                ecosa1=       ees0pij1*( 1.0D0+0.5D0*wij)
                ecosb1=-1.5D0*ees0pij1*(wij*cosg+cosbg1)
                ecosg1=-1.5D0*ees0pij1*(wij*cosb+cosbg1)
                ecosa2=       ees0mij1*(-1.0D0+0.5D0*wij)
                ecosb2=-1.5D0*ees0mij1*(wij*cosg+cosbg2) 
                ecosg2=-1.5D0*ees0mij1*(wij*cosb-cosbg2)
                ecosap=ecosa1+ecosa2
                ecosbp=ecosb1+ecosb2
                ecosgp=ecosg1+ecosg2
                ecosam=ecosa1-ecosa2
                ecosbm=ecosb1-ecosb2
                ecosgm=ecosg1-ecosg2
C Diagnostics
c               ecosap=ecosa1
c               ecosbp=ecosb1
c               ecosgp=ecosg1
c               ecosam=0.0D0
c               ecosbm=0.0D0
c               ecosgm=0.0D0
C End diagnostics
                facont_hb(num_conti,i)=fcont
                fprimcont=fprimcont/rij
cd              facont_hb(num_conti,i)=1.0D0
C Following line is for diagnostics.
cd              fprimcont=0.0D0
                do k=1,3
                  dcosb(k)=rmij*(dc_norm(k,i)-erij(k)*cosb)
                  dcosg(k)=rmij*(dc_norm(k,j)-erij(k)*cosg)
                enddo
                do k=1,3
                  gggp(k)=ecosbp*dcosb(k)+ecosgp*dcosg(k)
                  gggm(k)=ecosbm*dcosb(k)+ecosgm*dcosg(k)
                enddo
                gggp(1)=gggp(1)+ees0pijp*xj
                gggp(2)=gggp(2)+ees0pijp*yj
                gggp(3)=gggp(3)+ees0pijp*zj
                gggm(1)=gggm(1)+ees0mijp*xj
                gggm(2)=gggm(2)+ees0mijp*yj
                gggm(3)=gggm(3)+ees0mijp*zj
C Derivatives due to the contact function
                gacont_hbr(1,num_conti,i)=fprimcont*xj
                gacont_hbr(2,num_conti,i)=fprimcont*yj
                gacont_hbr(3,num_conti,i)=fprimcont*zj
                do k=1,3
                  ghalfp=0.5D0*gggp(k)
                  ghalfm=0.5D0*gggm(k)
                  gacontp_hb1(k,num_conti,i)=ghalfp
     &                   +(ecosap*dc_norm(k,j)+ecosbp*erij(k))*vblinv
                  gacontp_hb2(k,num_conti,i)=ghalfp
     &                   +(ecosap*dc_norm(k,i)+ecosgp*erij(k))*vblinv
                  gacontp_hb3(k,num_conti,i)=gggp(k)
                  gacontm_hb1(k,num_conti,i)=ghalfm
     &                   +(ecosam*dc_norm(k,j)+ecosbm*erij(k))*vblinv
                  gacontm_hb2(k,num_conti,i)=ghalfm
     &                   +(ecosam*dc_norm(k,i)+ecosgm*erij(k))*vblinv
                  gacontm_hb3(k,num_conti,i)=gggm(k)
                enddo
C Diagnostics. Comment out or remove after debugging!
cdiag           do k=1,3
cdiag             gacontp_hb1(k,num_conti,i)=0.0D0
cdiag             gacontp_hb2(k,num_conti,i)=0.0D0
cdiag             gacontp_hb3(k,num_conti,i)=0.0D0
cdiag             gacontm_hb1(k,num_conti,i)=0.0D0
cdiag             gacontm_hb2(k,num_conti,i)=0.0D0
cdiag             gacontm_hb3(k,num_conti,i)=0.0D0
cdiag           enddo
              endif  ! num_conti.le.maxconts
            endif  ! fcont.gt.0
          endif    ! j.gt.i+2
        enddo ! j
        num_cont_hb(i)=num_conti
      enddo   ! i
      return
      end
C-----------------------------------------------------------------------------
      subroutine escp(evdw2)
C
C This subroutine calculates the excluded-volume interaction energy between
C peptide-group centers and side chains and its gradient in virtual-bond and
C side-chain vectors.
C
      include 'DIMENSIONS'
      include 'COMMON.GEO'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.FFIELD'
      include 'COMMON.IOUNITS'
      dimension ggg(3)
      evdw2=0.0D0
cd    print '(a)','Enter ESCP'
cd    write (iout,*) 'iatscp_s=',iatscp_s,' iatscp_e=',iatscp_e
      do i=iatscp_s,iatscp_e
        iteli=itel(i)
        xi=0.5D0*(c(1,i)+c(1,i+1))
        yi=0.5D0*(c(2,i)+c(2,i+1))
        zi=0.5D0*(c(3,i)+c(3,i+1))

        do iint=1,nscp_gr(i)

        do j=iscpstart(i,iint),iscpend(i,iint)
          itypj=itype(j)
C Uncomment following three lines for SC-p interactions
c         xj=c(1,nres+j)-xi
c         yj=c(2,nres+j)-yi
c         zj=c(3,nres+j)-zi
C Uncomment following three lines for Ca-p interactions
          xj=c(1,j)-xi
          yj=c(2,j)-yi
          zj=c(3,j)-zi
          rrij=1.0D0/(xj*xj+yj*yj+zj*zj)
          fac=rrij**expon2
          e1=fac*fac*aad(itypj,iteli)
          e2=fac*bad(itypj,iteli)
          if (iabs(j-i) .le. 2) then
            e1=scal14*e1
            e2=scal14*e2
          endif
          evdwij=e1+e2
          evdw2=evdw2+evdwij
C
C Calculate contributions to the gradient in the virtual-bond and SC vectors.
C
          fac=-(evdwij+e1)*rrij
          ggg(1)=xj*fac
          ggg(2)=yj*fac
          ggg(3)=zj*fac
          if (j.lt.i) then
cd          write (iout,*) 'j<i'
C Uncomment following three lines for SC-p interactions
c           do k=1,3
c             gradx_scp(k,j)=gradx_scp(k,j)+ggg(k)
c           enddo
          else
cd          write (iout,*) 'j>i'
            do k=1,3
              ggg(k)=-ggg(k)
C Uncomment following line for SC-p interactions
c             gradx_scp(k,j)=gradx_scp(k,j)-ggg(k)
            enddo
          endif
	  do k=1,3
	    gvdwc_scp(k,i)=gvdwc_scp(k,i)-0.5D0*ggg(k)
          enddo
          kstart=min0(i+1,j)
          kend=max0(i-1,j-1)
cd        write (iout,*) 'i=',i,' j=',j,' kstart=',kstart,' kend=',kend
cd        write (iout,*) ggg(1),ggg(2),ggg(3)
          do k=kstart,kend
	    do l=1,3
              gvdwc_scp(l,k)=gvdwc_scp(l,k)-ggg(l)
            enddo
          enddo
        enddo

        enddo ! iint
      enddo ! i
      do i=1,nct
        do j=1,3
          gvdwc_scp(j,i)=expon*gvdwc_scp(j,i)
          gradx_scp(j,i)=expon*gradx_scp(j,i)
        enddo
      enddo
C******************************************************************************
C
C                              N O T E !!!
C
C To save time the factor EXPON has been extracted from ALL components
C of GVDWC and GRADX. Remember to multiply them by this factor before further 
C use!
C
C******************************************************************************
      return
      end
C--------------------------------------------------------------------------
      subroutine edis(ehpb)
C 
C Evaluate bridge-strain energy and its gradient in virtual-bond and SC vectors.
C
      include 'DIMENSIONS'
      include 'COMMON.SBRIDGE'
      include 'COMMON.CHAIN'
      include 'COMMON.DERIV'
      include 'COMMON.VAR'
      dimension ggg(3)
      ehpb=0.0D0
      if (link_end.eq.0) return
cd    print *,'edis: nhpb=',nhpb,' fbr=',fbr
      do i=link_start,link_end
C If ihpb(i) and jhpb(i) > NRES, this is a SC-SC distance, otherwise a
C CA-CA distance used in regularization of structure.
	ii=ihpb(i)
	jj=jhpb(i)
C iii and jjj point to the residues for which the distance is assigned.
        if (ii.gt.nres) then
          iii=ii-nres
          jjj=jj-nres 
        else
          iii=ii
          jjj=jj
        endif
C Calculate the distance between the two points and its difference from the
C target distance.
	dd=dist(ii,jj)
        rdis=dd-dhpb(i)
C Get the force constant corresponding to this distance.
        waga=forcon(i)
C Calculate the contribution to energy.
        ehpb=ehpb+waga*rdis*rdis
C
C Evaluate gradient.
C
        fac=waga*rdis/dd
cd      print *,'i=',i,' ii=',ii,' jj=',jj,' dhpb=',dhpb(i),' dd=',dd,
cd   &   ' waga=',waga,' fac=',fac
	do j=1,3
	  ggg(j)=fac*(c(j,jj)-c(j,ii))
        enddo
cd      print '(i3,3(1pe14.5))',i,(ggg(j),j=1,3)
C If this is a SC-SC distace, we need to calculate the contributions to the
C Cartesian gradient in the SC vectors (ghpbx).
        if (iii.lt.ii) then
          do j=1,3
            ghpbx(j,iii)=ghpbx(j,iii)-ggg(j)
            ghpbx(j,jjj)=ghpbx(j,jjj)+ggg(j)
          enddo
        endif
        do j=iii,jjj-1
          do k=1,3
            ghpbc(k,j)=ghpbc(k,j)+ggg(k)
          enddo
        enddo
      enddo
      ehpb=0.5D0*ehpb
      return
      end
C--------------------------------------------------------------------------
      subroutine ebend(etheta)
C
C Evaluate the virtual-bond-angle energy given the virtual-bond dihedral
C angles gamma and its derivatives in consecutive thetas and gammas.
C
      include 'DIMENSIONS'
      include 'COMMON.LOCAL'
      include 'COMMON.GEO'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.IOUNITS'
      include 'COMMON.NAMES'
      include 'COMMON.FFIELD'
      common /calcthet/ term1,term2,termm,diffak,ratak,
     & ak,aktc,termpre,termexp,sigc,sig0i,time11,time12,sigcsq,
     & delthe0,sig0inv,sigtc,sigsqtc,delthec,it
      double precision y(2),z(2)
      delta=0.02d0*pi
      time11=dexp(-2*time)
      time12=1.0d0
      etheta=0.0D0
c     write (*,'(a,i2)') 'EBEND ICG=',icg
      do i=ithet_start,ithet_end
C Zero the energy function and its derivative at 0 or pi.
        call splinthet(theta(i),0.5d0*delta,ss,ssd)
        it=itype(i-1)
        if (i.gt.3) then
          phii=phi(i)
          y(1)=dcos(phii)
          y(2)=dsin(phii)
        else 
          y(1)=0.0D0
          y(2)=0.0D0
        endif
        if (i.lt.nres) then
          phii1=phi(i+1)
          z(1)=dcos(phii1)
          z(2)=dsin(phii1)
        else
          z(1)=0.0D0
          z(2)=0.0D0
        endif  
C Calculate the "mean" value of theta from the part of the distribution
C dependent on the adjacent virtual-bond-valence angles (gamma1 & gamma2).
C In following comments this theta will be referred to as t_c.
        thet_pred_mean=0.0d0
        do k=1,2
          athetk=athet(k,it)
          bthetk=bthet(k,it)
          thet_pred_mean=thet_pred_mean+athetk*y(k)+bthetk*z(k)
        enddo
        dthett=thet_pred_mean*ssd
        thet_pred_mean=thet_pred_mean*ss+a0thet(it)
C Derivatives of the "mean" values in gamma1 and gamma2.
        dthetg1=(-athet(1,it)*y(2)+athet(2,it)*y(1))*ss
        dthetg2=(-bthet(1,it)*z(2)+bthet(2,it)*z(1))*ss
        if (theta(i).gt.pi-delta) then
          call theteng(pi-delta,thet_pred_mean,theta0(it),f0,fprim0,
     &         E_tc0)
          call mixder(pi-delta,thet_pred_mean,theta0(it),fprim_tc0)
          call theteng(pi,thet_pred_mean,theta0(it),f1,fprim1,E_tc1)
          call spline1(theta(i),pi-delta,delta,f0,f1,fprim0,ethetai,
     &        E_theta)
          call spline2(theta(i),pi-delta,delta,E_tc0,E_tc1,fprim_tc0,
     &        E_tc)
        else if (theta(i).lt.delta) then
          call theteng(delta,thet_pred_mean,theta0(it),f0,fprim0,E_tc0)
          call theteng(0.0d0,thet_pred_mean,theta0(it),f1,fprim1,E_tc1)
          call spline1(theta(i),delta,-delta,f0,f1,fprim0,ethetai,
     &        E_theta)
          call mixder(delta,thet_pred_mean,theta0(it),fprim_tc0)
          call spline2(theta(i),delta,-delta,E_tc0,E_tc1,fprim_tc0,
     &        E_tc)
        else
          call theteng(theta(i),thet_pred_mean,theta0(it),ethetai,
     &        E_theta,E_tc)
        endif
        etheta=etheta+ethetai
        if (i.gt.3) gloc(i-3,icg)=gloc(i-3,icg)+wang*E_tc*dthetg1
        if (i.lt.nres) gloc(i-2,icg)=gloc(i-2,icg)+wang*E_tc*dthetg2
        gloc(nphi+i-2,icg)=wang*(E_theta+E_tc*dthett)
      enddo
C Ufff.... We've done all this!!! 
      return
      end
C---------------------------------------------------------------------------
      subroutine theteng(thetai,thet_pred_mean,theta0i,ethetai,E_theta,
     &     E_tc)
      include 'DIMENSIONS'
      include 'COMMON.LOCAL'
      include 'COMMON.IOUNITS'
      common /calcthet/ term1,term2,termm,diffak,ratak,
     & ak,aktc,termpre,termexp,sigc,sig0i,time11,time12,sigcsq,
     & delthe0,sig0inv,sigtc,sigsqtc,delthec,it
C Calculate the contributions to both Gaussian lobes.
C 6/6/97 - Deform the Gaussians using the factor of 1/(1+time)
C The "polynomial part" of the "standard deviation" of this part of 
C the distribution.
        sig=polthet(3,it)
        do j=2,0,-1
          sig=sig*thet_pred_mean+polthet(j,it)
        enddo
C Derivative of the "interior part" of the "standard deviation of the" 
C gamma-dependent Gaussian lobe in t_c.
        sigtc=3*polthet(3,it)
        do j=2,1,-1
          sigtc=sigtc*thet_pred_mean+j*polthet(j,it)
        enddo
        sigtc=sig*sigtc
C Set the parameters of both Gaussian lobes of the distribution.
C "Standard deviation" of the gamma-dependent Gaussian lobe (sigtc)
        fac=sig*sig+sigc0(it)
        sigcsq=fac+fac
        sigc=1.0D0/sigcsq
C Following variable (sigsqtc) is -(1/2)d[sigma(t_c)**(-2))]/dt_c
        sigsqtc=-4.0D0*sigcsq*sigtc
c       print *,i,sig,sigtc,sigsqtc
C Following variable (sigtc) is d[sigma(t_c)]/dt_c
        sigtc=-sigtc/(fac*fac)
C Following variable is sigma(t_c)**(-2)
        sigcsq=sigcsq*sigcsq
        sig0i=sig0(it)
        sig0inv=1.0D0/sig0i**2
        delthec=thetai-thet_pred_mean
        delthe0=thetai-theta0i
        term1=-0.5D0*sigcsq*delthec*delthec
        term2=-0.5D0*sig0inv*delthe0*delthe0
C Following fuzzy logic is to avoid underflows in dexp and subsequent INFs and
C NaNs in taking the logarithm. We extract the largest exponent which is added
C to the energy (this being the log of the distribution) at the end of energy
C term evaluation for this virtual-bond angle.
        if (term1.gt.term2) then
          termm=term1
          term2=dexp(term2-termm)
          term1=1.0d0
        else
          termm=term2
          term1=dexp(term1-termm)
          term2=1.0d0
        endif
C The ratio between the gamma-independent and gamma-dependent lobes of
C the distribution is a Gaussian function of thet_pred_mean too.
        diffak=gthet(2,it)-thet_pred_mean
        ratak=diffak/gthet(3,it)**2
        ak=dexp(gthet(1,it)-0.5D0*diffak*ratak)
C Let's differentiate it in thet_pred_mean NOW.
        aktc=ak*ratak
C Now put together the distribution terms to make complete distribution.
        termexp=term1+ak*term2
        termpre=sigc+ak*sig0i
C Contribution of the bending energy from this theta is just the -log of
C the sum of the contributions from the two lobes and the pre-exponential
C factor. Simple enough, isn't it?
        ethetai=(-dlog(termexp)-termm+dlog(termpre))
C NOW the derivatives!!!
C 6/6/97 Take into account the deformation.
        E_theta=(delthec*sigcsq*term1
     &       +ak*delthe0*sig0inv*term2)/termexp
        E_tc=((sigtc+aktc*sig0i)/termpre
     &      -((delthec*sigcsq+delthec*delthec*sigsqtc)*term1+
     &       aktc*term2)/termexp)
      return
      end
c-----------------------------------------------------------------------------
      subroutine mixder(thetai,thet_pred_mean,theta0i,E_tc_t)
      include 'DIMENSIONS'
      include 'COMMON.LOCAL'
      include 'COMMON.IOUNITS'
      common /calcthet/ term1,term2,termm,diffak,ratak,
     & ak,aktc,termpre,termexp,sigc,sig0i,time11,time12,sigcsq,
     & delthe0,sig0inv,sigtc,sigsqtc,delthec,it
      delthec=thetai-thet_pred_mean
      delthe0=thetai-theta0i
C "Thank you" to MAPLE (probably spared one day of hand-differentiation).
      t3 = thetai-thet_pred_mean
      t6 = t3**2
      t9 = term1
      t12 = t3*sigcsq
      t14 = t12+t6*sigsqtc
      t16 = 1.0d0
      t21 = thetai-theta0i
      t23 = t21**2
      t26 = term2
      t27 = t21*t26
      t32 = termexp
      t40 = t32**2
      E_tc_t = -((sigcsq+2.D0*t3*sigsqtc)*t9-t14*sigcsq*t3*t16*t9
     & -aktc*sig0inv*t27)/t32+(t14*t9+aktc*t26)/t40
     & *(-t12*t9-ak*sig0inv*t27)
      return
      end
c-----------------------------------------------------------------------------
      subroutine esc(escloc)
C Calculate the local energy of a side chain and its derivatives in the
C corresponding virtual-bond valence angles THETA and the spherical angles 
C ALPHA and OMEGA.
      include 'DIMENSIONS'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.CHAIN'
      include 'COMMON.IOUNITS'
      include 'COMMON.NAMES'
      include 'COMMON.FFIELD'
      double precision x(3),dersc(3),xemp(3),dersc0(3),dersc1(3),
     &     ddersc0(3),ddummy(3),xtemp(3),temp(3)
      common /sccalc/ time11,time12,time112,theti,it,nlobit
      delta=0.02d0*pi
      escloc=0.0D0
c     write (iout,'(a)') 'ESC'
      do i=loc_start,loc_end
        it=itype(i)
        if (it.eq.10) goto 1
        nlobit=nlob(it)
c       print *,'i=',i,' it=',it,' nlobit=',nlobit
c       write (iout,*) 'i=',i,' ssa=',ssa,' ssad=',ssad
        theti=theta(i+1)-pipol
        x(1)=dtan(theti)
        x(2)=alph(i)
        x(3)=omeg(i)

        if (x(2).gt.pi-delta) then
          xtemp(1)=x(1)
          xtemp(2)=pi-delta
          xtemp(3)=x(3)
          call enesc(xtemp,escloci0,dersc0,ddersc0,.true.)
          xtemp(2)=pi
          call enesc(xtemp,escloci1,dersc1,ddummy,.false.)
          call spline1(x(2),pi-delta,delta,escloci0,escloci1,dersc0(2),
     &        escloci,dersc(2))
          call spline2(x(2),pi-delta,delta,dersc0(1),dersc1(1),
     &        ddersc0(1),dersc(1))
          call spline2(x(2),pi-delta,delta,dersc0(3),dersc1(3),
     &        ddersc0(3),dersc(3))
          xtemp(2)=pi-delta
          call enesc_bound(xtemp,esclocbi0,dersc0,dersc12,.true.)
          xtemp(2)=pi
          call enesc_bound(xtemp,esclocbi1,dersc1,chuju,.false.)
          call spline1(x(2),pi-delta,delta,esclocbi0,esclocbi1,
     &            dersc0(2),esclocbi,dersc02)
          call spline2(x(2),pi-delta,delta,dersc0(1),dersc1(1),
     &            dersc12,dersc01)
          call splinthet(x(2),0.5d0*delta,ss,ssd)
          dersc0(1)=dersc01
          dersc0(2)=dersc02
          dersc0(3)=0.0d0
          do k=1,3
            dersc(k)=ss*dersc(k)+(1.0d0-ss)*dersc0(k)
          enddo
          dersc(2)=dersc(2)+ssd*(escloci-esclocbi)
c         write (iout,*) 'i=',i,x(2)*rad2deg,escloci0,escloci,
c    &             esclocbi,ss,ssd
          escloci=ss*escloci+(1.0d0-ss)*esclocbi
c         escloci=esclocbi
c         write (iout,*) escloci
        else if (x(2).lt.delta) then
          xtemp(1)=x(1)
          xtemp(2)=delta
          xtemp(3)=x(3)
          call enesc(xtemp,escloci0,dersc0,ddersc0,.true.)
          xtemp(2)=0.0d0
          call enesc(xtemp,escloci1,dersc1,ddummy,.false.)
          call spline1(x(2),delta,-delta,escloci0,escloci1,dersc0(2),
     &        escloci,dersc(2))
          call spline2(x(2),delta,-delta,dersc0(1),dersc1(1),
     &        ddersc0(1),dersc(1))
          call spline2(x(2),delta,-delta,dersc0(3),dersc1(3),
     &        ddersc0(3),dersc(3))
          xtemp(2)=delta
          call enesc_bound(xtemp,esclocbi0,dersc0,dersc12,.true.)
          xtemp(2)=0.0d0
          call enesc_bound(xtemp,esclocbi1,dersc1,chuju,.false.)
          call spline1(x(2),delta,-delta,esclocbi0,esclocbi1,
     &            dersc0(2),esclocbi,dersc02)
          call spline2(x(2),delta,-delta,dersc0(1),dersc1(1),
     &            dersc12,dersc01)
          dersc0(1)=dersc01
          dersc0(2)=dersc02
          dersc0(3)=0.0d0
          call splinthet(x(2),0.5d0*delta,ss,ssd)
          do k=1,3
            dersc(k)=ss*dersc(k)+(1.0d0-ss)*dersc0(k)
          enddo
          dersc(2)=dersc(2)+ssd*(escloci-esclocbi)
c         write (iout,*) 'i=',i,x(2)*rad2deg,escloci0,escloci,
c    &             esclocbi,ss,ssd
          escloci=ss*escloci+(1.0d0-ss)*esclocbi
c         write (iout,*) escloci
        else
          call enesc(x,escloci,dersc,ddummy,.false.)
        endif

        escloc=escloc+escloci
c       write (iout,*) 'i=',i,' escloci=',escloci,' dersc=',dersc

        gloc(nphi+i-1,icg)=gloc(nphi+i-1,icg)+
     &   wscloc*dersc(1)
        gloc(ialph(i,1),icg)=wscloc*dersc(2)
        gloc(ialph(i,1)+nside,icg)=wscloc*dersc(3)
    1   continue
      enddo
      return
      end
C---------------------------------------------------------------------------
      subroutine enesc(x,escloci,dersc,ddersc,mixed)
      include 'DIMENSIONS'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.IOUNITS'
      common /sccalc/ time11,time12,time112,theti,it,nlobit
      double precision x(3),z(3),Ax(3,maxlob,-1:1),dersc(3),ddersc(3)
      double precision contr(maxlob,-1:1)
      logical mixed
c       write (iout,*) 'it=',it,' nlobit=',nlobit
        escloc_i=0.0D0
        do j=1,3
          dersc(j)=0.0D0
          if (mixed) ddersc(j)=0.0d0
        enddo
        x3=x(3)

C Because of periodicity of the dependence of the SC energy in omega we have
C to add up the contributions from x(3)-2*pi, x(3), and x(3+2*pi).
C To avoid underflows, first compute & store the exponents.

        do iii=-1,1

          x(3)=x3+iii*dwapi
 
          do j=1,nlobit
            do k=1,3
              z(k)=x(k)-censc(k,j,it)
            enddo
            do k=1,3
              Axk=0.0D0
              do l=1,3
                Axk=Axk+gaussc(l,k,j,it)*z(l)
              enddo
              Ax(k,j,iii)=Axk
            enddo 
            expfac=0.0D0 
            do k=1,3
              expfac=expfac+Ax(k,j,iii)*z(k)
            enddo
            contr(j,iii)=expfac
          enddo ! j

        enddo ! iii

        x(3)=x3
C As in the case of ebend, we want to avoid underflows in exponentiation and
C subsequent NaNs and INFs in energy calculation.
C Find the largest exponent
        emin=contr(1,-1)
        do iii=-1,1
          do j=1,nlobit
            if (emin.gt.contr(j,iii)) emin=contr(j,iii)
          enddo 
        enddo
        emin=0.5D0*emin
cd      print *,'it=',it,' emin=',emin

C Compute the contribution to SC energy and derivatives
        do iii=-1,1

          do j=1,nlobit
            expfac=dexp(bsc(j,it)-0.5D0*contr(j,iii)+emin)
cd          print *,'j=',j,' expfac=',expfac
            escloc_i=escloc_i+expfac
            do k=1,3
              dersc(k)=dersc(k)+Ax(k,j,iii)*expfac
            enddo
            if (mixed) then
              do k=1,3,2
                ddersc(k)=ddersc(k)+(-Ax(2,j,iii)*Ax(k,j,iii)
     &            +gaussc(k,2,j,it))*expfac
              enddo
            endif
          enddo

        enddo ! iii

        dersc(1)=dersc(1)/cos(theti)**2
        ddersc(1)=ddersc(1)/cos(theti)**2
        ddersc(3)=ddersc(3)

        escloci=-(dlog(escloc_i)-emin)
        do j=1,3
          dersc(j)=dersc(j)/escloc_i
        enddo
        if (mixed) then
          do j=1,3,2
            ddersc(j)=(ddersc(j)/escloc_i+dersc(2)*dersc(j))
          enddo
        endif
      return
      end
C------------------------------------------------------------------------------
      subroutine enesc_bound(x,escloci,dersc,dersc12,mixed)
      include 'DIMENSIONS'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.IOUNITS'
      common /sccalc/ time11,time12,time112,theti,it,nlobit
      double precision x(3),z(3),Ax(3,maxlob),dersc(3)
      double precision contr(maxlob)
      logical mixed

      escloc_i=0.0D0

      do j=1,3
        dersc(j)=0.0D0
      enddo

      do j=1,nlobit
        do k=1,2
          z(k)=x(k)-censc(k,j,it)
        enddo
        z(3)=dwapi
        do k=1,3
          Axk=0.0D0
          do l=1,3
            Axk=Axk+gaussc(l,k,j,it)*z(l)
          enddo
          Ax(k,j)=Axk
        enddo 
        expfac=0.0D0 
        do k=1,3
          expfac=expfac+Ax(k,j)*z(k)
        enddo
        contr(j)=expfac
      enddo ! j

C As in the case of ebend, we want to avoid underflows in exponentiation and
C subsequent NaNs and INFs in energy calculation.
C Find the largest exponent
      emin=contr(1)
      do j=1,nlobit
        if (emin.gt.contr(j)) emin=contr(j)
      enddo 
      emin=0.5D0*emin
 
C Compute the contribution to SC energy and derivatives

      dersc12=0.0d0
      do j=1,nlobit
        expfac=dexp(bsc(j,it)-0.5D0*contr(j)+emin)
        escloc_i=escloc_i+expfac
        do k=1,2
          dersc(k)=dersc(k)+Ax(k,j)*expfac
        enddo
        if (mixed) dersc12=dersc12+(-Ax(2,j)*Ax(1,j)
     &            +gaussc(1,2,j,it))*expfac
        dersc(3)=0.0d0
      enddo

      dersc(1)=dersc(1)/cos(theti)**2
      dersc12=dersc12/cos(theti)**2
      escloci=-(dlog(escloc_i)-emin)
      do j=1,2
        dersc(j)=dersc(j)/escloc_i
      enddo
      if (mixed) dersc12=(dersc12/escloc_i+dersc(2)*dersc(1))
      return
      end
c------------------------------------------------------------------------------
      subroutine gcont(rij,r0ij,eps0ij,delta,fcont,fprimcont)
C
C This procedure calculates two-body contact function g(rij) and its derivative:
C
C           eps0ij                                     !       x < -1
C g(rij) =  esp0ij*(-0.9375*x+0.625*x**3-0.1875*x**5)  ! -1 =< x =< 1
C            0                                         !       x > 1
C
C where x=(rij-r0ij)/delta
C
C rij - interbody distance, r0ij - contact distance, eps0ij - contact energy
C
      implicit none
      double precision rij,r0ij,eps0ij,fcont,fprimcont
      double precision x,x2,x4,delta
c     delta=0.02D0*r0ij
c      delta=0.2D0*r0ij
      x=(rij-r0ij)/delta
      if (x.lt.-1.0D0) then
        fcont=eps0ij
        fprimcont=0.0D0
      else if (x.le.1.0D0) then  
        x2=x*x
        x4=x2*x2
        fcont=eps0ij*(x*(-0.9375D0+0.6250D0*x2-0.1875D0*x4)+0.5D0)
        fprimcont=eps0ij * (-0.9375D0+1.8750D0*x2-0.9375D0*x4)/delta
      else
        fcont=0.0D0
        fprimcont=0.0D0
      endif
      return
      end
c------------------------------------------------------------------------------
      subroutine splinthet(theti,delta,ss,ssder)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.GEO'
      thetup=pi-delta
      thetlow=delta
      if (theti.gt.pipol) then
        call gcont(theti,thetup,1.0d0,delta,ss,ssder)
      else
        call gcont(-theti,-thetlow,1.0d0,delta,ss,ssder)
        ssder=-ssder
      endif
      return
      end
c------------------------------------------------------------------------------
      subroutine spline1(x,x0,delta,f0,f1,fprim0,f,fprim)
      implicit none
      double precision x,x0,delta,f0,f1,fprim0,f,fprim
      double precision ksi,ksi2,ksi3,a1,a2,a3
      a1=fprim0*delta/(f1-f0)
      a2=3.0d0-2.0d0*a1
      a3=a1-2.0d0
      ksi=(x-x0)/delta
      ksi2=ksi*ksi
      ksi3=ksi2*ksi  
      f=f0+(f1-f0)*ksi*(a1+ksi*(a2+a3*ksi))
      fprim=(f1-f0)/delta*(a1+ksi*(2*a2+3*ksi*a3))
      return
      end
c------------------------------------------------------------------------------
      subroutine spline2(x,x0,delta,f0x,f1x,fprim0x,fx)
      implicit none
      double precision x,x0,delta,f0x,f1x,fprim0x,fx
      double precision ksi,ksi2,ksi3,a1,a2,a3
      ksi=(x-x0)/delta  
      ksi2=ksi*ksi
      ksi3=ksi2*ksi
      a1=fprim0x*delta
      a2=3*(f1x-f0x)-2*fprim0x*delta
      a3=fprim0x*delta-2*(f1x-f0x)
      fx=f0x+a1*ksi+a2*ksi2+a3*ksi3
      return
      end
C-----------------------------------------------------------------------------
      subroutine etor(etors,edihcnstr)
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.GEO'
      include 'COMMON.LOCAL'
      include 'COMMON.TORSION'
      include 'COMMON.INTERACT'
      include 'COMMON.DERIV'
      include 'COMMON.CHAIN'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.FFIELD'
      include 'COMMON.TORCNSTR'
      logical lprn
C Set lprn=.true. for debugging
      lprn=.false.
c     lprn=.true.
      etors=0.0D0
      do i=iphi_start,iphi_end
	itori=itortyp(itype(i-2))
	itori1=itortyp(itype(i-1))
        phii=phi(i)
        gloci=0.0D0
C Proline-Proline pair is a special case...
        if (itori.eq.3 .and. itori1.eq.3) then
          if (phii.gt.-dwapi3) then
            cosphi=dcos(3*phii)
            fac=1.0D0/(1.0D0-cosphi)
            etorsi=v1(1,3,3)*fac
            etorsi=etorsi+etorsi
            etors=etors+etorsi-v1(1,3,3)
            gloci=gloci-3*fac*etorsi*dsin(3*phii)
          endif
          do j=1,3
            v1ij=v1(j+1,itori,itori1)
            v2ij=v2(j+1,itori,itori1)
            cosphi=dcos(j*phii)
            sinphi=dsin(j*phii)
            etors=etors+v1ij*cosphi+v2ij*sinphi+dabs(v1ij)+dabs(v2ij)
            gloci=gloci+j*(v2ij*cosphi-v1ij*sinphi)
          enddo
        else 
          do j=1,nterm
            v1ij=v1(j,itori,itori1)
            v2ij=v2(j,itori,itori1)
            cosphi=dcos(j*phii)
            sinphi=dsin(j*phii)
            etors=etors+v1ij*cosphi+v2ij*sinphi+dabs(v1ij)+dabs(v2ij)
            gloci=gloci+j*(v2ij*cosphi-v1ij*sinphi)
          enddo
        endif
        if (lprn)
     &  write (iout,'(2(a3,2x,i3,2x),2i3,6f8.3/26x,6f8.3/)')
     &  restyp(itype(i-2)),i-2,restyp(itype(i-1)),i-1,itori,itori1,
     &  (v1(j,itori,itori1),j=1,6),(v2(j,itori,itori1),j=1,6)
        gloc(i-3,icg)=gloc(i-3,icg)+wtor*gloci
c       write (iout,*) 'i=',i,' gloc=',gloc(i-3,icg)
      enddo
! 6/20/98 - dihedral angle constraints
      edihcnstr=0.0d0
      do i=1,ndih_constr
        itori=idih_constr(i)
        phii=phi(itori)
        difi=phii-phi0(i)
        if (difi.gt.drange(i)) then
          difi=difi-drange(i)
          edihcnstr=edihcnstr+0.25d0*ftors*difi**4
          gloc(itori-3,icg)=gloc(itori-3,icg)+ftors*difi**3
        else if (difi.lt.-drange(i)) then
          difi=difi+drange(i)
          edihcnstr=edihcnstr+0.25d0*ftors*difi**4
          gloc(itori-3,icg)=gloc(itori-3,icg)+ftors*difi**3
        endif
!        write (iout,'(2i5,2f8.3,2e14.5)') i,itori,rad2deg*phii,
!     &    rad2deg*difi,0.25d0*ftors*difi**4,gloc(itori-3,icg)
      enddo
!      write (iout,*) 'edihcnstr',edihcnstr
      return
      end
c------------------------------------------------------------------------------
      subroutine multibody(ecorr)
C This subroutine calculates multi-body contributions to energy following
C the idea of Skolnick et al. If side chains I and J make a contact and
C at the same time side chains I+1 and J+1 make a contact, an extra 
C contribution equal to sqrt(eps(i,j)*eps(i+1,j+1)) is added.
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      double precision gx(3),gx1(3)
      logical lprn

C Set lprn=.true. for debugging
      lprn=.false.

      if (lprn) then
        write (iout,'(a)') 'Contact function values:'
        do i=nnt,nct-2
          write (iout,'(i2,20(1x,i2,f10.5))') 
     &        i,(jcont(j,i),facont(j,i),j=1,num_cont(i))
        enddo
      endif
      ecorr=0.0D0
      do i=nnt,nct
        do j=1,3
          gradcorr(j,i)=0.0D0
          gradxorr(j,i)=0.0D0
        enddo
      enddo
      do i=nnt,nct-2

        DO ISHIFT = 3,4

        i1=i+ishift
        num_conti=num_cont(i)
        num_conti1=num_cont(i1)
        do jj=1,num_conti
          j=jcont(jj,i)
          do kk=1,num_conti1
            j1=jcont(kk,i1)
            if (j1.eq.j+ishift .or. j1.eq.j-ishift) then
cd          write(iout,*)'i=',i,' j=',j,' i1=',i1,' j1=',j1,
cd   &                   ' ishift=',ishift
C Contacts I--J and I+ISHIFT--J+-ISHIFT1 occur simultaneously. 
C The system gains extra energy.
              ecorr=ecorr+esccorr(i,j,i1,j1,jj,kk)
            endif   ! j1==j+-ishift
          enddo     ! kk  
        enddo       ! jj

        ENDDO ! ISHIFT

      enddo         ! i
      return
      end
c------------------------------------------------------------------------------
      double precision function esccorr(i,j,k,l,jj,kk)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      double precision gx(3),gx1(3)
      logical lprn
      lprn=.false.
      eij=facont(jj,i)
      ekl=facont(kk,k)
cd    write (iout,'(4i5,3f10.5)') i,j,k,l,eij,ekl,-eij*ekl
C Calculate the multi-body contribution to energy.
C Calculate multi-body contributions to the gradient.
cd    write (iout,'(2(2i3,3f10.5))')i,j,(gacont(m,jj,i),m=1,3),
cd   & k,l,(gacont(m,kk,k),m=1,3)
      do m=1,3
        gx(m) =ekl*gacont(m,jj,i)
        gx1(m)=eij*gacont(m,kk,k)
        gradxorr(m,i)=gradxorr(m,i)-gx(m)
        gradxorr(m,j)=gradxorr(m,j)+gx(m)
        gradxorr(m,k)=gradxorr(m,k)-gx1(m)
        gradxorr(m,l)=gradxorr(m,l)+gx1(m)
      enddo
      do m=i,j-1
        do ll=1,3
          gradcorr(ll,m)=gradcorr(ll,m)+gx(ll)
        enddo
      enddo
      do m=k,l-1
        do ll=1,3
          gradcorr(ll,m)=gradcorr(ll,m)+gx1(ll)
        enddo
      enddo 
      esccorr=-eij*ekl
      return
      end
c------------------------------------------------------------------------------
#ifdef MPL
      subroutine pack_buffer(dimen1,dimen2,atom,indx,buffer)
      include 'DIMENSIONS' 
      integer dimen1,dimen2,atom,indx
      double precision buffer(dimen1,dimen2)
      double precision zapas 
      common /contacts_hb/ zapas(3,20,maxres,7),
     &   facont_hb(20,maxres),ees0p(20,maxres),ees0m(20,maxres),
     &         num_cont_hb(maxres),jcont_hb(20,maxres)
      num_kont=num_cont_hb(atom)
      do i=1,num_kont
        do k=1,7
          do j=1,3
            buffer(i,indx+(k-1)*3+j)=zapas(j,i,atom,k)
          enddo ! j
        enddo ! k
        buffer(i,indx+22)=facont_hb(i,atom)
        buffer(i,indx+23)=ees0p(i,atom)
        buffer(i,indx+24)=ees0m(i,atom)
        buffer(i,indx+25)=dfloat(jcont_hb(i,atom))
      enddo ! i
      buffer(1,indx+26)=dfloat(num_kont)
      return
      end
c------------------------------------------------------------------------------
      subroutine unpack_buffer(dimen1,dimen2,atom,indx,buffer)
      include 'DIMENSIONS' 
      integer dimen1,dimen2,atom,indx
      double precision buffer(dimen1,dimen2)
      double precision zapas 
      common /contacts_hb/ zapas(3,20,maxres,7),
     &         facont_hb(20,maxres),ees0p(20,maxres),ees0m(20,maxres),
     &         num_cont_hb(maxres),jcont_hb(20,maxres)
      num_kont=buffer(1,indx+26)
      num_kont_old=num_cont_hb(atom)
      num_cont_hb(atom)=num_kont+num_kont_old
      do i=1,num_kont
        ii=i+num_kont_old
        do k=1,7    
          do j=1,3
            zapas(j,ii,atom,k)=buffer(i,indx+(k-1)*3+j)
          enddo ! j 
        enddo ! k 
        facont_hb(ii,atom)=buffer(i,indx+22)
        ees0p(ii,atom)=buffer(i,indx+23)
        ees0m(ii,atom)=buffer(i,indx+24)
        jcont_hb(ii,atom)=buffer(i,indx+25)
      enddo ! i
      return
      end
c------------------------------------------------------------------------------
#endif
      subroutine multibody_hb(ecorr)
C This subroutine calculates multi-body contributions to hydrogen-bonding 
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.INFO'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
#ifdef MPL
      parameter (max_cont=maxconts)
      parameter (max_dim=2*(8*3+2))
      parameter (msglen1=max_cont*max_dim*4)
      parameter (msglen2=2*msglen1)
      integer source,CorrelType,CorrelID,Error
      double precision buffer(max_cont,max_dim)
#endif
      double precision gx(3),gx1(3)
      logical lprn,ldone

C Set lprn=.true. for debugging
      lprn=.false.
#ifdef MPL
      if (fgProcs.le.1) goto 30
      if (lprn) then
        write (iout,'(a)') 'Contact function values:'
        do i=nnt,nct-2
          write (iout,'(2i3,50(1x,i2))') 
     &    i,num_cont_hb(i),(jcont_hb(j,i),
     &    j=1,num_cont_hb(i))
        enddo
      endif
C Caution! Following code assumes that electrostatic interactions concerning
C a given atom are split among at most two processors!
      CorrelType=477
      CorrelID=MyID+1
      ldone=.false.
      do i=1,max_cont
        do j=1,max_dim
          buffer(i,j)=0.0D0
        enddo
      enddo
      mm=mod(MyRank,2)
cd    write (iout,*) 'MyRank',MyRank,' mm',mm
      if (mm) 20,20,10 
   10 continue
cd    write (iout,*) 'Sending: MyRank',MyRank,' mm',mm,' ldone',ldone
      if (MyRank.gt.0) then
C Send correlation contributions to the preceding processor
        msglen=msglen1
        nn=num_cont_hb(iatel_s)
        call pack_buffer(max_cont,max_dim,iatel_s,0,buffer)
cd      write (iout,*) 'The BUFFER array:'
cd      do i=1,nn
cd        write (iout,'(i2,9(3f8.3,2x))') i,(buffer(i,j),j=1,26)
cd      enddo
        if (ielstart(iatel_s).gt.iatel_s+ispp) then
          msglen=msglen2
            call pack_buffer(max_cont,max_dim,iatel_s+1,26,buffer)
C Clear the contacts of the atom passed to the neighboring processor
        nn=num_cont_hb(iatel_s+1)
cd      do i=1,nn
cd        write (iout,'(i2,9(3f8.3,2x))') i,(buffer(i,j+26),j=1,26)
cd      enddo
            num_cont_hb(iatel_s)=0
        endif 
cd      write (iout,*) 'Processor ',MyID,MyRank,
cd   & ' is sending correlation contribution to processor',MyID-1,
cd   & ' msglen=',msglen
cd      write (*,*) 'Processor ',MyID,MyRank,
cd   & ' is sending correlation contribution to processor',MyID-1,
cd   & ' msglen=',msglen,' CorrelType=',CorrelType
        call mp_bsend(buffer,msglen,MyID-1,CorrelType,CorrelID)
cd      write (iout,*) 'Processor ',MyID,
cd   & ' has sent correlation contribution to processor',MyID-1,
cd   & ' msglen=',msglen,' CorrelID=',CorrelID
cd      write (*,*) 'Processor ',MyID,
cd   & ' has sent correlation contribution to processor',MyID-1,
cd   & ' msglen=',msglen,' CorrelID=',CorrelID
        msglen=msglen1
      endif ! (MyRank.gt.0)
      if (ldone) goto 30
      ldone=.true.
   20 continue
cd    write (iout,*) 'Receiving: MyRank',MyRank,' mm',mm,' ldone',ldone
      if (MyRank.lt.fgProcs-1) then
C Receive correlation contributions from the next processor
        msglen=msglen1
        if (ielend(iatel_e).lt.nct-1) msglen=msglen2
cd      write (iout,*) 'Processor',MyID,
cd   & ' is receiving correlation contribution from processor',MyID+1,
cd   & ' msglen=',msglen,' CorrelType=',CorrelType
cd      write (*,*) 'Processor',MyID,
cd   & ' is receiving correlation contribution from processor',MyID+1,
cd   & ' msglen=',msglen,' CorrelType=',CorrelType
        nbytes=-1
        do while (nbytes.le.0)
          call mp_probe(MyID+1,CorrelType,nbytes)
        enddo
cd      print *,'Processor',MyID,' msglen',msglen,' nbytes',nbytes
        call mp_brecv(buffer,msglen,MyID+1,CorrelType,nbytes)
cd      write (iout,*) 'Processor',MyID,
cd   & ' has received correlation contribution from processor',MyID+1,
cd   & ' msglen=',msglen,' nbytes=',nbytes
cd      write (iout,*) 'The received BUFFER array:'
cd      do i=1,max_cont
cd        write (iout,'(i2,9(3f8.3,2x))') i,(buffer(i,j),j=1,52)
cd      enddo
        if (msglen.eq.msglen1) then
          call unpack_buffer(max_cont,max_dim,iatel_e+1,0,buffer)
        else if (msglen.eq.msglen2)  then
          call unpack_buffer(max_cont,max_dim,iatel_e,0,buffer) 
          call unpack_buffer(max_cont,max_dim,iatel_e+1,26,buffer) 
        else
          write (iout,*) 
     & 'ERROR!!!! message length changed while processing correlations.'
          write (*,*) 
     & 'ERROR!!!! message length changed while processing correlations.'
          call mp_stopall(Error)
        endif ! msglen.eq.msglen1
      endif ! MyRank.lt.fgProcs-1
      if (ldone) goto 30
      ldone=.true.
      goto 10
   30 continue
#endif
      if (lprn) then
        write (iout,'(a)') 'Contact function values:'
        do i=nnt,nct-2
          write (iout,'(2i3,50(1x,i2))') 
     &    i,num_cont_hb(i),(jcont_hb(j,i),
     &    j=1,num_cont_hb(i))
        enddo
      endif
      ecorr=0.0D0
C Remove the loop below after debugging !!!
      do i=nnt,nct
        do j=1,3
          gradcorr(j,i)=0.0D0
          gradxorr(j,i)=0.0D0
        enddo
      enddo
      do i=iatel_s,iatel_e+1
        i1=i+1
        num_conti=num_cont_hb(i)
        num_conti1=num_cont_hb(i+1)
        do jj=1,num_conti
          j=jcont_hb(jj,i)
          do kk=1,num_conti1
            j1=jcont_hb(kk,i1)
c           write (iout,*) 'i=',i,' j=',j,' i1=',i1,' j1=',j1,
c    &         ' jj=',jj,' kk=',kk
            if (j1.eq.j+1 .or. j1.eq.j-1) then
C Contacts I-J and (I+1)-(J+1) or (I+1)-(J-1) occur simultaneously. 
C The system gains extra energy.
              ecorr=ecorr+ehbcorr(i,j,i+1,j1,jj,kk,0.72D0,0.32D0)
c             ecorr=ecorr+ehbcorr(i,j,i+1,j1,jj,kk,0.36D0,0.18D0)
            else if (j1.eq.j) then
C Contacts I-J and I-(J+1) occur simultaneously. 
C The system loses extra energy.
c             ecorr=ecorr+ehbcorr(i,j,i+1,j,jj,kk,0.60D0,-0.40D0) 
            endif
          enddo ! kk
          do kk=1,num_conti
            j1=jcont_hb(kk,i)
c           write (iout,*) 'i=',i,' j=',j,' i1=',i1,' j1=',j1,
c    &         ' jj=',jj,' kk=',kk
            if (j1.eq.j+1) then
C Contacts I-J and (I+1)-J occur simultaneously. 
C The system loses extra energy.
c             ecorr=ecorr+ehbcorr(i,j,i,j+1,jj,kk,0.60D0,-0.40D0)
            endif ! j1==j+1
          enddo ! kk
        enddo ! jj
      enddo ! i
      return
      end
c------------------------------------------------------------------------------
      double precision function ehbcorr(i,j,k,l,jj,kk,coeffp,coeffm)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      double precision gx(3),gx1(3)
      logical lprn
      lprn=.false.
      eij=facont_hb(jj,i)
      ekl=facont_hb(kk,k)
      ees0pij=ees0p(jj,i)
      ees0pkl=ees0p(kk,k)
      ees0mij=ees0m(jj,i)
      ees0mkl=ees0m(kk,k)
      ekont=eij*ekl
      ees=-(coeffp*ees0pij*ees0pkl+coeffm*ees0mij*ees0mkl)
cd    ees=-(coeffp*ees0pkl+coeffm*ees0mkl)
C Following 4 lines for diagnostics.
cd    ees0pkl=0.0D0
cd    ees0pij=1.0D0
cd    ees0mkl=0.0D0
cd    ees0mij=1.0D0
c     write (iout,*)'Contacts have occurred for peptide groups',i,j,
c    &   ' and',k,l
c     write (iout,*)'Contacts have occurred for peptide groups',
c    &  i,j,' fcont:',eij,' eij',' eesij',ees0pij,ees0mij,' and ',k,l
c    & ,' fcont ',ekl,' eeskl',ees0pkl,ees0mkl,' ees=',ees
C Calculate the multi-body contribution to energy.
      ecorr=ecorr+ekont*ees
C Calculate multi-body contributions to the gradient.
      do ll=1,3
        ghalf=0.5D0*ees*ekl*gacont_hbr(ll,jj,i)
        gradcorr(ll,i)=gradcorr(ll,i)+ghalf
     &  -ekont*(coeffp*ees0pkl*gacontp_hb1(ll,jj,i)+
     &  coeffm*ees0mkl*gacontm_hb1(ll,jj,i))
        gradcorr(ll,j)=gradcorr(ll,j)+ghalf
     &  -ekont*(coeffp*ees0pkl*gacontp_hb2(ll,jj,i)+
     &  coeffm*ees0mkl*gacontm_hb2(ll,jj,i))
        ghalf=0.5D0*ees*eij*gacont_hbr(ll,kk,k)
        gradcorr(ll,k)=gradcorr(ll,k)+ghalf
     &  -ekont*(coeffp*ees0pij*gacontp_hb1(ll,kk,k)+
     &  coeffm*ees0mij*gacontm_hb1(ll,kk,k))
        gradcorr(ll,l)=gradcorr(ll,l)+ghalf
     &  -ekont*(coeffp*ees0pij*gacontp_hb2(ll,kk,k)+
     &  coeffm*ees0mij*gacontm_hb2(ll,kk,k))
      enddo
      do m=i+1,j-1
        do ll=1,3
          gradcorr(ll,m)=gradcorr(ll,m)+
     &     ees*ekl*gacont_hbr(ll,jj,i)-
     &     ekont*(coeffp*ees0pkl*gacontp_hb3(ll,jj,i)+
     &     coeffm*ees0mkl*gacontm_hb3(ll,jj,i))
        enddo
      enddo
      do m=k+1,l-1
        do ll=1,3
          gradcorr(ll,m)=gradcorr(ll,m)+
     &     ees*eij*gacont_hbr(ll,kk,k)-
     &     ekont*(coeffp*ees0pij*gacontp_hb3(ll,kk,k)+
     &     coeffm*ees0mij*gacontm_hb3(ll,kk,k))
        enddo
      enddo 
      ehbcorr=ekont*ees
      return
      end
