      subroutine minim(maxf,maxi)
c  controls minimization and sorting routines
      include 'DIMENSIONS'
      parameter (liv=60,lv=(77+maxvar*(maxvar+17)/2)) 
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'COMMON.MINIM'
      include 'mpif.h'
      external func,gradient,fdum
      real ran1,ran2,ran3
      include 'COMMON.SETUP'
      include 'COMMON.GEO'
      dimension muster(mpi_status_size)
      dimension var(maxvar),erg(mxch*(mxch+1)/2+1)
      double precision d(maxvar),v(1:lv+1),garbage(maxvar)                     
      dimension indx(3)
      dimension iv(liv)                                               
      dimension idum(1),rdum(1)
      data rad /1.745329252d-2/
c  receive # of start
!      print *,'Processor',me,' calling MINIM_JLEE maxfun',maxfun,
!     &   ' maxmin',maxmin,' tolf',tolf,' rtolf',rtolf
   10 call mpi_recv(n,1,mpi_integer,king,idint,mpi_comm_world,
     *              muster,ierr)
      if (ierr.ne.0) go to 100
c  if # = 0, return
      if (n.eq.0) return
c  receive initial values of variables
      call mpi_recv(var,nvar,mpi_double_precision,
     *              king,idreal,mpi_comm_world,muster,ierr)
      if (ierr.ne.0) go to 100

!      write (iout,*) 'MINIM_JLEE: Processor',me,' nvar',nvar
!      write (iout,'(8f10.4)') (var(i),i=1,nvar)
!      write (*,*) 'MINIM_JLEE: Processor',me,' nvar',nvar
!      write (*,'(8f10.4)') (var(i),i=1,nvar)
C AL -------
       do i=nphi+ntheta+1,nphi+ntheta+nside
! Check the side chain "valence" angles alpha
         if (var(i).lt.1.0d-7) then 
           write (iout,*) 'CHUJ NASTAPIL ABSOLUTNY!!!!!!!!!!!!'
           write (iout,*) 'Processor',me,'received bad variables!!!!'
           write (iout,*) 'Variables'
           write (iout,'(8f10.4)') (rad2deg*var(j),j=1,nvar)
           write (iout,*) 'Continuing calculations at this point',
     & ' could destroy the results obtained so far... ABORTING!!!!!!'
           write (*,*) 'CHUJ NASTAPIL ABSOLUTNY!!!!!!!!!!!!'
           write (*,*) 'Processor',me,'received bad variables!!!!'
           write (*,*) 'Variables'
           write (*,'(8f10.4)') (rad2deg*var(j),j=1,nvar)
           write (*,*) 'Continuing calculations at this point',
     & ' could destroy the results obtained so far... ABORTING!!!!!!'
           call mpi_abort(mpi_comm_world,ierrcode)
           v(10)=1.0d10
           nf=0
           iv(1)=6
           goto 201
         endif
       enddo
! Check the backbone "valence" angles theta
       do i=nphi+1,nphi+ntheta
         if (var(i).lt.1.0d-7) then
           write (iout,*) 'CHUJ NASTAPIL ABSOLUTNY!!!!!!!!!!!!'
           write (iout,*) 'Processor',me,'received bad variables!!!!'
           write (iout,*) 'Variables'
           write (iout,'(8f10.4)') (rad2deg*var(j),j=1,nvar)
           write (iout,*) 'Continuing calculations at this point',
     & ' could destroy the results obtained so far... ABORTING!!!!!!'
           write (*,*) 'CHUJ NASTAPIL ABSOLUTNY!!!!!!!!!!!!'
           write (*,*) 'Processor',me,'received bad variables!!!!'
           write (*,*) 'Variables'
           write (*,'(8f10.4)') (rad2deg*var(j),j=1,nvar)
           write (*,*) 'Continuing calculations at this point',
     & ' could destroy the results obtained so far... ABORTING!!!!!!'
           call mpi_abort(mpi_comm_world,ierrcode)
           v(10)=1.0d10
           nf=0
           iv(1)=6
           goto 201
         endif
       enddo

       do i=1,nvar
         garbage(i)=var(i)
       enddo

      call deflt(2,iv,liv,lv,v)                                         
* 12 means fresh start, dont call deflt                                 
      iv(1)=12                                                          
* max num of fun calls                                                  
      if (maxfun.eq.0) maxfun=500
      iv(17)=maxfun
* max num of iterations                                                 
      if (maxmin.eq.0) maxmin=1000
      iv(18)=maxmin
* controls output                                                       
      iv(19)=2                                                          
* selects output unit                                                   
c     iv(21)=iout                                                       
      iv(21)=0
* 1 means to print out result                                           
      iv(22)=0                                                          
* 1 means to print out summary stats                                    
      iv(23)=0                                                          
* 1 means to print initial x and d                                      
      iv(24)=0                                                          
* min val for v(radfac) default is 0.1                                  
      v(24)=0.1D0                                                       
* max val for v(radfac) default is 4.0                                  
      v(25)=2.0D0                                                       
c     v(25)=4.0D0                                                       
* check false conv if (act fnctn decrease) .lt. v(26)*(exp decrease)    
* the sumsl default is 0.1                                              
      v(26)=0.1D0
* false conv if (act fnctn decrease) .lt. v(34)                         
* the sumsl default is 100*machep                                       
      v(34)=v(34)/100.0D0                                               
* absolute convergence                                                  
      if (tolf.eq.0.0D0) tolf=1.0D-4
      v(31)=tolf
* relative convergence                                                  
      if (rtolf.eq.0.0D0) rtolf=1.0D-4
      v(32)=rtolf
* controls initial step size                                            
       v(35)=1.0D-1                                                    
* large vals of d correspond to small components of step                
      do i=1,nphi
        d(i)=1.0D-1
      enddo
      do i=nphi+1,nvar
        d(i)=1.0D-1
      enddo
c  minimize energy
!      write (iout,*) 'Processor',me,' nvar',nvar
!      write (iout,*) 'Variables BEFORE minimization:'
!      write (iout,'(8f10.4)') (rad2deg*var(i),i=1,nvar)
      call sumsl(nvar,d,var,func,gradient,iv,liv,lv,v,idum,rdum,fdum)
c  find which conformation was returned from sumsl
        nf=iv(7)
!      print *,'Processor',me,' iv(17)',iv(17),' iv(18)',iv(18),' nf',nf,
!     & ' retcode',iv(1),' energy',v(10),' tolf',v(31),' rtolf',v(32)
        if (iv(1).ne.4 .or. nf.le.1) then
          write (*,*) 'Processor',me,' something bad in SUMSL',iv(1),nf
c         write (*,*) 'Initial Variables'
c         write (*,'(8f10.4)') (rad2deg*garbage(i),i=1,nvar)
c         write (*,*) 'Variables'
c         write (*,'(8f10.4)') (rad2deg*var(i),i=1,nvar)
c         write (*,*) 'Vector d'
c         write (*,'(8f10.4)') (d(i),i=1,nvar)
c         write (iout,*) 'Processor',me,' something bad in SUMSL',
c    &       iv(1),nf
c         write (iout,*) 'Initial Variables'
c         write (iout,'(8f10.4)') (rad2deg*garbage(i),i=1,nvar)
c         write (iout,*) 'Variables'
c         write (iout,'(8f10.4)') (rad2deg*var(i),i=1,nvar)
c         write (iout,*) 'Vector d'
c         write (iout,'(8f10.4)') (d(i),i=1,nvar)
        endif
        if (nf.lt.iv(6)-1) then
c  recalculate intra- and interchain energies
         call func(nvar,var,nf,v(10),iv,v,fdum)
        else if (nf.eq.iv(6)-1) then
c  regenerate conformation
         call var_to_geom(nvar,var)
         call chainbuild
        endif
c  change origin and axes to standard ECEPP format
        call var_to_geom(nvar,var)
!      write (iout,*) 'MINIM_JLEE after minim: Processor',me,' nvar',nvar
!      write (iout,'(8f10.4)') (var(i),i=1,nvar)
!      write (iout,*) 'Energy:',v(10)
c  send back output
  201  continue
        indx(1)=n
c return code: 6-gradient 9-number of ftn evaluation, etc
        indx(2)=iv(1)
c total # of ftn evaluations (for iwf=0, it includes all minimizations).
        indx(3)=nf
        call mpi_isend(indx,3,mpi_integer,king,idint,mpi_comm_world,
     *                 mid,ierr)
        if (ierr.ne.0) go to 200
        call mpi_wait(mid,muster,ierr)
        if (ierr.ne.0) go to 300
c  send back energies
        erg(1)=v(10)
        j=1
        call mpi_isend(erg,j,mpi_double_precision,king,idreal,
     *                 mpi_comm_world,mid,ierr)
        if (ierr.ne.0) go to 200
        call mpi_wait(mid,muster,ierr)
        if (ierr.ne.0) go to 300
c  send back values of variables
        call mpi_isend(var,nvar,mpi_double_precision,
     *               king,idreal,mpi_comm_world,mid,ierr)
        if (ierr.ne.0) go to 200
        call mpi_wait(mid,muster,ierr)
        if (ierr.ne.0) go to 300
        go to 10
  100 print *, ' error in receiving message from emperor'
      call mpi_abort(mpi_comm_world,ierrcode)
      return
  200 print *, ' error in sending message to emperor'
      call mpi_abort(mpi_comm_world,ierrcode)
      return
  300 print *, ' error in communicating with emperor'
      call mpi_abort(mpi_comm_world,ierrcode)
      return
  956 format (' initial energy could not be calculated',41x)
  957 format (80x)
  965 format (' convergence code ',i2,' # of function calls ',
     *  i4,' # of gradient calls ',i4,10x)
  975 format (' energy ',1p,e12.4,' scaled gradient ',e11.3,32x)
      end
