      subroutine thread_seq
C Thread the sequence through a database of known structures
      include 'DIMENSIONS'
      include 'COMMON.CONTROL'
      include 'COMMON.CHAIN'
      include 'COMMON.DBASE'
      include 'COMMON.INTERACT'
      include 'COMMON.VAR'
      include 'COMMON.THREAD'
      include 'COMMON.SBRIDGE'
      include 'COMMON.HEADER'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.TIME1'
      include 'COMMON.CONTACTS'
      include 'COMMON.MCM'
#ifdef MPL
      include 'COMMON.INFO'
      integer ThreadId,ThreadType,Kwita
#endif
      double precision varia(maxvar)
      double precision przes(3),obrot(3,3)
      double precision time_for_thread
      logical found_pattern,non_conv
      character*32 head_pdb
C   
C Body
C
#ifdef MPL
      if (MyID.eq.MasterID) then
        do i=1,nctasks
          nsave_part(i)=0
        enddo
      endif
      nacc_tot=0
#endif
      Kwita=0
      close(igeom)
      close(ipdb)
      close(istat)
      do i=1,maxthread
        do j=1,10
          ener0(j,i)=0.0D0
          ener(j,i)=0.0D0
        enddo
      enddo
      nres0=nct-nnt+1
      ave_time_for_thread=0.0D0
      max_time_for_thread=0.0D0
cd    print *,'nthread=',nthread,' nseq=',nseq,' nres0=',nres0
      nthread=nexcl+nthread
      do ithread=1,nthread
        found_pattern=.false.
        itrial=0
        do while (.not.found_pattern)
          itrial=itrial+1
          if (itrial.gt.1000) then
            write (iout,'(/a/)') 'Too many attempts to find pattern.'
            nthread=ithread-1
#ifdef MPL
            call recv_stop_sig(Kwita)
            call send_stop_sig(-3)
#endif
            goto 777
          endif
C Find long enough chain in the database
          ii=iran_num(1,nseq)
          nres_t=nres_base(1,ii)
C Select the starting position to thread.
cd        print *,'ii=',ii,' nres_t=',nres_t,' nres0=',nres0
          if (nres_t.ge.nres0) then
            ist=iran_num(0,nres_t-nres0)
#ifdef MPL
            if (Kwita.eq.0) call recv_stop_sig(Kwita)
            if (Kwita.lt.0) then 
              write (iout,*) 'Stop signal received. Terminating.'
              write (*,*) 'Stop signal received. Terminating.'
              nthread=ithread-1
              write (*,*) 'ithread=',ithread,' nthread=',nthread
              goto 777
            endif
            call pattern_receive
#endif
            do i=1,nexcl
              if (iexam(1,i).eq.ii .and. iexam(2,i).eq.ist) goto 10
            enddo
            found_pattern=.true.
          endif
C If this point is reached, the pattern has not yet been examined.
   10     continue
c         print *,'found_pattern:',found_pattern
        enddo 
        nexcl=nexcl+1
        iexam(1,nexcl)=ii
        iexam(2,nexcl)=ist
#ifdef MPL
        if (Kwita.eq.0) call recv_stop_sig(Kwita)
        if (Kwita.lt.0) then
          write (iout,*) 'Stop signal received. Terminating.'
          nthread=ithread-1
          write (*,*) 'ithread=',ithread,' nthread=',nthread
          goto 777
        endif
        call pattern_send
#endif
        ipatt(1,ithread)=ii
        ipatt(2,ithread)=ist
#ifdef MPL
        write (iout,'(/80(1h*)/a,i4,a,i5,2a,i3,a,i3,a,i3/)') 
     &   'Processor:',MyID,' Attempt:',ithread,
     &   ' pattern: ',str_nam(ii),nres_base(2,ii),':',nres_base(3,ii),
     &   ' start at res.',ist+1
        write (*,'(a,i4,a,i5,2a,i3,a,i3,a,i3)') 'Processor:',MyID,
     &   ' Attempt:',ithread,
     &   ' pattern: ',str_nam(ii),nres_base(2,ii),':',nres_base(3,ii),
     &   ' start at res.',ist+1
#else
        write (iout,'(/80(1h*)/a,i5,2a,i3,a,i3,a,i3/)') 
     &   'Attempt:',ithread,
     &   ' pattern: ',str_nam(ii),nres_base(2,ii),':',nres_base(3,ii),
     &   ' start at res.',ist+1
        write (*,'(a,i5,2a,i3,a,i3,a,i3)') 
     &   'Attempt:',ithread,
     &   ' pattern: ',str_nam(ii),nres_base(2,ii),':',nres_base(3,ii),
     &   ' start at res.',ist+1
#endif
        ipattern=ii
C Copy coordinates from the database.
        ist=ist-(nnt-1)
        do i=nnt,nct
          do j=1,3
            c(j,i)=cart_base(j,i+ist,ii)
c           cref(j,i)=c(j,i)
          enddo
cd        write (iout,'(a,i4,3f10.5)') restyp(itype(i)),i,(c(j,i),j=1,3)
        enddo
cd      call fitsq(rms,c(1,nnt),cref(1,nnt),nct-nnt+1,przes,obrot,
cd             non_conv) 
cd      write (iout,'(a,f10.5)') 
cd   &  'Initial RMS deviation from reference structure:',rms
        if (itype(nres).eq.21) then
          do j=1,3
            dcj=c(j,nres-2)-c(j,nres-3)
            c(j,nres)=c(j,nres-1)+dcj
            c(j,2*nres)=c(j,nres)
          enddo
        endif
        if (itype(1).eq.21) then
          do j=1,3
            dcj=c(j,4)-c(j,3)
            c(j,1)=c(j,2)-dcj
            c(j,nres+1)=c(j,1)
          enddo
        endif
        call int_from_cart(.false.,.false.)
cd      print *,'Exit INT_FROM_CART.'
cd      print *,'nhpb=',nhpb
        do i=nss+1,nhpb
          ii=ihpb(i)
          jj=jhpb(i)
          dhpb(i)=dist(ii,jj)
c         write (iout,'(2i5,2f10.5)') ihpb(i),jhpb(i),dhpb(i),forcon(i)
        enddo
c       stop 'End generate'
C Generate SC conformations.
        call sc_conf
c       call intout
#ifdef MPL
cd      print *,'Processor:',MyID,': exit GEN_SIDE.'
#else
cd      print *,'Exit GEN_SIDE.'
#endif
C Calculate initial energy.
        call chainbuild
#ifdef MPL
      if (fgProcs.gt.1) then
C Request energy computation from slave processors.
        call geom_to_var(nvar,varia)
        varia(nvar+1)=1
        varia(nvar+2)=-1
        varia(nvar+3)=icg
        call mp_bcast(varia(1),msglen_var,BossID,fgGroupID)
      endif
#endif
        call etotal(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
     &     edihcnstr,ecorr,etot)
c        call enerprint(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
c     &          edihcnstr,ecorr,etot)
        if (refstr) then
          call fitsq(rms1,c(1,nnt),cref(1,nnt),nct-nnt+1,przes,obrot,
     &       non_conv)
          ener0(9,ithread)=dsqrt(rms1)
          call contact(.false.,ncont,icont)
          ener0(10,ithread)=contact_fract(ncont,ncont_ref,icont,
     &        icont_ref)
        endif
        call fitsq(rms,c(1,nnt),cart_base(1,ist+nnt,ipattern),
     &     nct-nnt+1,przes,obrot,non_conv) 
        
        ener0(1,ithread)=evdw
        ener0(2,ithread)=evdw2
        ener0(3,ithread)=ees+evdw1
        ener0(4,ithread)=ecorr
        ener0(5,ithread)=ebe
        ener0(6,ithread)=escloc
        ener0(7,ithread)=etors
        ener0(8,ithread)=etot
        ener0(9,ithread)=dsqrt(rms)
C Minimize energy.
#ifdef MPL
       print*,'Processor:',MyID,' ithread=',ithread,' Start REGULARIZE.'
#else
        print*,'ithread=',ithread,' Start REGULARIZE.'
#endif
        curr_tim=tcpu()
        call regularize(nct-nnt+1,etot,rms,
     &                  cart_base(1,ist+nnt,ipattern),iretcode)  
        curr_tim1=tcpu()
        time_for_thread=curr_tim1-curr_tim 
        ave_time_for_thread=
     &  ((ithread-1)*ave_time_for_thread+time_for_thread)/ithread
        if (time_for_thread.gt.max_time_for_thread)
     &   max_time_for_thread=time_for_thread
#ifdef MPL
        print *,'Processor',MyID,': Exit REGULARIZE.'
        if (WhatsUp.eq.2) then
          write (iout,*) 
     &  'Sufficient number of confs. collected. Terminating.'
          nthread=ithread-1
          goto 777
        else if (WhatsUp.eq.-1) then
          nthread=ithread-1
          write (iout,*) 'Time up in REGULARIZE. Call SEND_STOP_SIG.'
          if (Kwita.eq.0) call recv_stop_sig(Kwita)
          call send_stop_sig(-2)
          goto 777
        else if (WhatsUp.eq.-2) then
          nthread=ithread-1
          write (iout,*) 'Timeup signal received. Terminating.'
          goto 777
        else if (WhatsUp.eq.-3) then
          nthread=ithread-1
          write (iout,*) 'Error stop signal received. Terminating.'
          goto 777
        endif
#else
        print *,'Exit REGULARIZE.'
        if (iretcode.eq.11) then
          write (iout,'(/a/)') 
     &'******* Allocated time exceeded in SUMSL. The program will stop.'
          nthread=ithread-1
          goto 777
        endif
#endif
        head_pdb=titel(:24)//':'//str_nam(ipattern)
        if (outpdb) call pdbout(etot,head_pdb)
        if (outmol2) call mol2out(etot,head_pdb)
c       call intout
        call briefout(ithread,etot)
        link_end0=link_end
        link_end=min0(link_end,nss)
        write (iout,*) 'link_end=',link_end,' link_end0=',link_end0,
     &                 ' nss=',nss
#ifdef MPL
      if (fgProcs.gt.1) then
C Request energy computation from slave processors.
        call geom_to_var(nvar,varia)
        varia(nvar+1)=1
        varia(nvar+2)=-1
        varia(nvar+3)=icg
        call mp_bcast(varia(1),msglen_var,BossID,fgGroupID)
      endif
#endif
        call etotal(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
     &       edihcnstr,ecorr,etot)
c       call enerprint(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
c    &       edihcnstr,ecorr,etot)
        link_end=link_end0
cd      call chainbuild
cd      call fitsq(rms,c(1,nnt),cref(1,nnt),nct-nnt+1,przes,obrot,non_conv) 
cd      write (iout,'(a,f10.5)') 
cd   &  'RMS deviation from reference structure:',dsqrt(rms)
        ener(1,ithread)=evdw
        ener(2,ithread)=evdw2
        ener(3,ithread)=ees+evdw1
        ener(4,ithread)=ecorr
        ener(5,ithread)=ebe
        ener(6,ithread)=escloc
        ener(7,ithread)=etors
        ener(8,ithread)=etot
        ener(9,ithread)=rms 
        if (refstr) then
          call fitsq(rms1,c(1,nnt),cref(1,nnt),nct-nnt+1,przes,obrot,
     &             non_conv)
          ener(10,ithread)=dsqrt(rms1)
          call contact(.false.,ncont,icont)
          ener(11,ithread)=contact_fract(ncont,ncont_ref,icont,
     &        icont_ref)
        endif
#ifdef AIX
        open(istat,file=statname,position='append')
#else
#ifdef LINUX
       open(istat,file=statname,access='append')
#else
        open(istat,file=statname,status='append')
#endif
#endif
        write (istat,'(i4,2x,a8,i4,8(1pe14.5),2(0pf8.3),f8.5)') 
     &  ithread,str_nam(ipattern),ist+1,(ener(k,ithread),k=1,8),
     &  (ener(k,ithread),k=9,11)
        close (istat)
#ifdef MPL
        if (MyID.eq.MasterID) then
          nacc_tot=nacc_tot+1
          call pattern_receive
          call receive_MCM_info
          if (nacc_tot.ge.nthread) then
            write (iout,*) 
     &     'Sufficient number of conformations collected nacc_tot=',
     &     nacc_tot,'. Stopping other processors and terminating.'
            write (*,*) 
     &     'Sufficient number of conformations collected nacc_tot=',
     &     nacc_tot,'. Stopping other processors and terminating.'
           call recv_stop_sig(Kwita)
           if (Kwita.eq.0) call send_stop_sig(-1) 
           nthread=ithread
           goto 777
          endif
        else
          call send_MCM_info(2)
        endif
#endif
        if (timlim-curr_tim1-safety .lt. max_time_for_thread) then
          write (iout,'(/2a)') 
     & '********** There would be not enough time for another thread. ',
     & 'The program will stop.'
          write (*,'(/2a)') 
     & '********** There would be not enough time for another thread. ',
     & 'The program will stop.'
          write (iout,'(a,1pe14.4/)') 
     &    'Elapsed time for last threading step: ',time_for_thread
          nthread=ithread
#ifdef MPL
          call recv_stop_sig(Kwita)
          call send_stop_sig(-2)
#endif
          goto 777
        else
          curr_tim=curr_tim1 
          write (iout,'(a,1pe14.4)') 
     &    'Elapsed time for this threading step: ',time_for_thread
        endif
#ifdef MPL
        if (Kwita.eq.0) call recv_stop_sig(Kwita)
        if (Kwita.lt.0) then
          write (iout,*) 'Stop signal received. Terminating.'
          write (*,*) 'Stop signal received. Terminating.'
          nthread=ithread
          write (*,*) 'nthread=',nthread,' ithread=',ithread
          goto 777
        endif
#endif
      enddo 
#ifdef MPL
      call send_stop_sig(-1)
#endif
  777 continue
#ifdef MPL
C Any messages left for me?
      call pattern_receive
      if (Kwita.eq.0) call recv_stop_sig(Kwita)
#endif
      call write_thread_summary
#ifdef MPL
      if (MyID.eq.MasterID) then
        Kwita=1
        do while (Kwita.ne.0 .or. nacc_tot.ne.0)
          Kwita=0
          nacc_tot=0
          call recv_stop_sig(Kwita)
          call receive_MCM_info
        enddo
        call receive_thread_results
        call write_thread_summary
      else
        call send_thread_results
      endif
#endif
      return
      end
c--------------------------------------------------------------------------
      subroutine write_thread_summary
C Thread the sequence through a database of known structures
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.DBASE'
      include 'COMMON.INTERACT'
      include 'COMMON.VAR'
      include 'COMMON.THREAD'
      include 'COMMON.SBRIDGE'
      include 'COMMON.HEADER'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.TIME1'
#ifdef MPL
      include 'COMMON.INFO'
#endif
      dimension ip(maxthread)
      write (iout,'(30x,a/)') 
     & '  *********** Summary threading statistics ************'
      write (iout,'(a)') 'Initial energies:'
      write (iout,'(a4,2x,a12,8a14,3a8)') 
     & 'No','seq','EVDW','EVDW2','EES','ECORR','EBE','ESCLOC','ETORS',
     & 'ETOT','RMS','RMSnat','NatCONT' 
C Energy sort patterns
      do i=1,nthread
        ip(i)=i
      enddo
      do i=1,nthread-1
        enet=ener(8,ip(i))
        jj=i
        do j=i+1,nthread
          if (ener(8,ip(j)).lt.enet) then
            jj=j
            enet=ener(8,ip(j))
          endif
        enddo
        if (jj.ne.i) then
          ipj=ip(jj)
          ip(jj)=ip(i)
          ip(i)=ipj
        endif
      enddo
      do ik=1,nthread
        i=ip(ik)
        ii=ipatt(1,i)
        ist=nres_base(2,ii)+ipatt(2,i)
        write (iout,'(i4,2x,a8,i4,8(1pe14.5),2(0pf8.3),f8.5)') 
     &  i,str_nam(ii),ist,(ener0(k,i),k=1,8),(ener0(k,i),k=9,11)
      enddo
      write (iout,'(//a)') 'Final energies:'
      write (iout,'(a4,2x,a12,8a14,3a8)') 
     & 'No','seq','EVDW','EVDW2','EES','ECORR','EBE','ESCLOC','ETORS',
     & 'ETOT','RMS','RMSnat','NatCONT' 
      do ik=1,nthread
        i=ip(ik)
        ii=ipatt(1,i)
        ist=nres_base(2,ii)+ipatt(2,i)
        write (iout,'(i4,2x,a8,i4,8(1pe14.5),2(0pf8.3),f8.5)') 
     &   i,str_nam(ii),ist,(ener(k,i),k=1,8),(ener(k,i),k=9,11)
      enddo
      write (iout,'(/a/)') 'IEXAM array:'
      write (iout,'(i5)') nexcl
      do i=1,nexcl
        write (iout,'(2i5)') iexam(1,i),iexam(2,i)
      enddo
      write (iout,'(/a,1pe14.4/a,1pe14.4/)') 
     & 'Max. time for threading step ',max_time_for_thread,
     & 'Average time for threading step: ',ave_time_for_thread
      return
      end
c----------------------------------------------------------------------------
      subroutine sc_conf
C Sample (hopefully) optimal SC orientations given backcone conformation.
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.DBASE'
      include 'COMMON.INTERACT'
      include 'COMMON.VAR'
      include 'COMMON.THREAD'
      include 'COMMON.SBRIDGE'
      include 'COMMON.HEADER'
      include 'COMMON.GEO'
      include 'COMMON.IOUNITS'
      double precision varia(maxvar)
      common /srutu/ icall
      logical glycine,fail
      maxsample=1000
      link_end0=link_end
      link_end=min0(link_end,nss)
      do i=nnt,nct
        if (itype(i).ne.10) then
cd        print *,'i=',i,' itype=',itype(i),' theta=',theta(i+1)  
          call gen_side(itype(i),theta(i+1),alph(i),omeg(i),fail)
        endif
      enddo
      call chainbuild
#ifdef MPL
      if (fgProcs.gt.1) then
C Request energy computation from slave processors.
        call geom_to_var(nvar,varia)
        varia(nvar+1)=1
        varia(nvar+2)=-1
        varia(nvar+3)=icg
        call mp_bcast(varia(1),msglen_var,BossID,fgGroupID)
      endif
#endif
      call etotal(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,edihcnstr,
     &   ecorr,e0)        
      do isample=1,maxsample
C Choose a non-glycine side chain.
        glycine=.true.
        do while(glycine) 
          ind_sc=iran_num(nnt,nct)
          glycine=(itype(ind_sc).eq.10)
        enddo
        alph0=alph(ind_sc)
        omeg0=omeg(ind_sc)
        call gen_side(itype(ind_sc),theta(ind_sc+1),alph(ind_sc),
     &       omeg(ind_sc),fail)
        call chainbuild
#ifdef MPL
      if (fgProcs.gt.1) then
C Request energy computation from slave processors.
        call geom_to_var(nvar,varia)
        varia(nvar+1)=1
        varia(nvar+2)=-1
        varia(nvar+3)=icg
        call mp_bcast(varia(1),msglen_var,BossID,fgGroupID)
      endif
#endif
        call etotal(evdw,evdw1,evdw2,ees,ebe,escloc,etors,ehpb,
     &      edihcnstr,ecorr,e1)
cd      write (iout,'(a,i5,a,i4,2(a,f8.3),2(a,1pe14.5))') 
cd   &   'Step:',isample,' SC',ind_sc,' alpha',alph(ind_sc)*rad2deg,
cd   &   ' omega',omeg(ind_sc)*rad2deg,' old energy',e0,' new energy',e1
        if (e0.le.e1) then
          alph(ind_sc)=alph0
          omeg(ind_sc)=omeg0 
        else
          e0=e1
        endif
      enddo
      link_end=link_end0
      return
      end
