      Subroutine together
c  feeds tasks for parallel processing
      include 'DIMENSIONS'
      include 'mpif.h'
      real ran1,ran2
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.IOUNITS'
      include 'COMMON.CHAIN'
      include 'COMMON.TIME1'
      include 'COMMON.SETUP'
      real tcpu
      logical ovrtim
      dimension muster(mpi_status_size)
      dimension t100(0:100),indx(mxio)
cccccccccccccccccccccccccccccccccccccccccccccccc
      numch=1
      call csa_read
      if (irestart.gt.2 .or. irestart.lt.0) then
        write (iout,*) 'ERROR in CSA_READ: irestart is ',irestart
        call mpi_abort(mpi_comm_world,ierrcode)
      endif
      call make_array
      ntrial=n1+n2+n3+n6+n5
c ntrial is the number of trial conformations per one seed
      ntry=ntrial*nseed
      ntry=ntry+nseed
c ntry is the total number of trial conformations
c +nseed is to reminimize seed conformations

      if (me.eq.king.and.irestart.eq.0) then
       call initial_write
      endif
      if (me.eq.king.and.irestart.ne.0) then
       call restart_write
      endif

      time=mclock()
      call mpi_gather(time,1,mpi_double_precision,t100(me),1,
     *                mpi_double_precision,0,mpi_comm_world,ierr)
      if(me.eq.king) then
       ttime=0
       do i=0,nodes-1
        ttime=ttime+t100(i)
       enddo
       ttime0=ttime
       t00=t100(me)
      endif

      if(irestart.gt.0) then
       call read_bank(jstart,nft,cutdifr)
      endif

      idum2=-123
      imax=2**31-1
cccccccccccccccccccccccccccccccccccccccc
      do 300 jlee=1,jend
cccccccccccccccccccccccccccccccccccccccc
      idum=-  ran2(idum2)*imax
      if(jlee.lt.jstart) goto 300

C Restart the random number generator for conformation generation
      if(irestart.gt.0) then
       idum2=idum2+nstep
       if(idum2.le.0) idum2=-idum2+1
       idum=-  ran2(idum2)*imax
      endif

      idumm=idum
      call vrndst(idumm)

      if (me.eq.king) then
       open(31,status="old")
        write(31,*) "jlee : ",jlee
       close(31)
#ifdef AIX
       open(32,position="append")
#else
       open(32,access="append")
#endif
        write(32,*) "number of procs is ",nodes
        write(32,*) jlee,idum,idum2
       close(32)
      endif

      nbank=nconf
      nstep=0
      do i=1,mxio
       ibank(i)=0
       jbank(i)=0
      enddo
      nft=0
cccccccccccccccccccccccccccccccccccccccccccccccc
  333 icycle=0
      if(irestart.gt.0) then
       call read_bank(jlee,nft,cutdifr)
       call read_rbank(jlee,adif)
c      print *, 'adif after call read_rbank ',adif
      endif

      if (me.eq.king) then
#ifdef AIX
       open(32,position="append")
#else
       open(32,access="append")
#endif
        write(32,*) "nbank is ",nbank
       close(32)
      endif

      if(irestart.eq.1) goto 111

      if(irestart.eq.2) then
       icycle=0
       do i=1,nbank
        ibank(i)=1
       enddo
       do i=nbank+1,nbank+nconf
        ibank(i)=0
       enddo
      endif

c  start energy minimization
      nconfr=max0(nconf,nodes-1)
      if (me.eq.king) then
c  king-emperor - feed input and sort output
       call make_ranvar(nconfr,idum)
       write (iout,*) 'Exitted from make_ranvar nconf=',nconf
       write (*,*) 'Exitted from make_ranvar nconf=',nconf
!       do m=1,nconf
!          write (iout,*) 'Make_RanVar Conformation',m
!          write(iout,'(8f10.4)') (dihang_in(1,j,1,m),j=2,nres-1)
!          write(iout,'(8f10.4)') (dihang_in(2,j,1,m),j=2,nres-1)
!          write(iout,'(8f10.4)') (dihang_in(3,j,1,m),j=2,nres-1)
!          write(iout,'(8f10.4)') (dihang_in(4,j,1,m),j=2,nres-1)
!       enddo 
!       write(iout,*)'Calling FEEDIN NCONF',nconfr
       call feedin(nconfr,nft)
#ifdef AIX
       open(32,position="append")
#else
       open(32,access="append")
#endif
        write(32,*) jlee,nft,nbank
        write(32,850) (etot(i),i=1,nconfr)
        write(32,*)
       close(32)
      else
c  soldier - perform energy minimization
       call minim
      endif
      nstep=nstep+nconf
      if(irestart.eq.2) nbank=nbank+nconf
ccccccccccccccccccccccccccccccccccc
c need to syncronize all procs
      call mpi_barrier(mpi_comm_world,ierr)
      if (ierr.ne.0) then
       print *, ' cannot syncronize MPI'
       stop
      endif

      call indexx(nconfr,etot,indx)
      do im=1,nconf
       m=indx(im)
       if (m.gt.mxio .or. m.lt.1) then
         write (iout,*) 'Dimension ERROR in TOGEHER: IM',im,' M',m
         call mpi_abort(mpi_comm_world,ierrcode)
       endif
       jbank(im+nbank-nconf)=0
       bene(im+nbank-nconf)=etot(m)
       rene(im+nbank-nconf)=etot(m)
       if (im+nbank-nconf.gt.mxio .or. im+nbank-nconf.lt.1) then
         write (iout,*) 'Dimension ERROR in TOGEHER: IM',im,
     &   ' NBANK',nbank,' NCONF',nconf,' IM+NBANK-NCONF',im+nbank-nconf
         call mpi_abort(mpi_comm_world,ierrcode)
       endif
       do k=1,numch
        do j=2,nres-1
         do i=1,4
          bvar(i,j,k,im+nbank-nconf)=dihang(i,j,k,m)
          rvar(i,j,k,im+nbank-nconf)=dihang(i,j,k,m)
         enddo
        enddo
       enddo
      enddo

  111 continue

      call find_max
      call find_min

      call get_diff
      if(nbank.eq.nconf.and.irestart.eq.0) then
       adif=avedif
      endif

      cutdif=adif/cut1
      ctdif1=adif/cut2

      iterm=1000000
      if(ntrial.eq.0) then
       do i=1,nbank
        ibank(i)=0
        bene(i)=999.99
       enddo
       iterm=1
       nseed=nbank
       ntry=nbank
      else
       nst=ntotal/ntrial/nseed
       xctdif=(cutdif/ctdif1)**(-1.0/nst)
       if(irestart.eq.1) call estimate_cutdif(adif,xctdif,cutdifr)
      endif

      irestart=0

      if (me.eq.king) then
       call write_rbank(jlee,adif,nft)
       call write_bank(jlee,nft)
c      call write_bank1(jlee)
#ifdef AIX
       open(32,position="append")
#else
       open(32,access="append")
#endif
        write(32,*) "xctdif: ", xctdif,nst,adif/cut1,ctdif1
        write(32,850) (bene(i),i=1,nbank)
       close(32)
      endif
  850 format(10f8.3)

      ifar=nseed/4*3+1
      ifar=nseed+1

ccccccccccccccccccccccccccccccccccccccc
      do 100 iter=1,iterm
ccccccccccccccccccccccccccccccccccccccc
        write (iout,'(a,i5,a,e20.10,a,e20.10)') 'Proc',me,
     &        ': E time:',tcpu(),
     &        ' remaining time',(timlim-safety)-tcpu()
c       write (*,'(a,i5,a,e20.10,a,e20.10)') 'Proc',me,
c    &        ': E time:',tcpu(),
c    &        ' remaining time',(timlim-safety)-tcpu()
C Check for messages from other nodes.
C--------------------------------------------------
        finished = .false.
        if (me .eq. king) then
c          print *,'Calling Master_Mail'
          call master_mail(finished)
c          print *,'King: finished:',finished
        endif
c Check time limit
        if (ovrtim()) then
          write (iout,'(80(1h*)/a,i5,a,e20.10,a,e20.10,a/80(1h*))')
     &    'FAJRANT!!! Processor',me,' has already run',
     &    tcpu(),' seconds out of',timlim-safety,' seconds.'
          write (*,'(80(1h*)/a,i5,a,e20.10,a,e20.10,a/80(1h*))')
     &    'FAJRANT!!! Processor',me,' has already run',
     &    tcpu(),' seconds out of',timlim-safety,' seconds.'
          if (me.eq.king) then
             finished = .true.
          else
             write (*, *) me, 'sending  "END" msg to Master '
             call mpi_send(me,1,mpi_integer,king,is_done,                    &
     &        mpi_comm_world,status,ierr)
          endif
          if (ierr.ne.0) print *, ' cannot finish MPI'
        endif
C-------------------------------------------------------------------
C King tells his soldiers to continue or to withdraw
       call mpi_bcast(finished,1,mpi_logical,0,mpi_comm_world,ierr)
c       print *,'After BCAST:',me,' finished',finished
C-------------------------------------------------------------------

c  start energy minimization
       if (me.eq.king) then
        if (finished) then
#ifdef AIX
       open(32,position="append")
#else
       open(32,access="append")
#endif
          write(32,40) jlee,icycle,nstep,cutdif,ibmin,ibmax,
     *    ebmin,ebmax,nft,iuse,nbank
         close(32)
         goto 200
        endif
c  king-emperor - select seeds & make var & feed input
        call select_is(nseed,ifar,idum)
        open(31,status="old")
         write(31,39) jlee,icycle,nstep,(is(i),bene(is(i)),i=1,nseed)
        close(31)
#ifdef AIX
       open(32,position="append")
#else
       open(32,access="append")
#endif
         write(32,40) jlee,icycle,nstep,cutdif,ibmin,ibmax,
     *   ebmin,ebmax,nft,iuse,nbank
        close(32)
        call make_var(ntrial,idum)
        write(iout,*)'1:Calling FEEDIN NTRY',NTRY,' ntrial',ntrial
        call feedin(ntry,nft)
       else
        if (finished) goto 200
c  soldier - perform energy minimization
        call minim
       endif

       nstep=nstep+ntrial*nseed
       cutdif=cutdif*xctdif
       if(cutdif.lt.ctdif1) cutdif=ctdif1

       if (me.eq.king) then
        call refresh_bank(ntry)
        call write_bank(jlee,nft)
        call find_min
       endif

       call mpi_bcast(icycle,1,mpi_integer,0,mpi_comm_world,ierr)
       if (ierr.ne.0) then
        print *, ' cannot initiate MPI'
        stop
       endif
       call mpi_bcast(ebmin,1,mpi_double_precision,0,
     *                mpi_comm_world,ierr)
       if (ierr.ne.0) then
        print *, ' cannot initiate MPI'
        stop
       endif
   39 format(2i3,i7,5(i4,f8.3,1x),19(/,13x,5(i4,f8.3,1x)))
   40 format(2i4,i8,f8.1,2i4,2f8.3,i10,2i5)
   43 format(10i8)
   44 format('jlee =',i3,':',4f10.1,' E =',f8.3,i7,i10)
       if(ebmin.lt.estop) goto 200
       if(icycle.gt.icmax) then
        if (me.eq.king) call write_bank1(jlee)
        do i=1,nbank
         ibank(i)=2
         ibank(i)=1
        enddo
        nbank=nbank+nconf
        if(nbank.gt.500) goto 200
        if(nstep.gt.nstmax) goto 200
        goto 333
       endif
ccccccccccccccccccccccccccccccccccccccc
  100 continue
ccccccccccccccccccccccccccccccccccccccc

  200 continue
      time=mclock()
c     write(6,*) me,time/100
      call mpi_gather(time,1,mpi_double_precision,t100(me),1,
     *                mpi_double_precision,0,mpi_comm_world,ierr)
      if (me.eq.king) then
       ttime=0
       do i=0,nodes-1
        ttime=ttime+t100(i)
       enddo
       ett=ttime-ttime0
       et0=t100(me)-t00
c      call write_bank1(jlee)
c      call write_bank(jlee,nft)
       if (.not. finished) then
#ifdef AIX
       open(32,position="append")
#else
       open(32,access="append")
#endif
        write(32,44) jlee,ttime/100,ett/100,t100(me)/100,et0/100,
     *               ebmin,nstep,nft
        write(32,*)
       close(32)
       endif
      endif

      if (finished) return

cccccccccccccccccccccccccccccc
  300 continue
cccccccccccccccccccccccccccccc

c      call mpi_finalize(ierr)
c      if (ierr.ne.0) print *, ' cannot finish MPI'
      return
      end
c-------------------------------------------------
      subroutine feedin(nconf,nft)
c  sends out starting conformations and receives results of energy minimization
      include 'DIMENSIONS'
      include 'COMMON.VAR'
      include 'COMMON.IOUNITS'
      include 'mpif.h'
      dimension xin(maxvar),xout(maxvar),eout(mxch*(mxch+1)/2+1),
     *          cout(2),ind(3)
      dimension muster(mpi_status_size)
      include 'COMMON.SETUP'
      parameter (rad=1.745329252d-2)

!      print *,'FEEDIN: NCONF=',nconf
      mm=0
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      if (nconf .lt. nodes-1) then
        write (*,*) 'FATAL ERROR in FEEDIN, nconf < nodes -1',
     &   nconf,nodes-1 
        write (iout,*) 'FATAL ERROR in FEEDIN, nconf < nodes -1',
     &   nconf,nodes-1 
        call mpi_abort(mpi_comm_world,ierrcode)
      endif
      do n=1,nconf
c  pull out external and internal variables for next start
        call putx(xin,n,rad)
!        write (iout,*) 'XIN from FEEDIN N=',n
!        write(iout,'(8f10.4)') (xin(j),j=1,nvar)
        mm=mm+1
        if (mm.lt.nodes) then
c  feed task to soldier
c        print *, ' sending input for start # ',n
         call mpi_isend(n,1,mpi_integer,mm,idint,mpi_comm_world,
     *                  mid,ierr)
         if (ierr.ne.0) go to 10
         call mpi_wait(mid,muster,ierr)
         if (ierr.ne.0) go to 20
         call mpi_isend(xin,nvar,mpi_double_precision,mm,
     *                  idreal,mpi_comm_world,mid,ierr)
         if (ierr.ne.0) go to 10
         call mpi_wait(mid,muster,ierr)
         if (ierr.ne.0) go to 20
        else
c  find an available soldier
         call mpi_recv(ind,3,mpi_integer,mpi_any_source,idint,
     *                 mpi_comm_world,muster,ierr)
         if (ierr.ne.0) go to 30
c        print *, ' receiving output from start # ',ind(1)
         man=muster(mpi_source)
c  receive final energies and variables
         nft=nft+ind(3)
         call mpi_recv(eout,1,mpi_double_precision,
     *                 man,idreal,mpi_comm_world,muster,ierr)
         if (ierr.ne.0) go to 30
         call mpi_recv(xout,nvar,mpi_double_precision,
     *                 man,idreal,mpi_comm_world,muster,ierr)
         if (ierr.ne.0) go to 30
c  feed next task to soldier
c        print *, ' sending input for start # ',n
         call mpi_isend(n,1,mpi_integer,man,idint,mpi_comm_world,
     *                  mid,ierr)
         if (ierr.ne.0) go to 10
         call mpi_wait(mid,muster,ierr)
         if (ierr.ne.0) go to 20
         call mpi_isend(xin,nvar,mpi_double_precision,man,
     *                  idreal,mpi_comm_world,mid,ierr)
         if (ierr.ne.0) go to 10
         call mpi_wait(mid,muster,ierr)
         if (ierr.ne.0) go to 20
c  retrieve latest results
         call getx(ind,xout,eout,cout,rad)
        endif
      enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  no more input
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      do j=1,nodes-1
c  wait for a soldier
       call mpi_recv(ind,3,mpi_integer,mpi_any_source,idint,
     *               mpi_comm_world,muster,ierr)
       if (ierr.ne.0) go to 30
c      print *, ' receiving output from start # ',ind(1)
       man=muster(mpi_source)
c  receive final energies and variables
       nft=nft+ind(3)
       call mpi_recv(eout,1,
     *               mpi_double_precision,man,idreal,
     *               mpi_comm_world,muster,ierr)
       if (ierr.ne.0) go to 30
       call mpi_recv(xout,nvar,mpi_double_precision,
     *               man,idreal,mpi_comm_world,muster,ierr)
       if (ierr.ne.0) go to 30
c  halt soldier
       call mpi_isend(0,1,mpi_integer,man,idint,mpi_comm_world,
     *                mid,ierr)
       if (ierr.ne.0) go to 10
       call mpi_wait(mid,muster,ierr)
       if (ierr.ne.0) go to 20
c  retrieve results
       call getx(ind,xout,eout,cout,rad)
      enddo
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      return
   10 print *, ' dispatching error'
      call mpi_abort(mpi_comm_world,ierrcode)
      return
   20 print *, ' communication error'
      call mpi_abort(mpi_comm_world,ierrcode)
      return
   30 print *, ' receiving error'
      call mpi_abort(mpi_comm_world,ierrcode)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getx(ind,xout,eout,cout,rad)
c  receives and stores data from soldiers
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      dimension ind(3),xout(maxvar),eout(mxch*(mxch+1)/2+1)
      k=ind(1)
      if (k.gt.mxio .or. k.lt.1) then 
        write (iout,*) 
     &   'ERROR - dimensions of ANGMIN have been exceeded K=',k
        call mpi_abort(mpi_comm_world,ierrcode)
      endif
c  store energies
      etot(k)=eout(1)
c  retrieve dihedral angles etc
      call var_to_geom(nvar,xout)
      do j=2,nres-1
        dihang(1,j,1,k)=theta(j+1)
        dihang(2,j,1,k)=phi(j+2)
        dihang(3,j,1,k)=alph(j)
        dihang(4,j,1,k)=omeg(j)
      enddo
      dihang(2,nres-1,1,k)=0.0d0
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine putx(xin,n,rad)
c  gets starting variables
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.IOUNITS'
      dimension xin(maxvar)

c  pull out starting values for variables
!       write (iout,*)'PUTX: N=',n
      do m=1,numch
!        write (iout,'(8f10.4)') (dihang_in(1,j,m,n),j=2,nres-1)
!        write (iout,'(8f10.4)') (dihang_in(2,j,m,n),j=2,nres-1)
!        write (iout,'(8f10.4)') (dihang_in(3,j,m,n),j=2,nres-1)
!        write (iout,'(8f10.4)') (dihang_in(4,j,m,n),j=2,nres-1)
       do j=2,nres-1
        theta(j+1)=dihang_in(1,j,m,n)
        phi(j+2)=dihang_in(2,j,m,n)
        alph(j)=dihang_in(3,j,m,n)
        omeg(j)=dihang_in(4,j,m,n)
       enddo
      enddo
c  set up array of variables
      call geom_to_var(nvar,xin)
!       write (iout,*) 'xin in PUTX N=',n 
!       call intout
!       write (iout,'(8f10.4)') (xin(i),i=1,nvar) 
      return
      end
